
#define DATE    "21.4.2000"
#define VERSION "2_0"
#define PATCHED "Std"

/*
 *  For R58 logics P8N and P8E
 *  RF decks:
 *   RB58  64/45.0    S8B
 *   RC58  64/21.4    S8C
 *   RD58 128/86.5125 S8D
 */

/*
 * 2.0 000421 Too many changes here and there to mention specifically.
 */

!----------------------------------------------------------------------

#if P8x + L8M != 1
#error Compilation must choose -DP8x or -DL8M cpu card
#endif

!  Looks like P8E works all right with (unnecessary) P8N saves/restores.

#ifdef P8x
#define P8N
#define P8E
#endif

#ifdef L8M
#error Sorry, L8M missing in action
#endif
!----------------------------------------------------------------------

#define TCXO 12800 /* kHz as all frequencies here */

!----------------------------------------------------------------------
! selectable channel steps (logical, not physical)

#define STEP_25 0
#define STEP_20 1
#define STEP_15 2
#define STEP_12 3
#define STEP_10 4

! RF decks

#define S8D 0
#define S8C 1
#define S8B 2

! datatypes in setup

#define CFG_BYTE    1
#define CFG_WORD    2
#define CFG_FREQ    3
#define CFG_TAB     4
#define CFG_DYN     5
#define CFG_RST     6
#define CFG_STR     7
#define CFG_DPX     8 /* like freq but signed */
#define CFG_cSEC    9 /* like byte but fake 0 at end to show as millisec */
#define CFG_EXE    10

#define EOS 0xFF
!----------------------------------------------------------------------

#define DPX_SIMPLEX 0
#define DPX_DUPLEX  1
#define DPX_REVERSE 2
#define DPX_SPLIT   3

!----------------------------------------------------------------------
!
!	Convenience macros
!
#define SIZE_FREQ 3
#define SIZE_STR  8

#define BUF(n) : .rs n
#define BYTE   : .rs 1
#define WORD   : .rs 2
#define FREQ   : .rs SIZE_FREQ
#define STRING : .rs SIZE_STR

#define srl4 srl a ; srl a ; srl a ; srl a
#define sla4 sla a ; sla a ; sla a ; sla a

#define imm_ahl(I) ld hl, (I) % 65536 ; ld a, (I) / 65536

#define load_ahl(A) ld hl, [A] ; ld a, [(A) + 2]
#define save_ahl(A) ld [A], hl ; ld [(A) + 2], a
#define load_abc(A) ld bc, [A] ; ld a, [(A) + 2]
#define save_abc(A) ld [A], bc ; ld [(A) + 2], a

#define load_ahl_ix_0 ld l, [ix+0]; ld h, [ix+1]; ld a, [ix+2]
#define load_ahl_ix_3 ld l, [ix+3]; ld h, [ix+4]; ld a, [ix+5]
#define save_ahl_ix_0 ld [ix+0], l; ld [ix+1], h; ld [ix+2], a
#define save_ahl_ix_3 ld [ix+3], l; ld [ix+4], h; ld [ix+5], a

#define sub_ahl_immde(I) ld de, (I) % 65536; and a; sbc hl, de; sbc (I) / 65536

#define add_ahl_de(A) ld de, [A]; add hl, de; ld de, [(A) + 2]; adc e;
#define sub_ahl_de(A) ld de, [A]; and a; sbc hl, de; ld de, [(A) + 2]; sbc e;

! from hl to de, bc also mashed

#define ldi_1(_dst) ld de, _dst; ldi
#define ldi_2(_dst) ld de, _dst; ldi; ldi
#define ldi_3(_dst) ld de, _dst; ldi; ldi; ldi
#define ldi_6(_dst) ld de, _dst; ldi; ldi; ldi; ldi; ldi; ldi
#define ldi_7(_dst) ld de, _dst; ldi; ldi; ldi; ldi; ldi; ldi; ldi

#define ldi_10(_dst) ld de, _dst; ldi;ldi;ldi;ldi;ldi;ldi;ldi;ldi;ldi;ldi;

#define segset_hl(_s) ld hl, segments + ((_s) / 8); set (_s) % 8, [hl]
#define segres_hl(_s) ld hl, segments + ((_s) / 8); res (_s) % 8, [hl]

!----------------------------------------------------------------------
!
!	I/O map
!
#define PIO   0x00
#define SIO   0x10
#define TMR   0x20
#define DA0   0x30
#define DA1   0x40
#define AD    0x50
#define OUT0  0x60
#define OUT1  0x70
#define OUT2  0x80
#define WD    0x90
#define MDM   0xA0

#define CSMEM 0xB0	/* P8E SMEM flipflop  */

#define ADATA 0
#define BDATA 1
#define ACTRL 2
#define BCTRL 3

#define TMRCTRL 3

#define AD_RSSI  (AD + 0)
#define AD_SQL   (AD + 1)
#define AD_BATT  (AD + 2)

#define DA_RFC   DA0
#define DA_TXPWR DA1

!----------------------------------------------------------------------
!
!	FX429
!
#define MDMDATA	2
#define MDMCTRL 3

#define MDM_TXENB	0x01
#define MDM_TXPAR	0x02
#define MDM_RXENB	0x04
#define MDM_RXFMT	0x08
#define MDM_TIMER	0xF0

#define MDM_XXX		0x00	/* Nothing enabled */

#define MDM_RXRDY	0x01
#define MDM_RXTRUE	0x02
#define MDM_DCD		0x04
#define MDM_TXRDY	0x08
#define MDM_TXIDL	0x10
#define MDM_TMRINT	0x20
#define MDM_SYNC	0x40
#define MDM_SYNT	0x80

!----------------------------------------------------------------------
!
!	8254 timer
!

#define TMR_0		0x00
#define TMR_1		0x40
#define TMR_2		0x80
#define TMR_INTTC	0x00	/* mode 0, intr on terminal cnt */
#define TMR_ONESHOT	0x02	/* mode 1, one shot */
#define TMR_RATEGEN	0x04	/* mode 2, rate generator */
#define TMR_SQWAVE	0x06	/* mode 3, square wave */
#define TMR_SWTRIGG	0x08	/* mode 4, s/w triggered strobe */
#define TMR_LSB		0x10	/* r/w counter LSB */
#define TMR_MSB		0x20	/* r/w counter MSB */
#define TMR_BOTH	0x30	/* r/w counter 16 bits, LSB first */

!----------------------------------------------------------------------
!
!	SIO defs
!

#define WR0_SEND_ABORT			0x08
#define WR0_RESET_ESCINT		0x10
#define WR0_CHANNEL_RESET		0x18
#define WR0_REARM_1STC			0x20
#define WR0_RESET_TXINT			0x28
#define WR0_ERROR_RESET			0x30
#define WR0_RETINT				0x38
#define WR0_RESET_RXCRC			0x40
#define WR0_RESET_TXCRC			0x80
#define WR0_RESET_UNDERRUN		0xc0

#define WR1_ESCINT_ENB			0x01
#define WR1_TXINT_ENB			0x02
#define WR1_STATUS_VECTOR		0x04
#define WR1_RXINT_DISABLE		0x00
#define WR1_INT_1STC			0x08
#define WR1_INT_ALLC			0x10
#define WR1_INT_ALLC_PNS		0x18
#define WR1_WAITREADY_RT		0x20
#define WR1_WAITREADY_FN		0x40
#define WR1_WAITREADY_ENB		0x80

#define WR3_RX_ENB				0x01
#define WR3_SYNCLOAD_INHIBIT	0x02
#define WR3_ADDRESS_SEARCH_MODE	0x04
#define WR3_RXCRC_ENB			0x08
#define WR3_ENTER_HUNT			0x10
#define WR3_AUTO_ENABLES		0x20
#define WR3_5BIT_RX				0x00
#define WR3_6BIT_RX				0x40
#define WR3_7BIT_RX				0x80
#define WR3_8BIT_RX				0xc0

#define WR4_PARITY_ENB			0x01
#define WR4_PARITY_ODD			0x00
#define WR4_PARITY_EVEN			0x02
#define WR4_SYNC_MODES			0x00
#define WR4_1STOPBIT			0x04
#define WR4_15STOPBIT			0x08
#define WR4_2STOPBIT			0x0c
#define WR4_8BITSYNC			0x00
#define WR4_16BITSYNC			0x10
#define WR4_SDLC_MODE			0x20
#define WR4_EXTSYNC				0x30
#define WR4_X1_CLK				0x00	/* 153600 bd, but... */
#define WR4_X16_CLK				0x40	/*   9600 bd */
#define WR4_X32_CLK				0x80	/*   4800 bd */
#define WR4_X64_CLK				0xc0	/*   2400 bd */

#define WR5_TXCRC_ENB			0x01
#define WR5_RTS					0x02
#define WR5_CCITT_CRC			0x00
#define WR5_CRC16_CRC			0x04
#define WR5_TX_ENB				0x08
#define WR5_SEND_BREAK			0x10
#define WR5_5BIT_TX				0x00
#define WR5_7BIT_TX				0x20
#define WR5_6BIT_TX				0x40
#define WR5_8BIT_TX				0x60
#define WR5_DTR					0x80

#define RR0_RCA					0x01
#define RR0_INT_PENDING			0x02
#define RR0_TBE					0x04
#define RR0_DCD					0x08
#define RR0_SYNC				0x10
#define RR0_CTS					0x20
#define RR0_UNDERRUN			0x40
#define RR0_BREAK_ABORT			0x80

#define RR1_ALL_SENT			0x01

#define RR1_PARER				0x10
#define RR1_ROVER				0x20
#define RR1_FRMERR				0x40
#define RR1_CRCERR				0x40
#define RR1_ENDFRAME			0x80

!----------------------------------------------------------------------
!
!	Output latch bits
!
#define O0_VOLUME 0x07
#define O0_INH    0x08
#define O0_AUDIOC 0x10
#define O0_CCIRC  0x20
#define O0_MTC    0x40
#define O0_MICM   0x80
#define O0_MTCBIT 6

#define O1_SRE    0x01
#define O1_SCE    0x02
#define O1_STE    0x04
#define O1_CLK    0x08
#define O1_SD     0x10
#define O1_RAS    0x20
#define O1_TPS    0x40
#define O1_TXOFF  0x80

!
!	Changes only by mainline.
!

#define O2_RA14   0x01
#define O2_RA15   0x02
#define O2_RS     0x04
#define O2_SMEM   0x08
#define O2_CS1    0x10
#define O2_CS2    0x20
#define O2_CLK    0x40	/* I2C SCL for CU58AF */
#define O2_DP     0x80

#define O2_XXX    O2_SMEM

#define O2_KEYPAD (O2_XXX | 0)
#define O2_LATCH  (O2_XXX | O2_CS1)
#define O2_LCD1   (O2_XXX | O2_CS2)
#define O2_LCD2   (O2_XXX | O2_CS2 | O2_CS1)

!----------------------------------------------------------------------
!
!	PIO and SIO controls
!
#define PA_CLK2   0x01
#define PA_HOOK   0x02
#define PA_WDR    0x04
#define PA_PWR    0x08
#define PA_CCIR   0xf0	/* all inputs */

#define PB_RAMA12 0x01	/*                         out */
#define PB_EXIN1  0x02	/* aka /POR                out 0 if SERV */
#define PB_EXIN2  0x04  /* aka /IGN aka /EMG */
#define PB_DCU    0x08	/* I2C SDA for CU58AF      out 0 if SDA 0 */
#define PB_RXOFF  0x10
#define PB_TMR0   0x20
#define PB_EXAL   0x40	/*                         out */
#define PB_PWROFF 0x80	/*                         out */

#define PB_INPUTS 0x3E
#define PB_BIT_EXIN1 1
#define PB_BIT_DCU   3

#define SA_KKINT  RR0_DCD
#define SA_DA     RR0_CTS	/* I2C /INT for CU58AF */

#define SB_PTT    RR0_CTS
#define SB_LOCAL  RR0_SYNC
#define SB_DMIDLE RR0_DCD	/* No MBUS activity */
#define SB_MON    WR5_DTR	/* Master ON pulse */

!----------------------------------------------------------------------
!
!	CU58AF defines
!
#define CU58AF_DTMF       0b01001000

#define CU58AF_LCD        0b01110000

#define CU58AF_ROW        0b01001100
#define CU58AF_ROW_MASK   0b01111111

#define CU58AF_COLBTN     0b01000000

#define CU58AF_OFFHOOK    0b10000000
#define CU58AF_TANGENT    0b01000000
#define CU58AF_SPEAKER    0b00100000
#define CU58AF_LDR        0b00010000
#define CU58AF_COL_MASK   0b00000111

#define CU58AF_LED        0b01000100

#define CU58AF_LED_SERV   0b00000001
#define CU58AF_LED_CALL   0b00000010
#define CU58AF_LED_ON     0b00000100
#define CU58AF_LED_ROAM   0b00001000
#define CU58AF_KBRLIGHT   0b00100000
#define CU58AF_LCDLIGHT   0b01000000

#define CU58AF_CTRL       0b01111100

#define CU58AF_NSPKRCTRL  0b00000001
#define CU58AF_DTMFCTRL   0b00000010
#define CU58AF_AUDIOCTRL  0b00000100
#define CU58AF_MICCTRL    0b00001000
#define CU58AF_EARCTRL    0b00010000
#define CU58AF_VOL_MASK   0b11100000
#define CU58AF_VOL_MIN    0b00100000

#define CU58AF_SEG_ARROW3   (24 + 7)
#define CU58AF_SEG_ARROW2   (24 + 6)
#define CU58AF_SEG_ARROW1   (24 + 5)
#define CU58AF_SEG_ARROW0   (24 + 4)

#define CU58AF_SEG_PHONE    (24 + 3)
#define CU58AF_SEG_CAR      (24 + 2)
#define CU58AF_SEG_EXP      (24 + 1)

!----------------------------------------------------------------------
!
!	LATCH bits
!

#define CU58AF_BIT_AVAIL    4	/* not connected */
#define CU58AF_BIT_ROAM     3
#define CU58AF_BIT_KEYLIGHT 5
#define CU58AF_BIT_SERV     0
#define CU58AF_BIT_ON       2
#define CU58AF_BIT_CALL     1
#define CU58AF_BIT_LCDLIGHT 6
#define CU58AF_BIT_BRIGHT   7

#define CU53AN_BIT_AVAIL    0	/* not connected */
#define CU53AN_BIT_ROAM     2
#define CU53AN_BIT_KEYLIGHT 3
#define CU53AN_BIT_SERV     4
#define CU53AN_BIT_ON       5
#define CU53AN_BIT_CALL     1
#define CU53AN_BIT_LCDLIGHT 6
#define CU53AN_BIT_BRIGHT   7

!	Special LCD segments

#define CU53AN_SEG_V_U      0x43
#define CU53AN_SEG_V_D      0x53
#define CU53AN_SEG_PHONE    0x47
#define CU53AN_SEG_CLOCK    0x4b
#define CU53AN_SEG_COLON_UR 0x4f
#define CU53AN_SEG_COLON_UL 0x63
#define CU53AN_SEG_COLON_D  0x57
#define CU53AN_SEG_PHONE_NO 0x5b
#define CU53AN_SEG_MAST     0x5f
#define CU53AN_SEG_BAR_L    0x67
#define CU53AN_SEG_BAR_R    0x6f
#define CU53AN_SEG_STAR     0x6b
#define CU53AN_SEG_KEY      0x73
#define CU53AN_SEG_BOOK     0x77
#define CU53AN_SEG_CAR_D    0x7b
#define CU53AN_SEG_CAR_U    0x7f

!----------------------------------------------------------------------
!
!	realstart
!
	.text

	.org 0

	di
	ld sp, 0			! stack down from end of ram (last 16kB)

	ld a, O0_INH
	out [OUT0], a
	ld a, O1_TXOFF
	out [OUT1], a

#if 0
	in a, [PIO+ADATA]
	and PA_WDR
	jp nz, .			! Not watchdog reset ?!?
#endif

	ld hl, 0x0FFF	! Depends on clock freq... XXX shit
1:
	dec hl
	ld a, h
	or l
	jr nz, 1b		! Wait but not too long for defined wd state

	out [WD], a		! ok, now start
	jp start

!----------------------------------------------------------------------

	.org 0x0038

	di
	out [WD], a
	ld sp, 0			! stack down from end of ram (last 16kB)
	jp start

!----------------------------------------------------------------------
!
!	NMI
!
	.org 0x0066

	di				! IFF1 and IFF2 cleared
	out [WD], a

	jp save_nvmisc_and_restart

!----------------------------------------------------------------------

	.ascii "@(#)"
banner:
	.ascii "R58 "
	.ascii "v"
version:
	.ascii VERSION
	.ascii " "
	.ascii PATCHED
	.ascii " "
	.ascii DATE
	.ascii " "
#ifdef P8x
	.ascii "P8E/P8N "
	.ascii "S8B/S8C/S8D "
#endif
	.ascii "CU53xx/CU58AF"
	.ascii "\n"
	.byte EOS

!----------------------------------------------------------------------
!
!	Interrupt table, short-aligned, on one page.
!
	.align 4

intvec:

sio_base:
	.word siob_tbe
	.word siob_esc
	.word siob_rca
	.word siob_src
	.word sioa_tbe
	.word sioa_esc
	.word sioa_rca
	.word sioa_src

pioa_base:
	.word pioa_int
piob_base:
	.word piob_int

!----------------------------------------------------------------------
!
!	Initialization commands for PIO, SIO and 8254
!	In that order, A/B, A/B, 0/1/2 !
!

init_chips:
1:
	.byte LO(pioa_base)	! load interrupt vector
	.byte 0xcf			! set operating mode 3
	.byte 0xff			! i/o selection, 1 for input, 0 for output
	.byte 0x97			! set interrupt control, IE, OR, LOW, MASK
	.byte 0xfe			! input bit monitoring mask, A0.
PIOA_INIT = . - 1b

1:
	.byte LO(piob_base)	! load interrupt vector
	.byte 0xCF			! set operating mode 3
	.byte 0x3E			! i/o selection, 1 for input, 0 for output
	.byte 0x97			! set interrupt control, IE, OR, LOW, MASK
	!.byte 0xDF			! input bit monitoring mask, only B5 (TMR0)
	.byte 0xFF			! input bit monitoring mask, nothing
PIOB_INIT = . - 1b

1:
	.byte WR0_CHANNEL_RESET
	.byte 4, WR4_1STOPBIT | WR4_X16_CLK
	.byte 3, WR3_8BIT_RX
	.byte 5, WR5_8BIT_TX | WR5_RTS | WR5_DTR
	.byte 1, WR1_STATUS_VECTOR | WR1_ESCINT_ENB
SIOA_INIT = . - 1b

1:
	.byte WR0_CHANNEL_RESET
	.byte 4, WR4_1STOPBIT | WR4_X16_CLK
	.byte 3, WR3_8BIT_RX | WR3_RX_ENB
	.byte 5, WR5_8BIT_TX | WR5_RTS | WR5_DTR | WR5_TX_ENB
	.byte 1, WR1_STATUS_VECTOR | WR1_ESCINT_ENB | WR1_TXINT_ENB | WR1_INT_ALLC
	.byte 2, LO(sio_base)
SIOB_INIT = . - 1b

!
!	All timer-gates are fixed on.
!	timer-clocks 0 and 1 are 4.032 MHz, 2 is 1968.75 Hz
!
!	System hz is 100, from PIO A0 change-interrupt 1968.75 Hz
!   divided with software
!
#define MT_CALCHZ(f) (4032000 / (f))

MT_300HZ  = MT_CALCHZ(300)
MT_600HZ  = MT_CALCHZ(600)
MT_1000HZ = MT_CALCHZ(1000)
MT_1200HZ = MT_CALCHZ(1200)
MT_1400HZ = MT_CALCHZ(1400)
MT_1750HZ = MT_CALCHZ(1750)

!----------------------------------------------------------------------
!
!    76543210
!   876543210
!
!     PV QQ SS        Pwr Vol sQuelch Sig
!   MM-434775           mem  frequency
!
! 0 1  23456789
! 10 1112

#define CU58AF_segs_bottom_row (segments + 2 * 11)
#define CU58AF_segs_d_digit_8  (segments + 2 * 11)
#define CU58AF_segs_d_digit_6  (segments + 2 * 13)

!	top row

#define CU58AF_segs_u_digit_7  (segments + 2 * 2)
#define CU58AF_segs_u_digit_4  (segments + 2 * 5)
#define CU58AF_segs_u_digit_1  (segments + 2 * 8)

!----------------------------------------------------------------------
!
!     XXYYZZ
!   9876543210
!
!      V P S        vola pwr srssi
!   CH  433500    channel  frequency
!

!	bottom row

CU53AN_segs_bottom_row:
CU53AN_segs_d_digit_9:		.byte 56, 57, 58, 59,	120, 121, 122
CU53AN_segs_d_digit_8:		.byte 60, 61, 62, 63,	124, 125, 126
CU53AN_segs_d_digit_7:		.byte  0,  1,  2,  3,	 64,  65,  66
CU53AN_segs_d_digit_6:		.byte  4,  5,  6,  7,	 68,  69,  70
CU53AN_segs_d_digit_5:		.byte  8,  9, 10, 11,	 72,  73,  74
CU53AN_segs_d_digit_4:		.byte 12, 13, 14, 15,	 76,  77,  78
CU53AN_segs_d_digit_3:		.byte 16, 17, 18, 19,	 80,  81,  82
CU53AN_segs_d_digit_2:		.byte 20, 21, 22, 23,	 84,  85,  86
CU53AN_segs_d_digit_1:		.byte 24, 25, 26, 27,	 88,  89,  90
CU53AN_segs_d_digit_0:		.byte 28, 29, 30, 31,	 92,  93,  94

!	top row

CU53AN_segs_u_digit_5:		.byte 32, 33, 34, 35,	 96,  97,  98
CU53AN_segs_u_digit_4:		.byte 36, 37, 38, 39,	100, 101, 102
CU53AN_segs_u_digit_3:		.byte 40, 41, 42, 43,	104, 105, 106
CU53AN_segs_u_digit_2:		.byte 44, 45, 46, 47,	108, 109, 110
CU53AN_segs_u_digit_1:		.byte 48, 49, 50, 51,	112, 113, 114
CU53AN_segs_u_digit_0:		.byte 52, 53, 54, 55,	116, 117, 118

!======================================================================
!
!	Initialization before main
!

start:
	di
	out [WD], a

	ld sp, 0			! stack down from end of ram (last 16kB)

	ld a, HI(intvec)
	ld iv, a
	im2

	!
	!  Output latches
	!

	ld a, O0_INH			! volume setting at lowest level
	ld [output_0], a
	out [OUT0], a

	ld a, O1_TXOFF		! no tx, idle all
	ld [output_1], a
	out [OUT1], a

	out [WD], a
	!
	!  Prep RAM selects for max workspace
	!
	ld a, O2_XXX		! select ram 0, i hope, on P8N
	out [OUT2], a

	ld a, 1
	out [CSMEM], a		! select full 16k page of ram on P8E, nop on P8N

	out [WD], a

	!
	!  Disable NMT modem
	!

	ld a, MDM_XXX
	out [MDM + MDMCTRL], a

	!
	!  PIO, SIO and 8254
	!

	ld a, PB_INPUTS
	ld [piob_mode], a

	ld a, 0
	out [PIO+BDATA], a	! B0, EXAL, OFF all zero. SDA low but direction read.

	ld hl, init_chips   ! few runs of 'otir' below

	ld b, PIOA_INIT
	ld c, PIO+ACTRL
	otir
	out [WD], a

	ld b, PIOB_INIT
	ld c, PIO+BCTRL
	otir
	out [WD], a

	! Set output bits, and check if restarted from powerdown nmi.

	ld a, 0
	out [PIO+BDATA], a	! B0, EXAL, OFF all zero, again ?

	in a, [PIO+ADATA]
	and PA_PWR
	jp nz, powerdown

	ld b, SIOA_INIT
	ld c, SIO+ACTRL
	in a, [c]
	otir
	out [WD], a

	ld b, SIOB_INIT
	ld c, SIO+BCTRL
	in a, [c]
	otir
	out [WD], a

	call check_for_P8E_cpu     ! timers messed up

	out [WD], a

	call init_timer1
	call ctcss_off

	out [WD], a

	! ----------------- zero variables ------------------------
	ld de, _bss
	ld a, 0
1:
	out [WD], a
	ld [de], a
	inc de
	ld hl, _end
	and a
	sbc hl, de
	jr nz, 1b

	!
	!  Initialize variables after bss clear
	!
	ld hl, mbusrx_buf
	ld [mbusrx_rp], hl
	ld [mbusrx_wp], hl

	ld hl, mbustx_buf
	ld [mbustx_rp], hl
	ld [mbustx_wp], hl

	out [WD], a

	ld a, 0xFF
	ld [dark], a
	ld [ad_batt], a

	ld hl, packet
	ld [pkt_ptr], hl		! rewind packet pointer

	call load_nvdata

	ld a, -1
	ld [key], a
	ld [lastkey], a
	ld [lastdigit], a

	out [WD], a

	call init_modem

	out [WD], a

	ld b, 2
	ld c, 0
	ld d, 0			! delay 2 * 256 * 256
1:
	out [WD], a
	nop
	nop
	nop
	nop
	dec d
	jr nz, 1b
	dec c
	jr nz, 1b
	dec b
	jr nz, 1b		! Give time for LCD to reset itself !

	in a, [TMR+TMRCTRL]		! dummy read to raise PIO B5 (remove int)
	out [WD], a

	!----------------------------------------------
	!  Check some input pins at bootup

	in a, [PIO+BDATA]
	and PB_EXIN1
	jr nz, 1f
	ld a, 1
	ld [portable], a	! /POR grounded
1:

	ld a, WR0_RESET_ESCINT
	out [SIO+BCTRL], a
	in a, [SIO+BCTRL]
	and SB_LOCAL		! inverted...
	jp z, 1f			! go if LOCAL idle high
	ld a, 1
	ld [local_mode], a
1:

	!----------------------------------------------

	jp main

!======================================================================

doreti:
	pop af
	ei
	reti

!----------------------------------------------------------------------
!
!  SIO interrupts
!

siob_tbe:
	push af
	ld a, [mbustx_cnt]
	dec a
	ld [mbustx_cnt], a
	jr z, siob_tbe_close
	push hl
	ld hl, [mbustx_rp]
	ld a, [hl]
	inc l
	ld [mbustx_rp], hl
	pop hl
	out [SIO+BDATA], a
	ld a, 25
	ld [mbus_timer], a		! keep transmit timer on
	jp doreti

siob_tbe_close:
	ld a, WR0_RESET_TXINT
	out [SIO+BCTRL], a
	jp doreti

siob_rca_drop:
	call bleep

siob_rca_ignore:
	in a, [SIO+BDATA]

	jp doreti

siob_rca:
	push af
	ld a, [mbus_timer]
	or a
	jr nz, siob_rca_ignore
	ld a, [mbusrx_cnt]
	inc a
	jr z, siob_rca_drop			! no room
	ld [mbusrx_cnt], a
	push hl
	ld hl, [mbusrx_wp]
	in a, [SIO+BDATA]
	ld [hl], a
	inc l
	ld [mbusrx_wp], hl
	pop hl
	jp doreti

!
!	SIO B ext/status change - PTT
!
siob_esc:
	push af
	in a, [SIO+BCTRL]
	and SB_PTT
	ld a, [pttdn]
	jr z, 1f
	set 0, a
	jr 2f
1:
	res 0, a
2:
	ld [pttdn], a

	ld a, WR0_RESET_ESCINT
	out [SIO+BCTRL], a
	jp doreti

!
!	SIO B special receive condition
!
siob_src:
	push af
	in a, [SIO+BDATA]
	ld a, WR0_ERROR_RESET
	out [SIO+BCTRL], a

	call bleep

	jp doreti

sioa_tbe:
	push af
	ld a, WR0_RESET_TXINT
	out [SIO+ACTRL], a
	jp doreti

sioa_rca:
	push af
	in a, [SIO+ADATA]
	jp doreti

!
!  SIO A ext/status change - DA, HK, Modem and timer OUT2
!
!
!  CU53 and CU58AF behave differently.
!
!  CU53 raises DA on make, and drops it on break.
!  CU58AF drops /INT each time a button makes or breaks.
!  'keydown' flags a pressed key, and is also used for debouncing.
!  When it increments to 10 in systick() the data is fetched from CU.
!  With CU53 the break is detected here, but CU58AF has to fetch
!  nil data with i2c. 'keydown' is restarted from 1 on each i2c /INT.
!
sioa_esc:
	push af

	ld a, [cu_is_known]
	or a
	jp z, 9f            ! disregard until CU53/CU58AF is known

	!
	!  /CTS inverts the input...
	!
	ld a, [cu_is_alfa]
	or a
	jr nz, 3f

	in a, [SIO+ACTRL]
	and SA_DA
	jp nz, 1f			! go (skip) if DA low
	ld a, [keydown]
	or a
	jr nz, 2f			! go if already seen it
	jr 4f
3:
	in a, [SIO+ACTRL]
	and SA_DA
	jp z, 2f			! go (skip) if /INT high. We only look for drops.
4:
	ld a, 1
	ld [keydown], a		! start debouncing
	jr 2f
1:
	ld a, 0
	ld [key_timer], a
	ld [keydown], a
	ld a, [lastdigit]
	cp -1
	jr z, 2f
	ld a, [lastdigit]
	ld [key], a			! Quick press of digit.
	ld a, -1
	ld [lastdigit], a
2:
9:

#if 1
	ld a, [txon]
	or a
	jr nz, 1f				! ignore during xmit
	in a, [MDM + MDMCTRL]
	and MDM_SYNC | MDM_RXRDY
	jr z, 1f				! no sync nor data
	push hl
	cp MDM_SYNC
	jr nz, 3f				! not sync only (never both simultaneously ?!?!?)
	ld hl, packet
	ld [pkt_ptr], hl		! rewind packet pointer
	jr 2f
3:
	and MDM_RXRDY
	jr z, 2f
	in a, [MDM + MDMDATA]
	ld hl, [pkt_ptr]
	ld [hl], a
	inc hl
	ld [pkt_ptr], hl
	ld a, l
	cp LO(packet + SIZE(packet))
	jr nz, 2f
	ld hl, packet
	ld [pkt_ptr], hl		! rewind packet pointer
	push bc
	push de
	push ix
	call check_packet
	pop ix
	pop de
	pop bc
2:
	pop hl
1:
#endif

	in a, [TMR+TMRCTRL]		! dummy read to raise PIO B5 (remove int)

	ld a, WR0_RESET_ESCINT
	out [SIO+ACTRL], a

	jp doreti

!
!	SIO A special receive condition
!
sioa_src:
	push af
	in a, [SIO+ADATA]
	ld a, WR0_ERROR_RESET
	out [SIO+ACTRL], a
	jp doreti

!----------------------------------------------------------------------
!
!  PIO interrupts
!

!	Change in B5
!   Should not get this now, as monitormask is empty...

piob_int:
	push af

	jp doreti

!	Change in A0, 1968.75 Hz square - systick and D/A read every now and then

pioa_int:
	ex af
	exx
	dec c
	jr z, systick
	dec b
	jr z, 1f
	ex af
	exx
	ei
	reti
2:
	ld [ad_select], a        ! wait for next reading from A/D
	ld b, 5
	ex af
	exx
	ei
	reti
1:                           ! another reading from A/D
	ld a, [ad_select]
	cp AD_BATT
	jr nz, 1f
	in a, [AD]
	ld [ad_batt], a

	out [AD_SQL], a		! value not important
	out [AD_SQL], a		! twice to settle analog mux, it changed
	ld a, AD_SQL
	jr 2b                     ! wait for next
1:
	cp AD_SQL
	jr nz, 1f
	in a, [AD]
	ld [ad_sql], a

	out [AD_RSSI], a		! value not important
	out [AD_RSSI], a		! twice to settle analog mux, it changed
	ld a, AD_RSSI
	jr 2b
1:
	in a, [AD]
	ld [ad_rssi], a

	out [AD_BATT], a		! value not important
	out [AD_BATT], a		! twice to settle analog mux, it changed
	ld a, AD_BATT
	jr 2b

systick:
	out [WD], a				! keep watchdog happy.

	!----------------------------
	!  Hook interest
	!
	ld a, [pioa_data]
	ld l, a					! old bits
	in a, [PIO+ADATA]
	ld [pioa_data], a       ! save PIO ADATA, check CCIR decode again at end
	xor l					! extract change
	and PA_HOOK
	jr z, 9f				! not changed

	! Change in hook here

	ld a, [cfg_light_seconds] ! light up ?
	or a
	jp z, 9f                ! 0 seconds lights on.

	call cu_lights_on
	ld hl, sir
	set DPYSIR, [hl]		! Update CU later
9:

	!-------------------------

	ld a, [scan_mode]
	or a
	jr z, 1f
	ld a, [scan_timer]
	or a
	jr z, 1f
	dec a
	ld [scan_timer], a
1:
	!-------------------------

	ld a, [mt_timer]
	or a
	jr z, 1f
	ld a, [output_0]
	out [OUT0], a              ! XXX check this
	ld a, [mt_timer]
	dec a
	ld [mt_timer], a
	call z, stop_marker_tone
1:

	!
	!  Decrement MBUS activity timer
	!
	ld a, [mbus_timer]
	or a
	jr z, 1f
	dec a
	ld [mbus_timer], a
1:
	!
	!  ccir timer
	!
	ld a, [ccir_tx_timer]
	or a
	jr z, 1f
	dec a
	ld [ccir_tx_timer], a
1:
	!
	!  One second trail after end of xmit
	!
	ld a, [txtail_timer]
	or a
	jr z, 1f				! Not counting anymore
	ld a, [txon]
	or a
	jr nz, 1f				! Still xmit
	ld a, [txtail_timer]
	dec a
	ld [txtail_timer], a	! One 10msec less of tail
1:
	!
	!  See if keypad has data coming and debouncing
	!  allows it to be fetched
	!
	ld a, [keydown]
	or a
	jr z, 9f			! not key down
	inc a
	jr z, 1f			! been a long time, 256 softicks
	ld [keydown], a
	cp 10
	jr nz, 1f			! not at debounce-position
	ld hl, sir
	set KEYSIR, [hl]	! go get it.
1:
	ld a, [key_timer]   !  Typematic ?
	or a
	jr z, 9f
	dec a
	ld [key_timer], a

	call z, typematic
9:

	!	S meter and squelch control, tone decoders

	ld a, [txtail_timer]
	cp 90
	jp nc, 9f				! Skip if tx during last 100 msec
	ld a, [mton]
	or a
	jp nz, 9f				! Skip if tone on.

	call squelch
	call rssi_disp
	call ccir_decoder
	call dtmf_decoder
9:

	!--------------------

	ld a, [sec100]
	inc a
	cp 100
	jr c, 1f		! less than full second.

	ld a, [seconds]
	inc a
	cp 60
	jr c, 2f		! less than full minute
	ld a, [minutes]
	inc a
	cp 60
	jr c, 3f
	ld a, [hours]
	inc a			! overflows to 0...
	ld [hours], a
	call once_per_hour
	ld a, 0
3:
	ld [minutes], a
	call once_per_minute
	ld a, 0
2:
	ld [seconds], a
	call once_per_second
	ld a, 0
1:
	ld [sec100], a

	!--------------------

	ld c, 20	! 1969 / 100 hard ticks to next
	ld b, 5		! hard ticks between A/D stuff
	exx

	!  softlevel

	ld a, [nosir]
	or a
	jr nz, 1f		! Cannot do it now.
	ld a, [sir]
	or a
	jr nz, 2f		! there are sirs
1:
	ex af
8:
	ei
	reti
2:
	bit INSIR, a
	jr nz, 1b		! already here

	set INSIR, a
	ld [sir], a		! note sir starting

	ex af

	push af
	push bc
	push de
	push hl
	push ix
	push iy			! sir runs with normal regset

	call 8b
	call dosir
	di

	ld a, [sir]
	res INSIR, a
	ld [sir], a

	pop iy
	pop ix
	pop hl
	pop de
	pop bc
	pop af

	ei
	ret

dosir:

	ld hl, sir
	bit KEYSIR, [hl]
	jr z, 1f
	res KEYSIR, [hl]
	call keypad
1:
	ld hl, sir
	bit DPYSIR, [hl]
	jr z, 1f
	res DPYSIR, [hl]
	call display
1:
	ld hl, sir
	bit DTMFSIR, [hl]
	jr z, 1f
	res DTMFSIR, [hl]
	ld a, [cu_is_alfa]
	or a
	call nz, i2c_dtmf
1:

	ret

!----------------------------------------------------------------------

once_per_second:

	!
	!  Alert timer
	!
	ld a, [alert_timer]
	or a
	jp z, 1f
	dec a
	ld [alert_timer], a
1:
	!
	!  slower scanner timer
	!
	ld a, [scan_mode]
	or a
	jp z, 1f
	ld a, [scan_patience]
	or a
	jr z, 1f
	dec a
	ld [scan_patience], a
1:
	!
	!  _INCREMENT_ timer for handset lights
	!
	ld a, [keydown]
	or a
	jr nz, 1f				! not if button still pressed
	ld a, [lights_timer]
	inc a
	jr z, 1f                ! walk and stay at 255 seconds
	ld [lights_timer], a
1:

	!  any pending DTMF codes buffered ?

	ld a, [dtmf_idletime]
	or a
	jp z, 1f
	inc a
	ld hl, cfg_dtmf_holdtime
	cp [hl]
	jp c, 2f
	call dtmf_decoder_timeout
	ld a, 0
2:
	ld [dtmf_idletime], a
1:
	ret

!----------------------------------------------------------------------

once_per_minute:

	! TOT overrun ?

	ld a, [txon]
	or a
	jp z, 1f
	ld a, [cfg_tx_tot_minutes]
	ld hl, tx_tot_timer
	cp [hl]                        ! if cfg is 255, never carry
	jp c, powerdown
	inc [hl]
1:
	ret

!----------------------------------------------------------------------

once_per_hour:

	! APO overrun ?

	in a, [PIO+BDATA]
	and PB_EXIN2              ! aka /IGN
	jr z, 1f                  ! /IGN still grounded
	ld a, [cfg_ign_apo_hours]
	ld hl, ign_apo_timer
	cp [hl]                        ! if cfg is 255, never carry
	jp c, powerdown
	inc [hl]
1:
	ret

!======================================================================


read_squelcher_value:
	ld a, [cfg_squelch_source]	! +SQL, -SQL or +RSSI
	cp 0
	jp nz, 1f
	ld a, [ad_sql]
	ret
1:
	cp 1
	jp nz, 2f
	ld a, [ad_sql]
	cpl
	ret
2:
	ld a, [ad_rssi]
	ret

squelch:
	call read_squelcher_value
	ld b, a                 ! b has sql
	ld a, [cfg_squelch_hyst]
	srl a
	ld c, a                 ! c has half hysteresis

	ld a, [squelch_open]
	or a
	jp nz, 9f

	!  squelch was closed --------------------------------

	ld a, [cfg_squelch_level]
	add c                        ! a has open limit
	jr nc, 1f
	ld a, 0xFF
1:
	cp b						! open_limit - sql
	ret nc        				 ! if still open_limit >= sql

	!  sql now above open limit

	ld a, [squelch_delay]
	or a
	jp z, 1f
	dec a
	ld [squelch_delay], a        ! still dragging to open
	ret nz
1:
	! opening delay expired, open and prep delay for tail

	call cu_serv_on
	call pull_down_EXIN1

	ld a, 1
	ld [squelch_open], a
	ld a, [cfg_squelch_tail]
	ld [squelch_delay], a

	ld a, [scan_mute]
	or a
	ret nz					! Scanner forced no audio.

	jp audioc_on

9:
	!  squelch was open ---------------------------------

	ld a, [cfg_squelch_level]
	sub c
	ld c, a
	jr nc, 1f
	ld c, 0                         ! c has close limit
1:
	ld a, b                         ! a has sql
	cp c							! sql - close_limit
	ret nc                     		! if still sql >= close_limit

	!  sql now below close limit

	ld a, [squelch_delay]
	or a
	jp z, 1f
	dec a
	ld [squelch_delay], a        ! still dragging
	ret nz
1:
	! closing delay expired, close and prep delay for opening delay

	call cu_serv_off
	call release_EXIN1

	ld a, 0
	ld [squelch_open], a
	ld a, [cfg_squelch_head]
	ld [squelch_delay], a

	ld a, [squelch_forced]
	or a
	ret nz						! Manually forced open.

	jp audioc_off

audioc_on:
	ld a, [output_0]
	or O0_AUDIOC
	ld [output_0], a
	out [OUT0], a
	ret

audioc_off:
	ld a, [output_0]
	and ~O0_AUDIOC
	ld [output_0], a
	out [OUT0], a
	ret

!----------------------------------------------------------------------

rssi_disp:

	!  smoothing rssi display

	ld a, [ad_rssi]
	ld b, a

	ld a, [srssi]
	cp b					! smoothed - rssi
	jr c, 1f				! go if raising
	ld a, [rssi_timer]
	dec a
	jr nz, 2f				! go if still timing
1:
	ld a, 1
	ld [redraw_req], a
	ld a, b
	ld [srssi], a
	ld a, 50			! one second
2:
	ld [rssi_timer], a
	ret

!----------------------------------------------------------------------
!
!	CCIR decoder called 100 times a second from systick if tx is off
!
ccir_decoder:
	ld a, [ccir_tonetime]
	ld d, a               ! duration to d
	inc a
	jr z, 1f
	ld [ccir_tonetime], a ! length of serie 10 msec longer
1:
	ld a, [pioa_data]
	and PA_CCIR           ! CCIR bits from the top of systick
	ld b, a
	in a, [PIO+ADATA]
	and PA_CCIR           ! current bits
	cp b
	ret nz                ! CCIR bits are changing

	cp 0xF0               ! restart duration if notone
	jp nz, 1f
	ld a, 0
	ld [ccir_tonetime], a
1:

	ld a, [ccir_prevdata] ! old ccir bits
	cp b
	ret z                 ! same bits as old
	ld a, b
	ld [ccir_prevdata], a ! remember these new bits

	ld h, HI(ccir_history)
	ld a, [ccir_hist_idx]
	ld l, a
	inc a
	ld [ccir_hist_idx], a ! idx points to next free slot

	ld a, b               ! new bits
	cp 0xF0
	jr z, 1f              ! tone F

	! NEW TONE

	cp 0xE0
	jr nz, 2f                ! not repeat
	dec l
	ld a, [hl]               ! peek previous chr
	inc l
	cp ' '
	jr nz, 3f                ! repeat with previous tone
	ld a, 0xE0               ! huh ? starts with repeat
2:
	srl a
	srl a
	srl a
	srl a     ; ASSERT(PA_CCIR == 0xf0)
3:
	ld [hl], a
	ret
1:
	! NOTONE

	ld a, ' '
	ld [hl], a

	ld a, [cfg_ccir_minlen]  ! accept only N csec or longer series
	cp d                     ! minimum_time - duration
	jp c, 1f
	ld a, [ccir_toneptr]
	ld [ccir_hist_idx], a    ! next tone will overwrite this bad one
	ret
1:
	! okay decode

	call ccir_ok_serie

	ld a, [ccir_hist_idx]
	ld [ccir_toneptr], a     ! next serie starts here (after blank)
	dec a
	ld [ccir_hist_finger], a ! reposition peeking finger also (over blank)
	ret

ccir_ok_serie:

	! check ours

	ld de, cfg_ccir_1
	call compare_ccir_serie
	jp z, ccir_match
	ld de, cfg_ccir_2
	call compare_ccir_serie
	jp z, ccir_match
	ld de, cfg_ccir_3
	call compare_ccir_serie
	jp z, ccir_match
	ret

compare_ccir_serie:
	ld a, [ccir_toneptr]
	ld l, a
	ld a, [de]; cp [hl]; jp nz, 1f; inc de; inc l
	ld a, [de]; cp [hl]; jp nz, 1f; inc de; inc l
	ld a, [de]; cp [hl]; jp nz, 1f; inc de; inc l
	ld a, [de]; cp [hl]; jp nz, 1f; inc de; inc l
	ld a, [de]; cp [hl]; jp nz, 1f; inc de; inc l
	ld a, [de]; cp [hl]; jp nz, 1f; inc de; inc l
	ld a, [de]; cp [hl]; jp nz, 1f; inc de; inc l
	ld a, [de]; cp [hl]; jp nz, 1f; inc de; inc l
	ld a, ' '
	cp [hl]    ! heard one must also end
	ret
1:
	cp EOS     ! if mismatch, both strings must be at end
	ret nz     ! cfg continues
	ld a, ' '  ! cfg ends, heard one must also
	cp [hl]
	ret


ccir_match:
	ld a, 2
	ld [call_dpyed], a
	ret

ccir_decoder_init:
	ld hl, ccir_history
	ld a, ' '
1:
	ld [hl], a
	inc l
	jr nz, 1b
	ret

!======================================================================

dtmf_decoder_init:
	ld hl, dtmf_history
	ld a, ' '
1:
	ld [hl], a
	inc l
	jr nz, 1b
	ld a, 0x00
	ld [dtmf_prevdata], a ! start from notone
	ret

dtmf_decoder:
	ld a, [0x8000]
	bit 7, a
	jp nz, 1f       ! if StD high
	ld a, 0
	ld [dtmf_prevdata], a
	ret
1:
	and 0xF8
	ld b, a         ! b is StD Q4...1 X X X

	ld a, 1
	ld [dtmf_idletime], a ! rewind dtmf notone timer

	ld a, [dtmf_prevdata]
	cp b
	ret z           ! same as old

	ld a, b
	ld [dtmf_prevdata], a ! remember as old
	srl a
	srl a
	srl a           ! 0 0 0 StD Q4 Q3 Q2 Q1
	and 0x0F

	ld hl, dtmf_8870_tab
	add l
	ld l, a
	jp nc, 1f
	inc h
1:
	ld b, [hl]        ! map into digit or code

	ld h, HI(dtmf_history)
	ld a, [dtmf_hist_idx]
	ld l, a
	inc a
	ld [dtmf_hist_idx], a ! idx points to next free slot now
	ld [hl], b       ! stash digit/code

	ret

dtmf_decoder_timeout:

	ld h, HI(dtmf_history)
	ld a, [dtmf_hist_idx]
	ld l, a
	ld [dtmf_hist_finger], a ! finger points to blank after codes
	inc a
	ld [dtmf_hist_idx], a ! idx points to next free slot now
	ld [dtmf_toneptr], a  ! ptr also
	ld a, ' '
	ld [hl], a            ! stash digit/code
	ret

!======================================================================

pull_down_EXIN1:
	ld hl, piob_mode
	res PB_BIT_EXIN1, [hl] ! i/o selection, 1 for input, 0 for output
	jp 1f

release_EXIN1:
	ld hl, piob_mode
	set PB_BIT_EXIN1, [hl] ! i/o selection, 1 for input, 0 for output
	jp 1f

pull_down_DCU:
	ld hl, piob_mode
	res PB_BIT_DCU, [hl]   ! i/o selection, 1 for input, 0 for output
	jp 1f

release_DCU:
	ld hl, piob_mode
	set PB_BIT_DCU, [hl]   ! i/o selection, 1 for input, 0 for output
1:
	ld a, 0xCF			   ! operating mode 3
	out [PIO+BCTRL], a
	ld a, [hl]
	out [PIO+BCTRL], a
	ret

!======================================================================

main:
	ei

	call probe_cu58af

	call ccir_decoder_init
	call dtmf_decoder_init
	call enable_modem

	call set_vola
	call init_menu
	call init_LPF

1:
	call is_key_down
	jp nz, 1b			! wait release
	ld a, [pttdn]
	or a
	jp nz, 1b			! wait release

#if 1                       /* XXX */
	ld a, 0
	ld [scan_mode], a
#endif

	call halt_txsynth
	call changed_frequency
	call cu_manipulated
	call light_on_led
	call resync_squelch
	call redraw
	call redraw

	ld a, [scan_mode]
	or a
	jr z, 1f
	ld [last_scan], a
	ld a, 0
	ld [scan_mode], a
	call scanner_start
1:

mainloop:
	call redrawcheck
	call battcheck
	call pttcheck
	call keycheck
	call fskcheck
	call dim_lights_if_idle
	call scanner_run

	jp mainloop

!======================================================================

dim_lights_if_idle:
	ld a, [cfg_light_seconds]
	ld hl, lights_timer
	cp [hl]                 ! setting - idleseconds
	call c, cu_lights_off   ! dim if idle longer than configured time
	ret

!----------------------------------------------------------------------

battcheck:

	ld a, [txtail_timer]	! did xmit lately ?
	or a
	jr z, 2f
	ld a, [ad_batt]
	cp  80 * 256 / 156	! 8V
	jp c, powerdown
	cp  90 * 256 / 156	! 9V, was 11.2V, 184
	jr c, 1f
	call clear_clock_icon
	ret
2:
	ld a, [ad_batt]
	cp  90 * 256 / 156	! 9V, was 10.2V, 167
	jp c, powerdown
	cp 100 * 256 / 156	! 10V, was 11.2V, 184
	jr c, 1f
	call clear_clock_icon
	ret

1:
	call draw_clock_icon

	ld a, [alert_timer]
	or a
	ret nz

	ld a, 60
	ld [alert_timer], a	! every 60 sec

	ld hl, MT_300HZ
	ld d, 100				! one second alert tone
	call start_marker_tone

	ret

!======================================================================

redrawcheck:

	ld a, [redraw_req]
	cp 0
	ret z

	ld a, 0
	ld [redraw_req], a

	jp redraw

!======================================================================

keycheck:

	ld a, [key]
	cp -1
	ret z

	ld c, a
	call clear_key
	call dokey
	call no_feedback
	jp redraw

is_key_down:
	ld a, [keydown]
	or a
	ret nz               ! NZ key down
	call clear_key
	cp a
	ret                  ! Z not

waitkey:
1:
	ld a, [key_time]
	cp 255
	call z, feedback_let_go_the_darn_button
	call redraw
	call is_key_down
	jr nz, 1b
	ret

!----------------------------------------------------------------------

cu_manipulated:
	ld a, 0
	ld [ign_apo_timer], a
	ld a, 0
	ld [call_dpyed], a
	call cu_call_off
	call cu_lights_on
	ret

!----------------------------------------------------------------------

dokey:				! whatever we call will do ret

	ld a, [menu_active]
	or a
	jp nz, menu_input

	ld a, c
	cp 10
	jp c, insdig

	cp '#'
	jp z, execute
	cp 'C'
	jp z, backspace
	cp 'E'
	jp z, toggle_or_position_menu
	cp '*'
	jp z, beep_or_fsk_send
	cp '+'
	jp z, up_vola
	cp '-'
	jp z, dn_vola
	cp 'B'
	jp z, monitor_audio

	cp 0x81
	jp z, up_sqlv
	cp 0x84
	jp z, dn_sqlv
	cp 0x87
	jp z, def_sqlv

	cp 0x82
	jp z, up_memo
	cp 0x85
	jp z, dn_memo
	cp 0x88
	jp z, def_memo

	cp 0x83
	jp z, up_freq
	cp 0x86
	jp z, dn_freq
	cp 0x89
	jp z, def_freq

	cp 0x80
	jp z, def_vola

	cp 'S'
	jp z, scanner_key

	cp 'R'
	jp z, duplex_key

	cp 'K'
	jp z, step_audio_dst

	ret

menu_input:

	ld a, c
	cp 10
	jp c, insdig

	cp 'C'
	jp z, backspace
	cp 'E'
	jp z, toggle_or_position_menu
	cp '#'
	jp z, menu_enter_or_walk
	cp '*'
	jp z, menu_defval_or_exec
	cp '+'
	jp z, menu_up_value
	cp '-'
	jp z, menu_dn_value
	cp 'B'
	jp z, monitor_audio

	cp 0x81   ! XXX alphanumeric input
	cp 0x84
	cp 0x87

	cp 0x82
	cp 0x85
	cp 0x88

	cp 0x83
	cp 0x86
	cp 0x89
	cp 0x80

	cp 'S'
	jp z, menu_next_group

	cp 'R'
	jp z, menu_prev

	cp 'K'
	jp z, step_audio_dst

	ret

!----------------------------------------------------------------------

handle_key_during_tx:

	call clear_key

	! volume buttons step xmit power when transmitting

	cp '+'
	jp z, step_txpwr_up
	cp '-'
	jp z, step_txpwr_down

	! other buttons emit DTMF

	ld c, a
	ld a, [cu_is_alfa]
	or a
	ld a, c
	jp nz, dtmf_cu58af

	jp dtmf_bang_tone

!----------------------------------------------------------------------

execute:
	ld a, [scan_mode]
	or a
	jp nz, scanner_stop	! Just stop it, nothing else
	call 1f
	call save_nvdata
	ret
1:
	ld a, [key_time]
	or a
	jp nz, save_memory		! long press starting, go handle memories

	call is_key_down
	jr nz, 1b

	ld a, [digidx]
	cp 0
	jp z, next_vip          ! just #, no digits
	cp 3
	jp c, go_mem			! 1...2 digits
	cp 5
	call c, fill_implied	! if 3 or 4 digits, fix to abs.

	call a2i
	save_ahl(rx_freq)
	call leave_memories
	call remember_vip
	call changed_frequency
	ret

!----------------------------------------------------------------------

monitor_audio:

	! possibly enter repeater input

	load_ahl(rx_freq)
	push af
	push hl
	call compare_tx_rx_freq
	push af                 ! Remember to re-swap rx/tx if needed
	jp z, 1f				! Simplex. No channel change

	load_ahl(tx_freq)
	save_ahl(rx_freq)
	call temporary_change_rx_freq
1:
	ld a, [squelch_forced]     ! remember which way it was
	ld c, a
	call force_squelch         ! anyways it is open when button down

	! wait button release, note if over 1 sec down.

	ld b, 0                 ! assume "quick"
1:
	push bc
	call redraw
	pop bc
	ld a, [key_time]
	or b
	ld b, a                 ! now maybe long
	call is_key_down
	jr nz, 1b

	! close squelch if long press, toggle if short. We opened it above, so
	! close squelch if long press _or_ it was already forced

	ld a, b            ! NZ if long
	or c               ! NZ if forced already
	call nz, unforce_squelch

	! restore frequency if changed

	pop af
	pop hl
	pop bc
	jp z, 1f				! Simplex. No channel change
	ld a, b
	save_ahl(rx_freq)
	call temporary_change_rx_freq
1:
	ret


up_freq:
	call leave_memories
	call clear_buffer
	call scanner_stop
	jp step_channel_up

dn_freq:
	call leave_memories
	call clear_buffer
	call scanner_stop
	jp step_channel_down


def_sqlv:
	call clear_buffer
	call feedback_default
	call redraw
1:
	ld a, [key_time]
	cp 2
	jr nc, 1f			! set default
	call is_key_down
	jr nz, 1b

	ld a, [cfg_def_squelch]
	ld [cfg_squelch_level], a

	call unforce_squelch	! Adjusting opened sq removes hard open.
	ret
1:
	ld a, [cfg_squelch_level]
	ld [cfg_def_squelch], a

	call feedback_stored
	call waitkey
	ret

up_sqlv:
	call clear_buffer

	ld a, [cfg_squelch_level]
	add 1
	sbc 0
	ld [cfg_squelch_level], a
	call unforce_squelch	! Adjusting opened sq removes hard open.
	ret

dn_sqlv:
	call clear_buffer

	ld a, [cfg_squelch_level]
	sub 1
	adc 0
	ld [cfg_squelch_level], a
	call unforce_squelch	! Adjusting opened sq removes hard open.
	ret

up_vola:
	ld a, 1
	jr 1f
dn_vola:
	ld a, -1
	jr 1f
set_vola:
	ld a, 0
1:
	ld hl, volume
	add [hl]

set_vola_a:
	cp 10
	jr z, 1f		! 9 -> 10
	jr c, 2f		! 0 -> -1
	ld a, 0
	jr 2f
1:
	ld a, 9
2:
	ld [volume], a
	cp 0
	jr z, 1f
	cp 1
	jr z, 2f
	sub 2				! 9 - 2 -> 7
	and 7
	ld b, a
	di
	ld a, [output_0]
	and ~O0_VOLUME
	and ~O0_INH
	or b
	ld [output_0], a
	out [OUT0], a
	ld hl, sir
	set DTMFSIR, [hl]
	ei
	ret
1:
	di
	ld a, [output_0]
	and ~O0_VOLUME
	or O0_INH
	ld [output_0], a
	out [OUT0], a
	ld hl, sir
	set DTMFSIR, [hl]
	ei
	ret
2:
	di
	ld a, [output_0]
	and ~O0_VOLUME
	and ~O0_INH
	ld [output_0], a
	out [OUT0], a
	ld hl, sir
	set DTMFSIR, [hl]
	ei
	ret

!----------------------------------------------------------------------

fill_implied:

	! 3 or 4 digits, use implied for initial part of frequency

	ld de, digbuf + 5
	ld hl, digbuf + 2
	ld bc, 6
	ld a, [digidx]
	cp 3
	jr z, 1f
	inc hl
	ldd
1:
	ldd
	ldd
	ldd
	ld hl, cfg_implied
	ld de, digbuf
	ldir                ! 2 or 3 count in bc
	ld a, 6
	ld [digidx], a      ! abs. freq now

	ret

!----------------------------------------------------------------------

clear_buffer:
	push af
	ld a, 0
	ld [digidx], a
	pop af
	ret

clear_key:
	push af
	ld a, -1
	ld [key], a
	pop af
	ret

insdig:
	ld e, a

	ld a, [digidx]
	cp 16
	jr nc, 1f
	ld hl, digbuf
	ld b, 0
	ld c, a
	add hl, bc
	inc a
	ld [hl], e
	ld [digidx], a
1:
	call scanner_stop
	ret

backspace:
	call decoder_hist_rewind

	ld a, 0
	ld [vip_idx], a

	call scanner_stop
#if 0
	ld a, [digidx]
	sub 1
	adc 0
#else
	ld a, 0				! Brute force clear all
#endif
	ld [digidx], a
	ret

!----------------------------------------------------------------------

duplex_key:
	ld a, [digidx]
	cp 2
	jp c, step_duplex_state  ! too few digits, simplex/duplex/reverse
1:
	call redraw
	ld a, [key_time]
	cp 1
	jp nc, 1f
	call is_key_down
	jr nz, 1b
	jp step_duplex_state     ! quick press, simplex/duplex/reverse
1:
	call feedback_shift_neg
1:
	call redraw
	ld a, [key_time]
	cp 2
	jp nc, 1f
	call is_key_down
	jr nz, 1b
	jp set_duplex_shift_neg ! longer press, temp. duplex shift override
1:
	call feedback_shift_pos
1:
	call redraw
	ld a, [key_time]
	cp 3
	jp nc, 1f
	call is_key_down
	jr nz, 1b
	jp set_duplex_shift_pos ! longer press, temp. duplex shift override
1:
	call feedback_split
	call waitkey
	jp set_tx_freq     ! even longer press, temp. tx freq override


beep_or_fsk_send:
	ld a, [digidx]
	or a
	jp nz, send_call_packet

	jp beep1750               ! No digits, repeater beep

!----------------------------------------------------------------------

scanner_key:
1:
	call redraw
	ld a, [key_time]
	cp 1
	jp nc, 1f
	call is_key_down
	jr nz, 1b
	jp scanner_start
1:
	call feedback_reject
1:
	call redraw
	ld a, [key_time]
	cp 2
	jp nc, 1f
	call is_key_down
	jr nz, 1b
	jp add_reject
1:
	call feedback_cleared
	call waitkey
	jp clear_rejects

!----------------------------------------------------------------------

def_vola:
	call clear_buffer

	call feedback_default
	call waitkey

	ld a, [cfg_def_volume]
	jp set_vola_a

def_memo:
	call clear_buffer
	call scanner_stop

	call feedback_default
	call waitkey

	ld a, [cfg_def_memory]
	jp go_mem_a

def_freq:
	call clear_buffer
	call scanner_stop

	call feedback_default
	call waitkey

	call leave_memories
	load_ahl(cfg_def_frequency)
	save_ahl(rx_freq)
	jp changed_frequency

	! tx_freq - rx_freq into ahl and CY and Z

compare_tx_rx_freq:
	load_ahl(tx_freq)
	sub_ahl_de(rx_freq)     ! tx - rx
	ret c                   ! CY set, Z clear
	ld e, a                 ! result in ahl
	or l
	or h
	ld a, e
	ret                     ! CY clear, Z valid

!======================================================================
!
!  Push current memory/frequency
!  into vip_list, forgetting oldest record.
!  Duplicates raise into head of list.
!
remember_vip:

	ld ix, vip_list
	ld b, VIP_COUNT

	load_ahl(rx_freq)
	ex de, hl
	ld c, a
	ld a, [mem_flags]
	and MEM_VALID
	jp z, 1f  ! on "vfo"
	ld a, [mem_idx]
	ld e, a   ! on memories
	ld d, 0
	ld c, 0
1:
	! Push CDE to vips
2:
	ld l, [ix+0]      ! next in list
	ld h, [ix+1]
	ld a, [ix+2]
	ld [ix+0], e      ! replaced by new
	ld [ix+1], d
	ld [ix+2], c
	ld e, l           ! flip for next round
	ld d, h
	ld c, a
	ld a, [vip_list+0]
	cp e
	jr nz, 1f
	ld a, [vip_list+1]
	cp d
	jr nz, 1f
	ld a, [vip_list+2]
	cp c
	jr nz, 1f
	ret               ! overwrote duplicate, leave rest.
1:
	inc ix
	inc ix
	inc ix
	djnz 2b
	ret

next_vip:

	ld a, [vip_idx]
	ld c, a
	inc a
	cp VIP_COUNT
	jr c, 1f
	ld a, 0
1:
	ld [vip_idx], a

	ld hl, vip_list
	ld b, 0
	add hl, bc
	add hl, bc
	add hl, bc

	push hl
	pop ix

	load_ahl_ix_0
	or h
	jp nz, 1f     ! larger than 255, must be frequency
	ld a, l
	jp go_mem_a   ! a memory else
1:
	load_ahl_ix_0
	save_ahl(rx_freq)
	call leave_memories
	jp changed_frequency

!----------------------------------------------------------------------

is_freq_rejected:
	ld c, a        ! CHL has freq
	ld ix, rejects
	ld b, 10
2:
	ld a, l
	cp [ix + 0]
	jr nz, 1f
	ld a, h
	cp [ix + 1]
	jr nz, 1f
	ld a, c
	cp [ix + 2]
	jr nz, 1f
	ret            ! Z - rejected
1:
	inc ix         ! flags not harmed
	inc ix
	inc ix
	djnz 2b        ! flags not harmed
	ret            ! NZ - not rejected

!----------------------------------------------------------------------

clear_rejects:
	ld b, 10 * SIZE_FREQ
	ld a, 0
	ld hl, rejects
1:
	ld [hl], a
	inc hl
	djnz 1b
	ret

add_reject:
	ld a, [reject_idx]
	inc a
	cp 10
	jr c, 1f
	ld a, 0
1:
	ld [reject_idx], a
	ld c, a
	ld b, 0
	ld ix, rejects
	add ix, bc
	add ix, bc
	add ix, bc

	ld iy, rx_freq     ! reject current rx frequency
	ld a, [scan_mode]
	or a
	jr z, 1f
	ld iy, vip_list    ! when scanning use vip[0] instead
1:
	ld a, [iy + 0]
	ld [ix + 0], a
	ld a, [iy + 1]
	ld [ix + 1], a
	ld a, [iy + 2]
	ld [ix + 2], a

	ld hl, scan_do_step
	ld [scanner_state], hl

	ret

!----------------------------------------------------------------------
!
!  Called from mainloop, enters scanner in [scanner_state]
!  scanner_ret updates [scanner_state] for next call.

scanner_run:
	ld a, [scan_mode]
	or a
	ret z
	ld hl, [scanner_state]
	push hl
	ret
scanner_ret:
	pop hl
	ld [scanner_state], hl
	ret

scanner_start:
	call unforce_squelch

	ld hl, scan_do_step
	ld [scanner_state], hl

	call draw_scanner_icon

	ld a, [digidx]
	or a
	jr z, 1f
	call a2i_byte
	or a
	jr z, 2f
	ld [scan_mode], a
	ld [last_scan], a
	ret
1:
	ld a, [scan_mode]
	or a
	ret nz
2:
	ld a, [last_scan]
	or a
	jr nz, 1f
	ld a, 1
1:
	ld [scan_mode], a
	ld [last_scan], a
	ret

scanner_stop:
	ld a, [scan_mode]
	or a
	ret z

	ld a, 0
	ld [scan_mode], a
	ld [scan_mute], a

	call clear_scanner_icon

	ld a, 0
	ld [vip_idx], a
	call next_vip
	ret


scan_bad:
	call scanner_stop
	call scanner_ret

scan_do_step:

	ld a, 0
	ld [scan_oops], a

scan_do_step_again:

	ld a, 1
	ld [scan_mute], a

	ld a, [scan_oops]
	dec a
	ld [scan_oops], a
	jp z, scan_bad

	ld a, [scan_mode]             ! XXX
	cp 2
	jp z, scan_next_simplex

	jp scan_next_simplex

step_channel_up:
	load_ahl(rx_freq)
	ld de, [band_step_hz]
	add hl, de
	adc 0
	save_ahl(rx_freq)        ! XXX align stepping into current band
	jp changed_frequency

step_channel_down:
	load_ahl(rx_freq)
	ld de, [band_step_hz]
	and a
	sbc hl, de
	sbc 0
	save_ahl(rx_freq)        ! XXX align stepping into current band
	jp changed_frequency

scan_next_simplex:
	call step_channel_up

	sub_ahl_de(cfg_band1_end)
	jr c, 1f
	load_ahl(cfg_band1_start)
	save_ahl(rx_freq)
1:
	jp scan_currfreq

scan_currfreq:

	ld a, 0
	ld [mem_flags], a

	call changed_frequency

	jp scan_do_wait

scan_next_memory:

	ld e, 101
	ld a, [mem_idx]
2:
	dec e
	jp z, scan_bad
	inc a
	cp 100
	jr c, 1f
	ld a, 0
1:
	ld d, a
	call get_mem_flags
	and MEM_VALID | MEM_SCANNABLE
	cp  MEM_VALID | MEM_SCANNABLE
	ld a, d
	jr nz, 2b

	call go_mem_a			! Next memory

	jp scan_do_wait

! like squelch_open 1/0, but disregards hysteresis and squelch slowness

is_sql_over_level:
	call read_squelcher_value
	ld b, a
	ld a, [cfg_squelch_level]
	cp b                     ! limit - value, CY if value > limit
	ret

scan_do_wait:

	call is_freq_rejected
	jp z, scan_do_step_again

	! step wait --------------

	ld a, [squelch_open]
	or a
	ld a, [cfg_scan_rate]	! Wait time
	jr z, 1f
	add a					! Make it double long if channel is busy.
	jr nc, 1f
	ld a, 255
1:
	ld [scan_timer], a
1:
	call scanner_ret

	ld a, [scan_timer]
	or a
	jr nz, 1b				! The wait.

	! after step wait, look around --------------

	ld a, [squelch_forced]
	or a
	jp nz, 2f				! Squelch manually forced open, act as if signal.

	call is_sql_over_level
	jp nc, scan_do_step		! No signal. Next.

	call remember_vip
2:
	call redraw
	call get_scan_patience
	ld [scan_patience], a	! Stay N seconds with or without signal.

#ifdef RD58

	ld a, [scan_skip_fsk_channels]
	or a
	jp z, 1f

	in a, [MDM + MDMCTRL]
	and MDM_DCD
	jp nz, scan_do_step
1:
#endif

1:
	call scanner_ret

	ld a, [scan_patience]
	or a
	jp z, scan_do_step		! Lost patience. Next.

	ld a, 0
	ld [scan_mute], a		! Open audio.

	ld a, [squelch_forced]
	or a
	jr nz, 2b				! Squelch forced open. Stay forever and 15 sec more.
	ld a, [squelch_open]
	or a
	jr nz, 1b				! There is signal. Stay.

	call get_scan_tail
	ld [scan_timer], a		! Stay N seconds without signal.
2:
	call scanner_ret

	ld a, [squelch_open]
	or a
	jr nz, 1b				! Again signal. Keep listening.

	ld a, [scan_timer]
	or a
	jr nz, 2b				! No signal for 1 sec...

	jp scan_do_step			! ... so Next.

!======================================================================
! 
!  FSK stuff

fskcheck:
	ld a, [packet_rdy]
	or a
	ret z
	call packet_for_whom
	ld a, 0
	ld [packet_rdy], a		! Ignores quick successive packets
	ret

init_modem:
	!
	!  Initialize NMT modem
	!

	ld a, 0x04
	out [MDM + MDMCTRL], a		! Write 04 to control register

	ld hl, 10000
1:
	out [WD], a

	dec hl
	ld a, h
	or l
	jr nz, 1b					! Wait at least 1 bit.

	ld a, 0x00
	out [MDM + MDMCTRL], a		! Write zeros to control register

	ret

enable_modem:
	!  Enable modem receiver

	ld a, MDM_RXENB
	out [MDM + MDMCTRL], a
	ret

packet_for_whom:
	ld a, [packet_good]
	add 6                 ! destination address offset
	ld l, a
	ld h, HI(fsk_history)
	ld ix, cfg_mycall_1

	ld a, [hl]; inc l; cp [ix + 0]; ret nz
	ld a, [hl]; inc l; cp [ix + 1]; ret nz
	ld a, [hl]; inc l; cp [ix + 2]; ret nz
	ld a, [hl]; inc l; cp [ix + 3]; ret nz
	ld a, [hl]; inc l; cp [ix + 4]; ret nz

	ld a, 1
	ld [call_dpyed], a

	call cu_lights_on
	call cu_call_on
	call redraw
	call ding
	ret

send_call_packet:

	call tx_on
	jp c, tx_error

	di
	ld a, [output_0]
	and ~O0_CCIRC
	or O0_MICM
	ld [output_0], a
	out [OUT0], a
	ei

	call waitkey

	call build_packet_buffer
	call append_packet_crc

	call send_packet_buffer
	call mdm_delay
	call send_packet_buffer
	call mdm_delay
	call send_packet_buffer

	call tx_off
	call clear_buffer

	ret

build_packet_buffer:

	ld hl, digbuf
	ld a, [digidx]
	ld b, a
	cp 1
	jr nz, 1f
	ld a, [hl]
	cp 0
	ret z				! 0* = send it again
1:
	ld de, outpacket
	ld ix, cfg_mycall_1
	ld a, 0xC0;           or [ix + 0]; ld [de], a; inc de
	ld a, [ix + 1]; sla4; or [ix + 2]; ld [de], a; inc de
	ld a, [ix + 3]; sla4; or [ix + 4]; ld [de], a; inc de
	ld c, 3
1:
	inc c
	ld a, [hl]
	inc hl
	sla a; sla a; sla a; sla a
	or 0xF
	ld [de], a
	inc de
	dec b
	jr z, 1f
	and 0xF0
	or [hl]
	inc hl
	dec de
	ld [de], a
	inc de
	dec b
	jr z, 1f
	ld a, c
	cp SIZE(outpacket) - 2
	jr nz, 1b
1:
	ld a, c
	cp SIZE(outpacket) - 2
	jr z, 1f
	ld a, 0xFF
	ld [de], a
	inc de
	inc c
	jr 1b
1:
	ret

!----------------------------------------------------------------------
!
!  crc = crchi ^ crc16_table[crclo ^ c]
!
#define INIT_CRC(pkt)	\
	ld b, 0xFF			;\
	ld a, 0xFF			;\
	ld ix, pkt			;

#define ADD_CRC(n)		\
	ld h, HI(crctbls)	;\
	xor [ix + (n)]		;\
	ld l, a				;\
	ld a, b				;\
	ld b, [hl]			;\
	inc h				;\
	xor [hl]			;

append_packet_crc:

	INIT_CRC(outpacket)

	ADD_CRC(0)
	ADD_CRC(1)
	ADD_CRC(2)
	ADD_CRC(3)
	ADD_CRC(4)
	ADD_CRC(5)

	cpl
	ld [ix + 7], a
	ld a, b
	cpl
	ld [ix + 6], a

	ret

	! af bc de hl ix allowed to changed

check_packet:

	INIT_CRC(packet)

	ADD_CRC(0)
	ADD_CRC(1)
	ADD_CRC(2)
	ADD_CRC(3)
	ADD_CRC(4)
	ADD_CRC(5)

	cpl
	cp [ix + 7]
	ret nz
	ld a, b
	cpl
	cp [ix + 6]
	ret nz

	ld a, [fsk_hist_idx]
	ld [packet_good], a
	ld l, a
	ld h, HI(fsk_history)

#define STASH(_a) \
	ld a,[_a]; ld b,a; srl4; ld [hl],a; inc l; ld a,b; and 15; ld [hl],a; inc l
	STASH(ix+0)
	STASH(ix+1)
	STASH(ix+2)
	STASH(ix+3)
	STASH(ix+4)
	STASH(ix+5)
#undef STASH

	ld a, ' '
	ld [hl], a
	ld a, l
	ld [fsk_hist_finger], a  ! reposition viewing also, over blank
	inc a
	ld [fsk_hist_idx], a     ! insert point after blank
	ld a, 1
	ld [packet_rdy], a
	ret

send_packet_buffer:

	ld a, MDM_TXENB
	out [MDM + MDMCTRL], a

	ld hl, nosir
	set 0, [hl]

	ld hl, packet_header
	ld b, packet_header_size
	call send_some_data

	ld hl, outpacket
	ld b, SIZE(outpacket)
	call send_some_data

	ld hl, nosir
	res 0, [hl]

	call mdm_delay
1:
	in a, [MDM + MDMCTRL]
	and MDM_TXIDL
	jr z, 1b

	ld a, MDM_RXENB
	out [MDM + MDMCTRL], a

	ret

packet_header:
	.byte 0b10101010
	.byte 0b10101010
	.byte 0b10101010
	.byte 0b10101010
	.byte 0b10101010
	.byte 0b11000100
	.byte 0b11010111
packet_header_size = . - packet_header

send_some_data:
1:
	call mdm_delay
	in a, [MDM + MDMCTRL]
	and MDM_TXRDY
	jr z, 1b
	ld a, [hl]
	inc hl
	out [MDM + MDMDATA], a
	djnz 1b
	ret

mdm_delay:
	nop; nop; nop; nop; nop
	nop; nop; nop; nop; nop
	nop; nop; nop; nop; nop
	nop; nop; nop; nop; nop
	nop; nop; nop; nop; nop
	ret

!======================================================================

save_memory:
	ld a, [digidx]
	or a
	jr nz, 1f
	ld a, [mem_idx]
	jr 2f
1:
	call a2i_byte
2:
	cp 130
	jr c, 1f
	ld a, 99
1:

	ld [mem_idx], a

	ld a, MEM_VALID | MEM_SCANNABLE
	ld [mem_flags], a
	call redraw
7:
	ld a, [mem_flags]
	ld b, a
	ld a, [key_time]
	cp 2
	jr c, 1f
	ld b, MEM_VALID       ! 2-long
1:
	ld a, [key_time]
	cp 3
	jr c, 1f
	ld b, MEM_VALID | MEM_HIDDEN  ! 3-long
1:
	ld a, [mem_flags]
	cp b
	jr z, 1f
	ld a, b
	ld [mem_flags], a
	call redraw
1:
	call is_key_down
	jr nz, 7b            ! keep waiting

	call point_ix_memory

	load_ahl(rx_freq)
	save_ahl_ix_0
	load_ahl(tx_freq)
	save_ahl_ix_3
	ld a, [mem_flags]
	ld [ix + 6], a

	ld a, 0
	ld [ix + 7], a
	ld [ix + 8], a
	ld [ix + 9], a
	ld [ix + 10], a
	ld [ix + 11], a

	call save_nvdata
	ret

! up down memories from "vfo", just go back to last memory

maybe_just_reenter_last:
	call clear_buffer
	call scanner_stop
	ld a, [mem_flags]
	cp 0
	ret nz                   ! NZ, already on memories
	call get_mem_flags
	and MEM_VALID | MEM_HIDDEN
	cp  MEM_VALID            ! Z if okay this
	ld a, [mem_idx]          ! ... last memory
	ret                      ! and Z condition

up_memo:
	call maybe_just_reenter_last
	jp z, go_mem_a
	ld e, 132
2:
	dec e
	jr z, 8f
	ld a, [mem_idx]
	inc a
	cp 130
	jr c, 1f
	ld a, 0
1:
	ld [mem_idx], a
	call get_mem_flags
	and MEM_VALID | MEM_HIDDEN
	cp  MEM_VALID
	jr nz, 2b

	ld a, [mem_idx]
	jp go_mem_a
8:
	ld a, 0
	ld [mem_flags], a
	ret

dn_memo:
	call maybe_just_reenter_last
	jp z, go_mem_a
	ld e, 132
2:
	dec e
	jr z, 8f
	ld a, [mem_idx]
	dec a
	cp 130
	jr c, 1f
	ld a, 129
1:
	ld [mem_idx], a
	call get_mem_flags
	and MEM_VALID | MEM_HIDDEN
	cp  MEM_VALID
	jr nz, 2b

	ld a, [mem_idx]
	jp go_mem_a
8:
	ld a, 0
	ld [mem_flags], a
	ret

go_mem:
	call a2i_byte
	call go_mem_a
	call remember_vip
	ret

!======================================================================

point_ix_memory:
	ld a, [mem_idx]
point_ix_memory_a:
	cp 130
	jr c, 1f
	ld a, 99
1:
	ld h, 0
	ld l, a
	add hl, hl      ! *= 2
	add hl, hl      ! *= 4
	push hl
	pop bc
	add hl, hl      ! *= 8
	add hl, bc
	ld bc, memories
	add hl, bc
	push hl
	pop ix
	ret

go_mem_a:
	cp 130
	jr c, 1f
	ld a, 99
1:
	ld [mem_idx], a
	call point_ix_memory_a

	load_ahl_ix_0
	save_ahl(rx_freq)
	load_ahl_ix_3
	save_ahl(tx_freq)
	ld a, [ix + mem_FLAGS]
	or MEM_VALID
	ld [mem_flags], a

	call set_duplex_from_tx_rx
	jp changed_frequency_duplex_okay

get_mem_flags:
	call point_ix_memory
	ld a, [ix + mem_FLAGS]
	ret

leave_memories:
	ld a, 0
	ld [mem_flags], a
	ret

!----------------------------------------------------------------------

pttcheck:
	ld a, [pttdn]
	or a
	ret z

	call cu_manipulated

	call tx_on
	jp c, tx_error

	call ctcss_maybe

	ld a, [digidx]			! CCIR if digits, then /PTT down
	or a
	call nz, ptt_ccir_xmit

	di
	ld a, [output_0]
	and ~(O0_CCIRC | O0_MICM)	! No tones, no mic mute
	ld [output_0], a
	out [OUT0], a
	call silence_timer1
	ei

	call battcheck
	call redraw
	ld a, [ad_batt]
	ld e, a
1:
	ld a, [ad_batt]
	sub e
	jr z, 2f
	cp 1
	jr z, 2f
	cp -1
	jr z, 2f
	call battcheck
	call redraw
	ld a, [ad_batt]
	ld e, a
2:
	push de
	ld a, [key]			! keys pressed after /PTT ?
	cp -1
	call nz, handle_key_during_tx
	call is_key_down
	call z, stop_dtmf_tone
	pop de
	ld a, [pttdn]
	or a
	jp nz, 1b

	call tx_off
	call stop_dtmf_tone
	call redraw

	call remember_vip
	ret

tx_error:
	ld hl, MT_300HZ
	ld d, 100
	call start_marker_tone
1:
	call waitkey
	ld a, [pttdn]
	or a
	jr nz, 1b

	ret

!----------------------------------------------------------------------

beep1750:

	call tx_on
	jp c, tx_error

	call battcheck
	di
	ld a, 0
	ld [mt_timer], a

	ld a, LO(MT_1750HZ)
	out [TMR + 1], a
	ld a, HI(MT_1750HZ)
	out [TMR + 1], a

	ld a, [output_0]
	or O0_CCIRC | O0_MICM
	ld [output_0], a
	out [OUT0], a
	ei

	call waitkey

	di
	ld a, [output_0]
	and ~(O0_CCIRC | O0_MICM)
	ld [output_0], a
	out [OUT0], a
	call stop_marker_tone
	ei

	call tx_off

	ret

!----------------------------------------------------------------------

ptt_ccir_xmit:

	call redraw

	di
	call silence_timer1
	ld a, [output_0]
	push af
	and ~O0_VOLUME
	or O0_MICM
	ld [output_0], a
	out [OUT0], a
	ld a, 20			! 10 ms systicks, 200 ms silence before ccir
	ld [ccir_tx_timer], a
	ei
3:
	ld a, [ccir_tx_timer]
	or a
	jr nz, 3b

	di
	ld a, [output_0]
	or O0_CCIRC | O0_MTC | O0_AUDIOC
	ld [output_0], a
	out [OUT0], a
	ei

	ld ix, digbuf		! Start of digits
	ld a, [digidx]
	ld b, a				! Digit count
	ld c, -1			! Prev digit
	ld d, 0				! MSB of hl offset
1:
	ld a, [ix]			! Pick a digit
	inc ix
	cp c
	jr nz, 3f
	ld a, 0xE
3:
	ld c, a
	ld e, a
	sla e				! two bytes per record in table
	ld hl, ccirtbl
	add hl, de
	di
	ld a, [hl]
	inc hl
	out [TMR + 1], a
	ld a, [hl]
	out [TMR + 1], a
	ld a, 10			! 10 ms systicks
	ld [ccir_tx_timer], a
	ei
3:
	ld a, [ccir_tx_timer]
	or a
	jr nz, 3b

	djnz 1b				! foreach digit

	di
	ld a, [output_0]
	and ~(O0_CCIRC | O0_MTC | O0_AUDIOC)
	ld [output_0], a
	out [OUT0], a
	call silence_timer1
	ld a, 10
	ld [ccir_tx_timer], a
	ei
3:
	ld a, [ccir_tx_timer]
	or a
	jr nz, 3b			! add one 100msec of silence for sure

	di
	pop af
	ld [output_0], a
	out [OUT0], a
	ei					! restored port 0

	ret

!----------------------------------------------------------------------

step_txpwr_up:
	ld a, [cfg_txpwr]
	add 26
	jr nc, 1f
	ld a, 0xFF
1:
	ld [cfg_txpwr], a
	out [DA_TXPWR], a
	jp redraw

step_txpwr_down:
	ld a, [cfg_txpwr]
	sub 26
	jr nc, 1f
	ld a, 0
1:
	ld [cfg_txpwr], a
	out [DA_TXPWR], a
	jp redraw

!======================================================================
!
!	Powerdown
!
powerdown:
	di
	ld a, O1_TXOFF
	out [OUT1], a
	ld a, PB_PWROFF
	out [PIO+BDATA], a
	halt
	jp powerdown

!----------------------------------------------------------------------
!
!	MBUS putchar, character in c
!

putchar:
	ld hl, mbustx_cnt
1:
	ld a, [hl]
	inc a
	jr z, 1b				! wait until not full
	di
	ld a, [hl]
	inc [hl]
	or a
	jr z, putchar_start		! tx not active, go start it
	ld hl, [mbustx_wp]
	ld [hl], c
	inc l
	ld [mbustx_wp], hl
	ei
	ret
putchar_start:
	ld a, c
	out [SIO+BDATA], a
	ld a, 25
	ld [mbus_timer], a
	ei
	ret

iputc:
	push af
	ld a, [mbustx_cnt]
	inc a
	jr z, 1f				! full
	ld [mbustx_cnt], a
	dec a
	jr z, 2f				! tx not active, go start it
	pop af
	push hl
	ld hl, [mbustx_wp]
	ld [hl], a
	inc l
	ld [mbustx_wp], hl
	pop hl
	ret
1:
	pop af
	ret
2:
	pop af
	out [SIO+BDATA], a
	ld a, 25
	ld [mbus_timer], a
	ret


getchar:
	ld hl, mbusrx_cnt
	ld a, [hl]
	or a
	jr z, getchar
	di
	dec [hl]
	ld hl, [mbusrx_rp]
	ld a, [hl]
	inc l
	ld [mbusrx_rp], hl
	ei
	ret

!======================================================================

keypad:

	ld a, [cu_is_alfa]
	or a
	jp z, 1f

	call keypad_cu58af
	ret z

	push af
	ld a, 0
	ld [key_timer], a
	ld [key_time], a
	call cu_manipulated
	call blip
	pop af

	jp 2f
1:

	ld a, 0					! CU53AN then
	ld [key_timer], a
	ld [key_time], a

	call cu_manipulated
	call blip

	!
	!	strobe the data into shifter
	!
	ld a, O2_KEYPAD
	out [OUT2], a
	ld a, O2_KEYPAD | O2_CLK
	out [OUT2], a
	ld a, O2_KEYPAD
	out [OUT2], a
	ld a, O2_LCD1
	out [OUT2], a

	in a, [PIO+BDATA]		! from LDR
	and PB_DCU
	ld [dark], a

	!
	!	shift 5 keycode bits to l
	!
	ld c, 0		! collect bits here
	ld b, 5		! this many
1:
	ld a, O2_LCD1 | O2_CLK
	out [OUT2], a
	ld a, O2_LCD1
	out [OUT2], a
	in a, [PIO+BDATA]
	and PB_DCU
	sub 1
	rl c
	djnz 1b

	ld hl, keytbl_cu53an ! table
	add hl, bc           ! b is already 0 from djnz
	ld a, [hl]			 ! map code to character

2:

	! common again for CU53 and CU58

	ld [lastkey], a

	cp '*'
	jr nz, 2f
1:
	ld [key], a			! * does not repeat
	ret
2:
	cp 10				! digit ?
	jr nc, 1f
						! Yes, downtime determines 0..9 or function.
	ld [lastdigit], a

	ld a, [txon]
	or a
	ld a, [lastdigit]
	jr nz, 1b			! TX on, digits are DTMF. No repeat

	cp 1
	jr z, 2f
	cp 4
	jr z, 2f

	cp 7
	jr z, 3f
	cp 8
	jr z, 3f
	cp 9
	jr z, 3f
	cp 0
	jr z, 3f

	ld a, 255			! 2356 memory/freq adjust
	ld [key_blips], a
	ld a, 50
	ld [key_timer], a
	ld a, 33
	ld [key_speed], a
	ret
3:
	ld a, 2				! 7890 default buttons
	ld [key_blips], a
	ld a, 50
	ld [key_timer], a
	ld a, 100
	ld [key_speed], a
	ret
2:
	ld a, 8				! 14 squelch adjust
	ld [key_speed], a
	ld a, 50
	ld [key_timer], a
	ld a, 1
	ld [key_blips], a
	ret
1:
	ld [key], a

	cp '+'
	jr z, 1f
	cp '-'
	jr z, 1f

	cp 'S'
	jr z, 2f
	cp 'R'
	jr z, 2f

	cp 'B'
	jr z, 3f

	ld a, 100
	ld [key_timer], a
	ld a, 100
	ld [key_speed], a
	ld a, 4
	ld [key_blips], a
	ret					! Not digit nor +/-
2:
	ld a, 100
	ld [key_timer], a
	ld a, 100
	ld [key_speed], a
	ld a, 2
	ld [key_blips], a
	ret
1:
	ld a, 50
	ld [key_timer], a
	ld a, 20
	ld [key_speed], a
	ld a, 255
	ld [key_blips], a
	ret
3:
	ld a, 100
	ld [key_timer], a
	ld a, 100
	ld [key_speed], a
	ld a, 1
	ld [key_blips], a
	ret

typematic:
	ld a, [key_speed]
	ld [key_timer], a
	ld a, [key_time]
	inc a
	jr z, 1f
	ld [key_time], a
1:
	ld a, [key_blips]
	or a
	jr z, 1f
	dec a
	ld [key_blips], a
	call blip
1:
	ld a, [lastkey]
	cp 10
	jr nc, 1f
	or 0x80			! Repeating digit is a function.
1:
	ld [key], a
	ld a, -1
	ld [lastdigit], a
	ret

!======================================================================
!
!  4032000 / N = LPF CLK     LP_3600HZ = 4032000 / 3600 / 100
!  4032000 / N = Hz * 100
!  4032000 / (Hz * 100) = N
!  40320 / Hz = N            Hz 2000....5000
!   2016 / (Hz / 20) = N     Hz/20 0...255

init_LPF:
	ld c, 20                 ! /= 20, scale Hz
	ld a, 0
	ld hl, [cfg_lpf_hz]      ! binary Hz in AHL
	ld [lpf_hz_now], hl
	call div248              ! Hz/20 in L (5100/20 = 255, max Hz)

	ld c, l                  ! /= (Hz/20)
	ld a, 0
	ld hl, 2016
	call div248

	ld a, TMR_0 | TMR_BOTH | TMR_SQWAVE
	out [TMR + TMRCTRL], a
	ld a, l
	out [TMR + 0], a
	ld a, h
	out [TMR + 0], a
	ret

update_LPF:
	ld ix, cfg_lpf_hz
	ld a, [lpf_hz_now + 0]
	cp [ix+0]
	jp nz, init_LPF
	ld a, [lpf_hz_now + 1]
	cp [ix+1]
	jp nz, init_LPF
	ret

!-------------------
!  marker and tx tones

init_timer1:
	ld a, TMR_1 | TMR_BOTH | TMR_SQWAVE
	out [TMR + TMRCTRL], a
	! and ...
silence_timer1:
	ld a, 0x04
	out [TMR + 1], a	! But it leaks anyway, highest possible
	ld a, 0x00
	out [TMR + 1], a	! tone causes the least harm... brrh.
	ret

blip:
	push hl
	ld hl, MT_600HZ
	ld d, 3
	call start_marker_tone

	pop hl
	ret

bleep:
	push hl
	ld hl, MT_300HZ
	ld d, 100
	call start_marker_tone

	pop hl
	ret

ding:

	push bc

	di
	call stop_marker_tone
	ld a, [output_0]
	push af
	and ~O0_AUDIOC
	out [OUT0], a
	and ~O0_INH
	out [OUT0], a
	or   O0_VOLUME
	out [OUT0], a
	ld [output_0], a
	ld a, 1
	ld [mton], a
	ei

	ld b, 5
2:
	push hl
	ld hl, MT_1200HZ
	ld d, 5
	call start_marker_tone
	pop hl
1:
	ld a, [mt_timer]
	or a
	jr nz, 1b

	push hl
	ld hl, MT_1400HZ
	ld d, 5
	call start_marker_tone
	pop hl
1:
	ld a, [mt_timer]
	or a
	jr nz, 1b

	djnz 2b

	di
	pop af
	ld [output_0], a
	out [OUT0], a
	ld a, 0
	ld [mton], a
	ei

	pop bc
	ret

!
!  Duration in 10ms in d, pitch in hl
!
start_marker_tone:

	ld a, 0
	ld [mt_timer], a

	ld a, l
	out [TMR + 1], a
	ld a, h
	out [TMR + 1], a	! pitch

	ld hl, output_0
	set O0_MTCBIT, [hl]

	ld a, d
	ld [mt_timer], a	! duration in 10ms units

	ret

stop_marker_tone:

	ld a, 0
	ld [mt_timer], a

	ld a, [output_0]
	and ~O0_MTC
	ld [output_0], a
	out [OUT0], a		! Cut tone from local audio

	call silence_timer1

	ret

!======================================================================

resync_squelch:
	di
	ld a, [squelch_forced]
	or a
	call nz, audioc_on
	ei
	ret

force_squelch:
	di
	ld a, 1
	ld [squelch_forced], a
	call audioc_on
	ei
	ret

unforce_squelch:
	di
	ld a, [squelch_open]
	or a
	call z, audioc_off
	ld a, 0
	ld [squelch_forced], a
	ei
	ret

close_squelch:
	ld a, [squelch_forced]
	or a
	ret nz						! Manually forced open.

	di
	call cu_serv_off
	call release_EXIN1

	ld a, 0
	ld [squelch_open], a
	ld a, [cfg_squelch_head]
	ld [squelch_delay], a

	call audioc_off
	ei
	ret

!======================================================================
!
!	Build up display buffer
!

!     PVQQSS
!   MM_-FFFFFF
!
!     PV_QQ_SS
!    MM-FFFFFF

redraw:

	ld a, 0
	ld [dpx_ind_flags], a

	call draw_upper_row
	call draw_lower_row
	call draw_dpx_ind

	ld hl, sir
	set DPYSIR, [hl]

	ret

!----------------------------------------------------------------------

light_on_led:
	ld hl, indicators
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	set CU53AN_BIT_ON, [hl]
	ret
1:
	set CU58AF_BIT_ON, [hl]
	ret

dim_transmit_led:
	ld hl, indicators
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	res CU53AN_BIT_ROAM, [hl]
	ret
1:
	res CU58AF_BIT_ROAM, [hl]
	ret

light_transmit_led:
	ld hl, indicators
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	set CU53AN_BIT_ROAM, [hl]
	ret
1:
	set CU58AF_BIT_ROAM, [hl]
	ret

cu_lights_on:
	ld a, 0
	ld [lights_timer], a
	ld a, [cfg_light_seconds]
	or a
	ret z
	ld hl, indicators
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	set CU53AN_BIT_LCDLIGHT, [hl]	! lit the lights.
	set CU53AN_BIT_KEYLIGHT, [hl]
	ret
1:
	set CU58AF_BIT_LCDLIGHT, [hl]	! lit the lights.
	set CU58AF_BIT_KEYLIGHT, [hl]
	ret

cu_lights_off:
	ld hl, indicators
	ld a, [cu_is_alfa]
	or a
	ld a, [hl]
	jr nz, 1f
	res CU53AN_BIT_LCDLIGHT, [hl]	! lit the lights.
	res CU53AN_BIT_KEYLIGHT, [hl]
	bit CU53AN_BIT_KEYLIGHT, a
	ret z
	jp redraw
1:
	res CU58AF_BIT_LCDLIGHT, [hl]	! lit the lights.
	res CU58AF_BIT_KEYLIGHT, [hl]
	bit CU58AF_BIT_KEYLIGHT, a
	ret z
	jp redraw

cu_serv_on:
	ld hl, indicators
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	set CU53AN_BIT_SERV, [hl]
	ret
1:
	set CU58AF_BIT_SERV, [hl]
	ret

cu_serv_off:
	ld hl, indicators
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	res CU53AN_BIT_SERV, [hl]
	ret
1:
	res CU58AF_BIT_SERV, [hl]
	ret

cu_call_on:
	ld hl, indicators
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	set CU53AN_BIT_CALL, [hl]
	ret
1:
	set CU58AF_BIT_CALL, [hl]
	ret

cu_call_off:
	ld hl, indicators
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	res CU53AN_BIT_CALL, [hl]
	ret
1:
	res CU58AF_BIT_CALL, [hl]
	ret

draw_scanner_icon:
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	segset_hl(CU53AN_SEG_CAR_U)
	ret
1:
	segset_hl(CU58AF_SEG_CAR)
	ret

clear_scanner_icon:
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	segres_hl(CU53AN_SEG_CAR_U)
	ret
1:
	segres_hl(CU58AF_SEG_CAR)
	ret

draw_upper_colons:
	ld a, [cu_is_alfa]
	or a
	ret nz
	segset_hl(CU53AN_SEG_COLON_UL)
	segset_hl(CU53AN_SEG_COLON_UR)
	ret

clear_upper_colons:
	ld a, [cu_is_alfa]
	or a
	ret nz
	segres_hl(CU53AN_SEG_COLON_UL)
	segres_hl(CU53AN_SEG_COLON_UR)
	ret

draw_lower_colon:
	ld a, [cu_is_alfa]
	or a
	ret nz
	segset_hl(CU53AN_SEG_COLON_D)
	ret

clear_lower_colon:
	ld a, [cu_is_alfa]
	or a
	ret nz
	segres_hl(CU53AN_SEG_COLON_D)
	ret

draw_clock_icon:
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	segset_hl(CU53AN_SEG_CLOCK)
	ret
1:
	segset_hl(CU58AF_SEG_EXP)
	ret

clear_clock_icon:
	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	segres_hl(CU53AN_SEG_CLOCK)
	ret
1:
	segres_hl(CU58AF_SEG_EXP)
	ret

draw_squelch_ind:
	ld a, [cu_is_alfa]
	or a
	jp nz, 1f
	ld a, [squelch_forced]
	or a
	jr nz, 2f
	segres_hl(CU53AN_SEG_STAR)
	ret
2:
	segset_hl(CU53AN_SEG_STAR)
	ret
1:
	ld a, [squelch_forced]
	or a
	ld a, ' '
	jr z, 2f
	ld a, '*'
2:
	call dpydig
	ret

draw_dpx_ind:

	ld a, [cu_is_alfa]
	or a
	ld a, [dpx_ind_flags]
	jp nz, 3f
	bit 0, a
	jr z, 1f
	segset_hl(CU53AN_SEG_V_D)
	jr 2f
1:
	segres_hl(CU53AN_SEG_V_D)
2:
	bit 1, a
	jr z, 1f
	segset_hl(CU53AN_SEG_V_U)
	jr 2f
1:
	segres_hl(CU53AN_SEG_V_U)
2:
	ret
3:
	bit 0, a
	jr z, 1f
	segset_hl(CU58AF_SEG_ARROW0)
	jr 2f
1:
	segres_hl(CU58AF_SEG_ARROW0)
2:
	bit 1, a
	jr z, 1f
	segset_hl(CU58AF_SEG_ARROW3)
	jr 2f
1:
	segres_hl(CU58AF_SEG_ARROW3)
2:
	ret

!----------------------------------------------------------------------

draw_upper_row:

	ld de, CU53AN_segs_u_digit_5
	ld a, [cu_is_alfa]
	or a
	jr z, 1f
	ld de, CU58AF_segs_u_digit_7
1:

	ld a, [menu_active]
	or a
	jp nz, draw_menu_title

	call draw_upper_colons

	! txpwr volume squelch rssi

	ld a, [cfg_txpwr]             ! txpwr 0..255 into 0..9
	call dpydiv9

	ld a, [volume]               ! volume
	call dpydig

	ld a, [cu_is_alfa]           !  audio whereto if alfa handset
	or a
	jr z, 2f
	ld a, [audio_dst]
	cp 1
	ld l, '>'
	jr z, 1f
	cp 2
	ld l, '<'
	jr z, 1f
	ld l, ' '
1:
	ld a, l
	call dpydig
2:

	ld a, [cfg_squelch_level]    ! squelch setting 0..255 into 0..99
	call dpydiv99

	call draw_squelch_ind        ! icon or a star character to cursor++

	ld a, [txon]                 ! srssi or txpwr
	or a
	ld a, [srssi]
	jr z, 1f
	ld a, [cfg_txpwr]
1:
	call dpydiv99

	ret                          ! upper row complete

!----------------------------------------------------------------------

draw_digit_buffer:
	ld ix, digbuf
	ld a, [digidx]
	cp 10				! positions max
	jr c, 1f
	ld a, 10
1:
	ld b, a				! to show
	neg
	add 10
	ld c, a				! to blank
1:
	ld a, [ix]
	inc ix
	call dpydig
	djnz 1b

	ld a, c
	or a
	ret z              ! no blanks needed
	ld b, a
1:
	ld a, ' '
	call dpydig
	djnz 1b

	ret

!----------------------------------------------------------------------

draw_memory_info:

	ld a, [mem_flags]
	and MEM_VALID
	jp nz, 1f
	ld a, ' '           ! blank out memory info digits
	call dpydig
	ld a, ' '
	call dpydig
	ld a, ' '           ! and status blanked
	jp dpydig           ! and ret
1:
	!  Active memory exists

	ld a, [mem_idx]
	call dpyval99         ! memory number, 2 digits

	ld b, '='
	ld a, [mem_flags]
	and MEM_HIDDEN
	jr nz, 1f             ! = if hidden set
	ld b, '-'
	ld a, [mem_flags]
	and MEM_SCANNABLE
	jr z, 1f              ! - if scannable clear
	ld b, ' '
1:
	ld a, b
	jp dpydig				! memory status

set_dpx_ind_from_rx_tx_freq:
	push de
	call compare_tx_rx_freq
	pop de
	ret z                 ! tx = rx
	ld a, 2
	jp nc, 1f   ! tx above
	ld a, 1     ! tx below
1:
	ld [dpx_ind_flags], a
	ret

!----------------------------------------------------------------------

no_feedback:
	ld iy, 0
	push iy
2:
	pop iy
	ld [adj_feedback], iy
	ret

feedback_reject:
	call 2b
	.ascii " rEJECtEd "

feedback_cleared:
	call 2b
	.ascii "  CLEArEd "

feedback_default:
	call 2b
	.ascii "  dEFAULt "

feedback_stored:
	call 2b
	.ascii "   StorEd "

feedback_shift_neg:
	call 2b
	.ascii "SHIFt NEG "

feedback_shift_pos:
	call 2b
	.ascii "SHIFt POS "

feedback_split:
	call 2b
	.ascii "FrEq SPLIt"

feedback_let_go_the_darn_button:
	call 2b
	.ascii "ALLrIGHt  "


draw_adjust_feedback:
	ld b, 10
	ld a, [cu_is_alfa]
	or a
	jp z, 1f
	ld b, 9        ! sorry
1:
	ld a, [hl]
	inc hl
	push hl
	call dpydig
	pop hl
	djnz 1b
	ret

!----------------------------------------------------------------------

	!  Lower left, 2 digits, lower right, 8 digits

draw_lower_row:

	ld de, CU53AN_segs_bottom_row
	ld a, [cu_is_alfa]
	or a
	jr z, 1f
	ld de, CU58AF_segs_bottom_row      !  Cursor at lower left
1:

	call clear_lower_colon

	ld a, [call_dpyed]
	or a
	jp nz, draw_call_notice

	ld hl, [adj_feedback]
	ld a, h
	or l
	jp nz, draw_adjust_feedback

	ld a, [digidx]                    ! digit buffer non-empty ?
	or a
	jp nz, draw_digit_buffer

	ld a, [menu_active]
	or a
	jp nz, draw_menu_lower_row

	!  Cursor still at lower left, now memory number and frequency

	call draw_memory_info

	call set_dpx_ind_from_rx_tx_freq

	ld a, [txon]
	or a
	jp nz, 1f
	load_ahl(rx_freq)
	jp draw_long                    
1:
	load_ahl(tx_freq)
	jp draw_long                    


draw_call_notice:

	call sput ; .asciz "CALL"

	ld a, [cu_is_alfa]
	or a
	jr nz, 1f
	call sput ; .asciz " "
1:
	ld a, [call_dpyed]
	cp 1
	jp z, 1f
	cp 2
	jp z, 2f
	call sput ; .asciz "  ???"
	ret
1:
	ld h, HI(fsk_history)
	ld a, [packet_good]
	add 1                     ! source address offset
	ld l, a
	ld a, [hl]; inc l; push hl; call dpydig; pop hl
	ld a, [hl]; inc l; push hl; call dpydig; pop hl
	ld a, [hl]; inc l; push hl; call dpydig; pop hl
	ld a, [hl]; inc l; push hl; call dpydig; pop hl
	ld a, [hl]; inc l; push hl; call dpydig; pop hl
	ret
2:
	call sput ; .asciz " CCIr"
	ret

!----------------------------------------------------------------------

segment_onoff:
	jr nc, segment_off

segment_on:

	ld h, HI(segments)	; ASSERT(LO(segments) == 0)
	ld l, a
	srl l
	srl l
	srl l				! byte ptr ok

	!	Uhhuh. Maybe not so bad as it looks :)

	and 7				! bit number

	cp 4; jr nc, 4f			! >= 4
	cp 2; jr nc, 2f			! >= 2, < 4
	cp 1; jr nc, 1f			! >= 1, < 2
	set 0, [hl] ; ret
1:	set 1, [hl] ; ret
2:	cp 3; jr nc, 3f			! >= 3, < 4
	set 2, [hl] ; ret
3:	set 3, [hl] ; ret
4:	cp 6; jr nc, 6f			! >= 6
	cp 5; jr nc, 5f			! >= 5, < 6
	set 4, [hl] ; ret
5:	set 5, [hl] ; ret
6:	cp 7; jr nc, 7f			! >= 7
	set 6, [hl] ; ret
7:	set 7, [hl] ; ret

segment_off:

	ld h, HI(segments)	; ASSERT(LO(segments) == 0)
	ld l, a
	srl l
	srl l
	srl l				! byte ptr ok

	!	Uhhuh. Maybe not so bad as it looks :)

	and 7				! bit number

	cp 4; jr nc, 4f			! >= 4
	cp 2; jr nc, 2f			! >= 2, < 4
	cp 1; jr nc, 1f			! >= 1, < 2
	res 0, [hl] ; ret
1:	res 1, [hl] ; ret
2:	cp 3; jr nc, 3f			! >= 3, < 4
	res 2, [hl] ; ret
3:	res 3, [hl] ; ret
4:	cp 6; jr nc, 6f			! >= 6
	cp 5; jr nc, 5f			! >= 5, < 6
	res 4, [hl] ; ret
5:	res 5, [hl] ; ret
6:	cp 7; jr nc, 7f			! >= 7
	res 6, [hl] ; ret
7:	res 7, [hl] ; ret

!----------------------------------------------------------------------

display:

	ld a, [cu_is_alfa]
	or a
	jp nz, display_cu58af

display_cu53an:

	ld hl, segments

	ld a, O2_LCD2
	out [OUT2], a

	ld a, O2_LCD1		! start 1st half of LCD1
	call display_group
	call display_bit_zero

	ld a, O2_LCD2		! start 1st half of LCD2
	call display_group
	call display_bit_zero

	ld a, O2_LCD1		! start 2nd half of LCD1
	call display_group
	call display_bit_one

	ld a, O2_LCD2		! start 2nd half of LCD2
	call display_group
	call display_bit_one

	ld a, O2_LCD1		! unselect LATCH
	out [OUT2], a

	ld hl, indicators
	call display_byte

	ld a, O2_LATCH		! select LATCH
	out [OUT2], a
	ld a, O2_LCD1		! unselect LATCH
	out [OUT2], a

	ret

display_group:
	out [OUT2], a

	call display_bit_zero
	call display_byte
	call display_byte
	call display_byte
	call display_byte
	ret

	!
	!	4032000 Hz pclk
	!	0.24 us T-state
	!
display_byte:
	ld c, [hl]
	inc hl
	ld b, 8
1:
	srl c
	call display_bit
	djnz 1b
	ret

display_bit:
	jr nc, display_bit_zero
display_bit_one:
	or O2_DP
display_bit_zero:
	or O2_CLK
	out [OUT2], a		! data & clock set	11 T	2.7 us
	and ~O2_CLK
	out [OUT2], a		! clock edge		2.7 us
	and ~O2_DP
	out [OUT2], a		! clear data		2.7 us

	ret

!======================================================================
!
!  CU58AF things

probe_cu58af:

    ! flush /INT from CU58AF, DA floats; no effect on CU53, DA low

	call cu58af_init
	call cu58af_init

	in a, [SIO+ACTRL]
	and SA_DA			! inverted...
	jp nz, 1f			! go if DA low, idle state DA low vs. /INT high
	ld a, 1
	ld [cu_is_alfa], a
1:
	ld a, 1
	ld [cu_is_known], a
	ret


step_audio_dst:

	ld a, [audio_dst]
	inc a
	cp 3
	jr c, 1f
	ld a, 0				! 0, 1 and 2 possible
1:
	ld [audio_dst], a

	call set_vola
	ret

dtmf_cu58af:

	ld l, 0x3F      ! 1760Hz from button        Codes for PCF3312
	cp 'B'
	jr z, 1f

	ld l, 0x1A      ! A from STO
	cp 'S'
	jr z, 1f

	ld l, 0x1B      ! B from RCL
	cp 'R'
	jr z, 1f

	ld l, 0x1C      ! C from CL
	cp 'C'
	jr z, 1f

	ld l, 0x1D      ! D from ENT
	cp 'E'
	jr z, 1f

	ld l, 0x1E      ! *
	cp '*'
	jr z, 1f

	ld l, 0x1F      ! #
	cp '#'
	jr z, 1f

	and 0x0F        ! 0..9 digits
	or 0x10
	ld l, a
1:
	ld a, l
	ld [dtmf_code], a
	ld hl, sir
	set DTMFSIR, [hl]
	ret

stop_dtmf_tone:
	ld a, [dtmf_code]
	or a
	ret z             ! no tone on
	ld a, 0
	ld [dtmf_code], a
	ld hl, sir
	set DTMFSIR, [hl]
	ret

i2c_dtmf_tone:

	ld a, CU58AF_AUDIOCTRL | CU58AF_EARCTRL | CU58AF_VOL_MIN | CU58AF_DTMFCTRL 
	ld c, CU58AF_CTRL
	call i2c_send_a

	ld a, [dtmf_code]
	ld c, CU58AF_DTMF
	call i2c_send_a

	ret

i2c_dtmf:

	ld a, [dtmf_code]
	or a
	jr nz, i2c_dtmf_tone

	ld a, 0				! End tone
	ld c, CU58AF_DTMF
	call i2c_send_a

	ASSERT(CU58AF_VOL_MASK == 0xE0)

	ld a, [volume]	! 0..9
	cp 0
	jr z, 2f		! no at all
	sub 1			! 0..8
	cp 7
	jr c, 1f
	ld a, 7			! 0..7
1:
	and 7	! -----210
	rrc a	! 0-----21
	rrc a	! 10-----2
	rrc a	! 210-----

	ld b, a			! volume bits in position

	ld a, [audio_dst]
	cp 1
	jr nz, 1f
	di
	ld a, [output_0]
	or O0_INH
	ld [output_0], a
	out [OUT0], a
	ei
	ld a, CU58AF_NSPKRCTRL
	jr 2f
1:
	cp 2
	jr nz, 1f
	di
	ld a, [output_0]
	or O0_INH
	ld [output_0], a
	out [OUT0], a
	ei
	ld a, CU58AF_EARCTRL
	jr 2f
1:
	di
	ld a, [output_0]
	and ~O0_INH
	ld [output_0], a
	out [OUT0], a
	ei
	ld a, 0
2:
	xor CU58AF_NSPKRCTRL
	or CU58AF_AUDIOCTRL | CU58AF_MICCTRL
	or b
	ld c, CU58AF_CTRL
	call i2c_send_a

	ret

!
!  before 'ei'
!
cu58af_init:

	ld c, CU58AF_LED
	ld b, CU58AF_LED_ON | CU58AF_KBRLIGHT | CU58AF_LCDLIGHT
	call i2c_send

	ld a, 0
	ld [dtmf_code], a
	call i2c_dtmf

	ld c, CU58AF_COLBTN
	ld b, 0xFF		! All inputs
	call i2c_send

	ld c, CU58AF_ROW
	ld b, 0
	call i2c_send

	!
	!  LCD needs more attention
	!
	call i2c_start

	ld c, CU58AF_LCD ! /WR as required.
	call i2c_wrbyte
	ld c, 0b11001100 ! C, normal mode, enabled, 1/2 bias, 4 backplanes
	call i2c_wrbyte
	ld c, 0b10000000 ! C, data pointer rewind
	call i2c_wrbyte
	ld c, 0b11100000 ! C, device select 0
	call i2c_wrbyte
	ld c, 0b11111000 ! C, bank select 0
	call i2c_wrbyte
	ld c, 0b01110000 ! /C, blink off
	call i2c_wrbyte

	ld b, 40
1:
	ld c, 0xFF
	call i2c_wrbyte
	djnz 1b

	call i2c_stop

	ld c, CU58AF_COLBTN
	call i2c_recv
	ld c, CU58AF_ROW
	call i2c_recv			! Flush /int
	ld c, CU58AF_COLBTN
	call i2c_recv
	ld c, CU58AF_ROW
	call i2c_recv			! Flush /int

	ret

keypad_cu58af:

	!  Read columns (and buttons)

	ld c, CU58AF_COLBTN
	call i2c_recv

	ld c, a		! buttons..

	and CU58AF_SPEAKER
	jr z, 2f			! Not pressed (anymore)
	ld a, [spkrbtn]
	or a
	jr nz, 3f			! Was already pressed
	ld a, 'K'
	ld [key], a
	ld a, 1				! Mark as down
2:
	ld [spkrbtn], a
3:

	ld hl, pttdn
	ld a, c
	and CU58AF_TANGENT
	jr z, 1f
	set 1, [hl]
	jr 2f
1:
	res 1, [hl]
2:

	ASSERT(CU58AF_COL_MASK == 7)

	ld b, 0

	ld a, c
	rr a
	jr c, 1f	! column 0
	inc b
	rr a
	jr c, 1f	! column 1
	inc b
	rr a
	jr c, 1f	! column 2

	di
	ld a, 0
	ld [key_timer], a
	ld [keydown], a
	ld [last_columns], a
	ld a, [lastdigit]
	cp -1
	jr z, 2f
	ld a, [lastdigit]
	ld [key], a			! Quick press of digit.
	ld a, -1
	ld [lastdigit], a
2:
	ei
	ld a, 0				! NOKEY
	or a
	ret
1:
	ld a, [last_columns]
	xor c
	and CU58AF_COL_MASK
	ld a, c
	ld [last_columns], a
	ret z

	push bc

	!  rows to inputs

	ld c, CU58AF_ROW
	ld b, 0xFF
	call i2c_send

	!  columns to outputs (low)

	ld c, CU58AF_COLBTN
	ld b, ~CU58AF_COL_MASK
	call i2c_send

	!  Read rows (8 lines)

	ld c, CU58AF_ROW
	call i2c_recv

	ASSERT(CU58AF_COL_MASK == 7)	! 3 keys (columns) per row
									! 0x7F row bits

	ld b, 0		! 0
	rr a
	jr c, 1f

	ld b, 3		! 1
	rr a
	jr c, 1f

	ld b, 6		! 2
	rr a
	jr c, 1f

	ld b, 9		! 3
	rr a
	jr c, 1f

	ld b, 12	! 4
	rr a
	jr c, 1f

	ld b, 15	! 5
	rr a
	jr c, 1f

	ld b, 18	! 6
	rr a
	jr c, 1f

	pop bc
	ld b, 0		! NOKEY
	push bc
1:

	push bc

	!  columns back to inputs (high)

	ld c, CU58AF_COLBTN
	ld b, 0xFF
	call i2c_send

	!  rows back to outputs (low)

	ld c, CU58AF_ROW
	ld b, 0
	call i2c_send

	ld c, CU58AF_COLBTN
	call i2c_recv		! Flush int from changes

	pop bc
	ld a, b
	pop bc
	add b

	ld hl, keytbl_cu58af
	ld b, 0
	ld c, a
	add hl, bc
	ld a, [hl]			! map code to character
	cp 'Z'
	ret

!
!  Update LCD and LEDs
!
display_cu58af:

	ld hl, indicators
	ld c, CU58AF_LED
	ld b, [hl]
	call i2c_send

	call i2c_start

	ld c, CU58AF_LCD ! /WR as required.
	call i2c_wrbyte
	ld c, 0b10000000 ! C, data pointer rewind
	call i2c_wrbyte
	ld c, 0b01100000 ! /C, device select 0
	call i2c_wrbyte

	ld hl, segments
	ld b, 40
1:
	ld c, [hl]
	inc hl
	call i2c_wrbyte
	djnz 1b

	call i2c_stop

	ret

!
!  SDA into carry
!

i2c_getbit:
	in a, [PIO+BDATA]
	and PB_DCU
	sub 1
	jp i2c_delay

!
!  Pull or release SDA wrt carry. NOT INTERRUPT PROTECTED.
!

i2c_putbit:
	jp c, i2c_sda_high

	/* FALLTHRU */

i2c_sda_low:
	di
	call pull_down_DCU
	ei
	jp i2c_delay

i2c_sda_high:
	di
	call release_DCU
	ei
	jp i2c_delay

i2c_scl_low:
	ld a, O2_XXX
	out [OUT2], a
	jp i2c_delay

i2c_scl_high:
	ld a, O2_XXX | O2_CLK
	out [OUT2], a
	jp i2c_delay

!
!  Call/return implicit delay should be enough...
!
i2c_delay:

	out [WD], a
	out [WD], a
	out [WD], a		! some delay anyway...
#if 0
	push af
	ld a, 20		! delay. We run blind.
1:
	dec a
	jr nz, 1b
	pop af
#endif
	ret

i2c_sendbit:
	sla c				! MSB of C (reg) into C (carry). Hmpfth...
	call i2c_putbit
	call i2c_scl_high
	call i2c_scl_low
	ret

i2c_recvbit:
	call i2c_scl_high
	call i2c_getbit
	rl c
	call i2c_scl_low
	ret

!
!  I2C byte write from reg c
!
i2c_wrbyte:

	call i2c_sendbit
	call i2c_sendbit
	call i2c_sendbit
	call i2c_sendbit

	call i2c_sendbit
	call i2c_sendbit
	call i2c_sendbit
	call i2c_sendbit

	call i2c_sda_high
	call i2c_scl_high
	call i2c_getbit		! ack ?
	push af
	call i2c_scl_low
	pop af				! Return carry clear if acknowledged.
	ret

!
!  I2C byte read to reg c. One and only one byte at a time.
!
i2c_rdbyte:

	call i2c_sda_high

	call i2c_recvbit
	call i2c_recvbit
	call i2c_recvbit
	call i2c_recvbit

	call i2c_recvbit
	call i2c_recvbit
	call i2c_recvbit
	call i2c_recvbit

	ret

i2c_start:

	call i2c_sda_high
	call i2c_scl_high

	call i2c_sda_low	! start ...
	call i2c_scl_low	! ... condition.

	ret

i2c_stop:

	call i2c_scl_low
	call i2c_sda_low

	call i2c_scl_high	! stop ...
	call i2c_sda_high	! ... condition.

	ret

i2c_send_a:
	ld b, a

i2c_send:

	res 0, c		! /WR

	call i2c_start

	call i2c_wrbyte	! Send address from C
	ld c, b
	call i2c_wrbyte	! Send data from B

	call i2c_stop

	ret

i2c_recv:

	set 0, c		! RD

	call i2c_start

	call i2c_wrbyte	! Send address from C
	call i2c_rdbyte	! Get data to C

	call i2c_stop

	ld a, c			! Return in A
	ret

!======================================================================
!
!	25 kHz
!	 512, 12800 /  512  quot 25 rem 0, /= 25 shift 0
!
!	20 kHz
!	 640, 12800 /  640  quot 20 rem 0, /= 20 shift 0
!
!	15 kHz
!	 853, 12800 /  853  quot 15 rem 0, /= 15 shift 0    NOT EXACT XXX
!
!	12.5 kHz
!	1024, 12800 / 1024  quot 12 rem 512
!	      12800 /  512  quot 25 rem 0, /= 25 shift 1
!
!	10 kHz
!	1280, 12800 / 1280  quot 10 rem 0, /= 10 shift 0
!
!	6.25 kHz
!	2048, 12800 / 2048  quot  6 rem 512
!	      12800 / 1024  quot 12 rem 512
!	      12800 /  512  quot 25 rem 0, /= 25 shift 2
!
!	3.125 kHz
!	4096, 12800 / 4096  quot  3 rem 512
!	      12800 / 2048  quot  6 rem 512
!	      12800 / 1024  quot 12 rem 512
!	      12800 /  512  quot 25 rem 0, /= 25 shift 3
!
!	5 kHz
!	2560, 12800 / 2560  quot  5 rem 0, 5 too small, use /= 10 shift 1
!

changed_frequency:
	call parameters_from_band
	call changed_frequency_duplex_okay
	ret

changed_frequency_duplex_okay:
	call temporary_change_rx_freq
	call determine_tx_div
	call set_legal_tx_flag
	ret

temporary_change_rx_freq:
	call close_squelch
	call lookup_rfc            ! input: rx_freq
	call update_vco_bands      ! input: rx_freq & tx_freq
	call determine_rx_div
	call load_rxsynth
	ret

parameters_from_band:
	call locate_band
	call set_channel_step      ! input: bandx logical step
	ret

locate_band:
	ld a, DPX_DUPLEX
	ld [duplex_state], a     ! assume duplex

	ld ix, cfg_band1_start
	ld b, num_bandrecs
1:
	load_ahl(rx_freq)
	ld e, [ix+0]
	ld d, [ix+1]
	ld c, [ix+2]
	and a
	sbc hl, de
	sbc c                    ! current - start
	jp c, 2f                 ! current < start, try next
	load_ahl(rx_freq)
	ld e, [ix+3]
	ld d, [ix+4]
	ld c, [ix+5]
	and a
	sbc hl, de
	sbc c                    ! current - end
	jp c, 3f                 ! current < end, found !
2:
	ld de, size_bandrec
	add ix, de
	djnz 1b

	! none of the bands, we now point into defaults for "other"

	ld a, DPX_SIMPLEX
	ld [duplex_state], a     ! default to simplex outside bands
3:
	ld a, num_bandrecs
	sub b
	ld [band], a

	ld l, [ix+6]             ! offset of duplex shift
	ld h, [ix+7]
	ld a, [ix+8]
	call set_band_duplex_shift

	ld a, [ix+9]             ! rest of band parameters
	ld [band_step], a
	ld a, [ix+10]
	ld [band_sctail], a
	ld a, [ix+11]
	ld [band_sclisten], a

	ret

	! duplex shift is set in band 1..6 only if it is "repeater band"
	! "other" shift does not imply autoduplex

set_band_duplex_shift:
	save_ahl(duplex_shift)
	or h
	or l
	ret nz                   ! band has shift

	load_ahl(cfg_other_duplex)
	save_ahl(duplex_shift)
	ld a, DPX_SIMPLEX         ! not a duplex band, prepare with "other" shift
	ld [duplex_state], a
	ret

set_duplex_from_tx_rx:
	call compare_tx_rx_freq    ! ahl has subtract value, CY and Z also
	save_ahl(duplex_shift)
	ld a, DPX_DUPLEX
	jp nz, 1f
	load_ahl(cfg_other_duplex)
	save_ahl(duplex_shift)
	ld a, DPX_SIMPLEX
1:
	ld [duplex_state], a
	ret

	!-------------
	! duplex state 0: tx = rx_freq
	!              1: tx = rx_freq + duplex_shift (sign included in shift)
	!              2: tx = rx_freq - duplex_shift (sign included in shift)
	!              3: tx = tx_freq

determine_tx_div:
	ld a, [duplex_state]
	cp DPX_DUPLEX
	jp z, 1f
	cp DPX_REVERSE
	jp z, 2f
	cp DPX_SPLIT
	jp z, 3f
	load_ahl(rx_freq)         ! duplex 0, tx follows rx
	save_ahl(tx_freq)
	jp 3f
1:
	load_ahl(rx_freq)         ! duplex 1, tx = rx + shift (shift neg. usually)
	add_ahl_de(duplex_shift)
	save_ahl(tx_freq)
	jp 3f
2:
	load_ahl(rx_freq)         ! duplex 2, tx = rx + shift
	sub_ahl_de(duplex_shift)
	save_ahl(tx_freq)
3:
	load_ahl(tx_freq)
	ld bc, [tx_bstep_cfg]
	call freq2div
	save_ahl(tx_divisor)
	ld bc, [tx_bstep_cfg]
	call div2freq
	save_ahl(tx_freq)         ! and back in aligned
	ret

determine_rx_div:
	load_ahl(rx_freq)
	add_ahl_de(cfg_if_freq)   ! vco kHz

	ld bc, [rx_bstep_cfg]
	call freq2div             ! linear NA
	save_ahl(rx_divisor)      ! rxdiv = (rxfq + IF) / step
	ld bc, [rx_bstep_cfg]
	call div2freq
	sub_ahl_de(cfg_if_freq)
	save_ahl(rx_freq)         ! rxfq = rxdiv * step - IF
	ret

get_scan_tail:
	ld a, [band_sctail]
	ret
get_scan_patience:
	ld a, [band_sclisten]
	ret

set_legal_tx_flag:
	load_ahl(cfg_tx_band_start)
	sub_ahl_de(tx_freq)
	jp nc, 2f                  ! start >= vfo, illegal

	load_ahl(tx_freq)
	sub_ahl_de(cfg_tx_band_end)
	jp c, 1f                   ! vfo < end, and start < vfo, legal
2:
	load_ahl(tx_freq)
	sub_ahl_de(cfg_tx_oob)
	or l
	or h
	jp z, 1f                   ! vfo at "oob tx spot", legal after all

	ld a, [local_mode]         ! illegal if not local_mode 
	ld [tx_is_legal], a
	ret
1:
	ld a, 1
	ld [tx_is_legal], a
	ret

	! split and temporary shift overrides are forgotten if this is used

step_duplex_state:
	ld a, [duplex_state]
	inc a
	cp DPX_SPLIT
	jr c, 1f
	ld a, DPX_SIMPLEX
1:
	ld [duplex_state], a
	cp DPX_DUPLEX
	jp z, 1f
	load_ahl(rx_freq)        ! 1 to 2 or 2 to 0, flip rx/tx
	push af
	push hl
	load_ahl(tx_freq)
	save_ahl(rx_freq)
	pop hl
	pop af
	save_ahl(tx_freq)
1:
	jp changed_frequency_duplex_okay

	! set duplex shift temporarily

set_duplex_shift_neg:
	call a2i
	call negate_ahl
	save_ahl(duplex_shift)
	ld a, DPX_DUPLEX
	ld [duplex_state], a
	jp changed_frequency_duplex_okay

set_duplex_shift_pos:
	call a2i
	save_ahl(duplex_shift)
	ld a, DPX_DUPLEX
	ld [duplex_state], a
	jp changed_frequency_duplex_okay

	! set tx freq to given memory (rx of the memory)
	! or given frequency (short 3/4 digit freq ok)

set_tx_freq:
	ld a, [digidx]
	cp 3
	jp c, 1f               ! 1...2 digits
	cp 5
	call c, fill_implied   ! if 3 or 4 digits, fix to abs.
	call a2i               ! AHL freq
	jp 2f
1:
	call a2i_byte
	call point_ix_memory_a
	load_ahl_ix_0          ! use memory rx frequency as tx freq
2:
	save_ahl(tx_freq)

	ld a, DPX_SPLIT
	ld [duplex_state], a
	jp changed_frequency_duplex_okay



set_channel_step:
	ld a, [band_step]

	ld hl, TCXO / 25 * 2  ! phys 12.5
	ld bc, 25 | (1 << 8)

	ld de, 25             ! user visible 25, 12.5 phys.
	cp STEP_25
	jr z, 1f

	ld de, 12             ! user visible 12.5, 12.5 phys
	cp STEP_12
	jr z, 1f

	ld hl, TCXO / 10      ! phys 10
	ld bc, 10

	ld de, 20             ! user visible 20, 10 phys
	cp STEP_20
	jr z, 1f

	ld de, 10             ! user visible 10, 10 phys
	cp STEP_10
	jr z, 1f

	ld hl, TCXO / 15      ! phys 15
	ld bc, 15

	ld de, 15             ! user visible 15, 15 phys.
	cp STEP_15
	jr z, 1f

	ld hl, TCXO / 25 * 2
	ld bc, 25 | (1 << 8)    ! 25/2
	ld de, 25
1:
	ld [rx_bstep_cfg], bc
	ld [tx_bstep_cfg], bc  ! XXX no need to force same stepping tx/rx
	ld [rx_refdiv], hl
	ld [tx_refdiv], hl

	ld [band_step_hz], de
	ret


	! AHL has divisor, BC has step config

div2freq:

	call mul248         ! AHL * C -> CYAHL
	inc b
	jr 2f
1:
	rr a
	rr h
	rr l
	and a
2:
	djnz 1b

	ret

	!
	!	freq / 25 * 2 = linear divisor
	!	AHL has freq in Hz, BC has step config
	!

freq2div:

	call div248         ! AHL / C -> HL,A
	ld e, 0				! MSb
	inc b
	jr 2f
1:
	scf					! remainder * 2 + 1
	rl a				! 
	cp c				! compare with divider
	jr c, 3f
	sub c
3:
	ccf
	rl l				! and shift in
	rl h
	rl e
2:
	djnz 1b

	! divisor almost there, check last remainder 
	rl a
	cp c
	jr c, 3f
	inc l
	jr nz, 3f
	inc h
	jr nz, 3f
	inc e
3:
	call check_and_clamp_divisor  ! EHL -> AHL
	ret

check_and_clamp_divisor:
	ld a, [cfg_synth_card]
	cp S8D
	ld a, e       ! get 3rd byte of divisor
	jp nz, 1f     ! go if RC58 or RB58 case
	cp 2          ! RD58 case
	ret c         ! ok, E was 0/1, AHL now 0/1HL
	imm_ahl(0x1FFFF)
	ret
1:
	or a
	ret z         ! ok, E was 0, AHL now 0HL, RC58 and RB58 case
	imm_ahl(0xFFFF)
	ret

!======================================================================

update_vco_bands:
	ld a, [synth_ctrl]
	or 0xF3                 ! Max deviation (b7..b4), assume vco bits "1"
	ld c, a

	load_ahl(tx_freq)
	sub_ahl_de(cfg_tx_vco_center)
	jr c, 1f
	res 1, c                 ! "0" = high band
1:
	load_ahl(rx_freq)
	sub_ahl_de(cfg_rx_vco_center)
	jr c, 1f
	res 0, c                 ! "0" = high band
1:
	ld a, c
	ld [synth_ctrl], a
	ret

halt_txsynth:
	ld a, [synth_ctrl]
	set 2, a                ! cut supply, prediv & pll
	res 3, a                ! cut supply, vco and amps
	ld [synth_ctrl], a
	jp load_synth_ctrl

enable_txsynth:
	ld a, [synth_ctrl]
	res 2, a                ! supply on, prediv & pll
	set 3, a                ! supply on, vco and amps
	ld [synth_ctrl], a
	jp load_synth_ctrl

load_synth_ctrl:
	ld a, [synth_ctrl]
	ld c, a

	ld a, O1_TXOFF
	out [OUT1], a

	ld b, 8
	call send_to_synth

	or O1_SCE
	call strobe_to_synth
	ret

load_txsynth:

	! Control register, tx vco band A/B  and txsynth ON bits

	call enable_txsynth

	! Channel spacing - R

	ld a, O1_TXOFF
	out [OUT1], a

	ld hl, [tx_refdiv]
	ld c, h
	ld b, 8			! has excess bits... they overflow ok
	call send_to_synth
	ld c, l
	ld b, 8
	call send_to_synth

	call one_to_synth	! single "1" bit - to R register

	or O1_STE
	call strobe_to_synth

	! Divisor

	load_ahl(tx_divisor)
	ld e, a

	ld d, O1_STE
	call send_NA_to_synth

	ret

load_rxsynth:

	! Control register, rx vco band A/B

	call load_synth_ctrl

	! Channel spacing - R

	ld a, O1_TXOFF
	out [OUT1], a

	ld hl, [rx_refdiv]	! channel spacing
	ld c, h
	ld b, 8			! has excess bits... they overflow ok
	call send_to_synth
	ld c, l
	ld b, 8
	call send_to_synth

	call one_to_synth	! single "1" bit - to R register

	or O1_SRE
	call strobe_to_synth

	! Divisor

	load_ahl(rx_divisor)
	ld e, a

	ld d, O1_SRE
	call send_NA_to_synth

	ret

!----------------------------------------------------------------------

	!
	!  10 bits of N, 7 bits of A, single zerobit to selector
	!
	!  RD58  NNNNNNNNNNAAAAAAA
	!        GFEDCBA9876543210 effective bit numbers
	!        EHHHHHHHHLLLLLLLL
	!
	!  RB58S
	!  RC58  NNNNNNNNNN0AAAAAA
	!        FEDCBA9876 543210 effective bit numbers
	!        HHHHHHHHLL LLLLLL
	!        
	!  NA in EHL register triple

send_NA_to_synth:
	ld a, [cfg_synth_card]
	cp S8D
	jp nz, send_NA_64_to_synth   ! RB58 or RC58

	! RD58 default synthesizer S8D, fall thru to

send_NA_128_to_synth:

	! A used thru routine

	ld a, O1_TXOFF
	out [OUT1], a

	! MSbit of N

	ld c, e
	rrc c				! Align lowest bit for MSb first shifting just 1 bit
	ld b, 1
	call send_to_synth	! send MSb (lowest of e)

	! Rest of NA

	ld c, h
	ld b, 8
	call send_to_synth
	ld c, l
	ld b, 8
	call send_to_synth

	call zero_to_synth	! single "0" bit - to A/N registers

	or d
	call strobe_to_synth	! which synth

	ret

send_NA_64_to_synth:

	! A used thru routine

	ld a, O1_TXOFF
	out [OUT1], a

	! NA

	ld c, h
	ld b, 8
	call send_to_synth
	ld c, l
	ld b, 2
	call send_to_synth
	call zero_to_synth	! pad for 64/65 prescaler, instead of linear 128/129
	ld b, 6
	call send_to_synth

	call zero_to_synth	! single "0" bit - to A/N registers

	or d
	call strobe_to_synth	! which synth

	ret


strobe_to_synth:

	out [OUT1], a
	and ~(O1_SCE | O1_STE | O1_SRE | O1_SD)
	out [OUT1], a
	ret

send_to_synth:
2:
	rl c
	jr c, 1f
	call zero_to_synth
	djnz 2b
	ret
1:
	call one_to_synth
	djnz 2b
	ret

zero_to_synth:

	and ~O1_SD
	out [OUT1], a
	or O1_CLK
	out [OUT1], a
	and ~(O1_CLK)
	out [OUT1], a

	ret

one_to_synth:

	or O1_SD
	out [OUT1], a
	or O1_CLK
	out [OUT1], a
	and ~(O1_CLK)
	out [OUT1], a

	ret

!======================================================================

tx_on:
	call scanner_stop

	ld a, [tx_is_legal]
	sub 1
	ret c

	call update_LPF

	di
	ld a, 0
	ld [squelch_open], a
	ld [tx_tot_timer], a
	ld a, 1
	ld [txon], a
	ld a, 100
	ld [txtail_timer], a	! shall count 1 second after tx ends

	call stop_marker_tone
	ld a, [output_0]
	and ~ O0_AUDIOC
and ~ O0_CCIRC
	ld [output_0], a
	out [OUT0], a
	ei

	ld a, O1_TXOFF
	out [OUT1], a
	ld a, 0
	out [DA_TXPWR], a
	call load_txsynth

	ld a, 0
	out [OUT1], a

	ld a, [cfg_txpwr]
	out [DA_TXPWR], a

	call light_transmit_led
	and a					! return carry clear
	ret


tx_off:
	ld a, O1_TXOFF
	out [OUT1], a
	ld a, 0
	out [DA_TXPWR], a

	ld a, 0
	ld [txon], a

	call ctcss_off
	call halt_txsynth

#if 0
	ld a, 0
	ld [alert_timer], a
#endif

	call dim_transmit_led
	call resync_squelch
	ret

!======================================================================

	! this needs no align
keytbl_cu53an:
	.byte 'Z','Z','Z','Z','Z','Z','Z','Z'
	.byte 'Z','Z','Z','Z','+','-','?','B'
	.byte 'E','*', 0 ,'#','R', 7 , 8 , 9
	.byte 'S', 4 , 5 , 6 ,'C', 1 , 2 , 3

	! this needs no align
keytbl_cu58af:
	.byte 'Z','Z','B', 4 , 2 , 1 , 5 , 6 
	.byte  3 , 7 , 8 , 9 ,'*', 0 ,'E','-'     ! XXX check ENT vs # correct
	.byte 'C','#','+','S','R','Z','Z','Z'
	.byte 'Z','Z','Z','Z','Z','Z','Z','Z'
	.byte 'Z','Z','Z','Z','Z','Z','Z','Z'

	! this needs no align
ccirtbl:
	.word MT_CALCHZ(1981) ! 0
	.word MT_CALCHZ(1124) ! 1
	.word MT_CALCHZ(1197) ! 2
	.word MT_CALCHZ(1275) ! 3
	.word MT_CALCHZ(1358) ! 4
	.word MT_CALCHZ(1446) ! 5
	.word MT_CALCHZ(1540) ! 6
	.word MT_CALCHZ(1640) ! 7
	.word MT_CALCHZ(1747) ! 8
	.word MT_CALCHZ(1860) ! 9
	.word MT_CALCHZ(2400) ! A
	.word MT_CALCHZ( 930) ! B
	.word MT_CALCHZ(2247) ! C
	.word MT_CALCHZ( 991) ! D
	.word MT_CALCHZ(2110) ! E
	.word 4               ! F

!
!  -----       3
!  |\|/|   6 2 E F B
!  -- --     5   A
!  |/|\|   4 0 1 D 9
!  -----       C

	! this needs no align
cu58af_font:

	        ! FEDCBA9876543210
	.word	0b1001101001011001	! 0
	.word	0b0100000000000010	! 1
	.word	0b0001110000111000	! 2
	.word	0b0001111000101000	! 3
	.word	0b0000111001100000	! 4
	.word	0b0001011001101000	! 5
	.word	0b0001011001111000	! 6
	.word	0b0000101000001000	! 7
	.word	0b0001111001111000	! 8
	.word	0b0001111001101000	! 9
	.word	0b0000111001111000	! A
	.word	0b1011000001111000	! B
	.word	0b0001000001011000	! C
	.word	0b0101101000001010	! D
	.word	0b0001010001111000	! E
	.word	0b0000010001111000	! F
	        ! FEDCBA9876543210

	.word	0b0001011001011000	! G
	        ! FEDCBA9876543210

	.org cu58af_font + 2*' '

	        ! FEDCBA9876543210
	.word	0b0000000000000000	!   	- - - -   - - -
	.word	0b1001000110001100	! ! 	- - 2 3   - - -
	.word	0b0100000111000000	! " 	0 - - 3   - - -
	.word	0b0001011110110000	! # 	- 1 2 -   - 5 6
	.word	0b0101011111101010	! $ 	0 - 2 -   - 5 -
	.word	0b1000001111000001	! % 	0 - 2 -   - - -
	.word	0b1011000110001101	! & 	- 1 - 3   - 5 6
	.word	0b0000000111000000	! ' 	- - - 3   - - -
	.word	0b1010000110000000	! ( 	- - 2 3   - - -
	.word	0b0000000110000101	! ) 	0 1 - -   - - -
	.word	0b1110010110100111	! * 	- - - -   4 5 6
	.word	0b0100010110100010	! + 	0 1 - -   - 5 -
	.word	0b0000000110000001	! , 	- 1 - -   - - -
	.word	0b0000010110100000	! - 	- - - -   - 5 -
	.word	0b0000000110010000	! . 	- 1 - -   - - -
	.word	0b1000000110000001	! / 	- 1 - 3   - 5 -
	.word	0b1001101001011001	! 0
	.word	0b0100000000000010	! 1
	.word	0b0001110000111000	! 2
	.word	0b0001111000101000	! 3
	.word	0b0000111001100000	! 4
	.word	0b0001011001101000	! 5
	.word	0b0001011001111000	! 6
	.word	0b0000101000001000	! 7
	.word	0b0001111001111000	! 8
	.word	0b0001111001101000	! 9
	.word	0b0000000111010000	! : 	- - - -   4 - 6
	.word	0b0100000110000001	! ; 	- - - 3   - - 6
	.word	0b1010000110000000	! < 	- - 2 3   - 5 -
	.word	0b0001010110100000	! = 	- - - -   - 5 6
	.word	0b0000000110000101	! > 	0 1 - -   - 5 -
	.word	0b1000000110001010	! ? 	- 1 - 3   4 5 -
	.word	0b0101110111011000	! @ 	- 1 2 3   4 5 6
	        ! FEDCBA9876543210
	.word	0b0000111001111000	! A
	.word	0b1011000001111000	! B
	.word	0b0001000001011000	! C
	.word	0b0101101000001010	! D
	.word	0b0001010001111000	! E
	.word	0b0000010001111000	! F
	.word	0b0001011001011000	! G
	.word	0b0000111111110000	! H		0 1 2 3   - 5 -
	.word	0b0101000110001010	! I 	- - 2 3   - - -
	.word	0b0001101110010000	! J 	- 1 2 3   - - 6
	.word	0b1010000111110000	! K 	- 1 2 3   - - 6
	.word	0b0001000111010000	! L		0 1 - -   - - 6
	.word	0b1000101111010100	! M		0 1 2 3   4 - -
	.word	0b0010101111010100	! N		- 1 2 -   - 5 -
	.word	0b0001101111011000	! O 	0 1 2 3   4 - 6
	.word	0b0000110111111000	! P 	0 1 - 3   4 5 -
	.word	0b0011101111011000	! Q 	0 - 2 3   4 5 -
	.word	0b0010110111111000	! R		0 1 - 3   4 - -
	.word	0b0011000110001100	! S 	0 - 2 -   4 5 6
	.word	0b0100000110001010	! T		0 1 - -   4 - -
	.word	0b0001101111010000	! U 	0 1 2 3   - - 6
	.word	0b1000000111010001	! V 	0 1 2 3   - - 6
	.word	0b0010101111010001	! W 	0 1 2 3   - - 6
	.word	0b1010000110000101	! X		- - - -   4 5 6
	.word	0b1000000110000110	! Y 	0 - 2 3   - 5 6
	.word	0b1001000110001001	! Z 	- 1 - 3   4 5 6
	.word	0b0000000110000000	! [ 	0 1 - -   4 - 6
	        ! FEDCBA9876543210
	.word	0b0010000110000100	! \ 	0 - 2 -   - 5 -
	.word	0b0000000110000000	! ] 	- - 2 3   4 - 6
	.word	0b0000000110000000	! ^ 	- - - -   4 - -
	.word	0b0001000110000000	! _ 	- - - -   - - 6
	.word	0b0000000110000100	! ` 	0 - - -   - - -

	.word	0b0000111001111000	! a
	.word	0b1011000001111000	! b
	.word	0b0001000001011000	! c
	.word	0b0101101000001010	! D
	.word	0b0001010001111000	! E
	.word	0b0000010001111000	! F
	.word	0b0001011001011000	! G
	.word	0b0000111111110000	! H		0 1 2 3   - 5 -
	.word	0b0101000110001010	! I 	- - 2 3   - - -
	.word	0b0001101110010000	! J 	- 1 2 3   - - 6
	.word	0b1010000111110000	! K 	- 1 2 3   - - 6
	.word	0b0001000111010000	! L		0 1 - -   - - 6
	.word	0b1000101111010100	! M		0 1 2 3   4 - -
	.word	0b0010101111010100	! N		- 1 2 -   - 5 -
	.word	0b0001101111011000	! O 	0 1 2 3   4 - 6
	.word	0b0000110111111000	! P 	0 1 - 3   4 5 -
	.word	0b0011101111011000	! Q 	0 - 2 3   4 5 -
	.word	0b0010110111111000	! R		0 1 - 3   4 - -
	.word	0b0011000110001100	! S 	0 - 2 -   4 5 6
	.word	0b0100000110001010	! T		0 1 - -   4 - -
	.word	0b0001101111010000	! U 	0 1 2 3   - - 6
	.word	0b1000000111010001	! V 	0 1 2 3   - - 6
	.word	0b0010101111010001	! W 	0 1 2 3   - - 6
	.word	0b1010000110000101	! X		- - - -   4 5 6
	.word	0b1000000110000110	! Y 	0 - 2 3   - 5 6
	.word	0b1001000110001001	! Z 	- 1 - 3   4 5 6

	.word	0b0000000110000000	! { 	- 1 - -   - 5 6
	.word	0b0100000110000010	! | 	- 1 - -   - - -
	.word	0b0000000110000000	! } 	- - 2 -   - 5 6
	.word	0b0000000110001000	! ~ 	- - - -   4 - -
	.word	0b0000000110000000	! ^? 	- 1 - 3   4 5 6

	ASSERT((. - cu58af_font) == (2 * 128))

!======================================================================

	.align 8, 0xFF
div99tbl:
	.byte 0x00, 0x00, 0x01, 0x01, 0x02, 0x02, 0x02, 0x03, 0x03, 0x04
	.byte 0x04, 0x04, 0x05, 0x05, 0x05, 0x06, 0x06, 0x07, 0x07, 0x07
	.byte 0x08, 0x08, 0x09, 0x09, 0x09, 0x10, 0x10, 0x11, 0x11, 0x11
	.byte 0x12, 0x12, 0x12, 0x13, 0x13, 0x14, 0x14, 0x14, 0x15, 0x15
	.byte 0x16, 0x16, 0x16, 0x17, 0x17, 0x18, 0x18, 0x18, 0x19, 0x19
	.byte 0x20, 0x20, 0x20, 0x21, 0x21, 0x21, 0x22, 0x22, 0x23, 0x23
	.byte 0x23, 0x24, 0x24, 0x25, 0x25, 0x25, 0x26, 0x26, 0x27, 0x27
	.byte 0x27, 0x28, 0x28, 0x29, 0x29, 0x29, 0x30, 0x30, 0x30, 0x31
	.byte 0x31, 0x32, 0x32, 0x32, 0x33, 0x33, 0x34, 0x34, 0x34, 0x35
	.byte 0x35, 0x36, 0x36, 0x36, 0x37, 0x37, 0x37, 0x38, 0x38, 0x39
	.byte 0x39, 0x39, 0x40, 0x40, 0x41, 0x41, 0x41, 0x42, 0x42, 0x43
	.byte 0x43, 0x43, 0x44, 0x44, 0x45, 0x45, 0x45, 0x46, 0x46, 0x46
	.byte 0x47, 0x47, 0x48, 0x48, 0x48, 0x49, 0x49, 0x50, 0x50, 0x50
	.byte 0x51, 0x51, 0x52, 0x52, 0x52, 0x53, 0x53, 0x54, 0x54, 0x54
	.byte 0x55, 0x55, 0x55, 0x56, 0x56, 0x57, 0x57, 0x57, 0x58, 0x58
	.byte 0x59, 0x59, 0x59, 0x60, 0x60, 0x61, 0x61, 0x61, 0x62, 0x62
	.byte 0x62, 0x63, 0x63, 0x64, 0x64, 0x64, 0x65, 0x65, 0x66, 0x66
	.byte 0x66, 0x67, 0x67, 0x68, 0x68, 0x68, 0x69, 0x69, 0x70, 0x70
	.byte 0x70, 0x71, 0x71, 0x71, 0x72, 0x72, 0x73, 0x73, 0x73, 0x74
	.byte 0x74, 0x75, 0x75, 0x75, 0x76, 0x76, 0x77, 0x77, 0x77, 0x78
	.byte 0x78, 0x79, 0x79, 0x79, 0x80, 0x80, 0x80, 0x81, 0x81, 0x82
	.byte 0x82, 0x82, 0x83, 0x83, 0x84, 0x84, 0x84, 0x85, 0x85, 0x86
	.byte 0x86, 0x86, 0x87, 0x87, 0x87, 0x88, 0x88, 0x89, 0x89, 0x89
	.byte 0x90, 0x90, 0x91, 0x91, 0x91, 0x92, 0x92, 0x93, 0x93, 0x93
	.byte 0x94, 0x94, 0x95, 0x95, 0x95, 0x96, 0x96, 0x96, 0x97, 0x97
	.byte 0x98, 0x98, 0x98, 0x99, 0x99, 0x99

!======================================================================

	.align 8, 0xFF
crctbls:
crctbl_hi:
	.byte HI(    0); .byte HI( 4489); .byte HI( 8978); .byte HI(12955);
	.byte HI(17956); .byte HI(22445); .byte HI(25910); .byte HI(29887);
	.byte HI(35912); .byte HI(40385); .byte HI(44890); .byte HI(48851);
	.byte HI(51820); .byte HI(56293); .byte HI(59774); .byte HI(63735);
	.byte HI( 4225); .byte HI(  264); .byte HI(13203); .byte HI( 8730);
	.byte HI(22181); .byte HI(18220); .byte HI(30135); .byte HI(25662);
	.byte HI(40137); .byte HI(36160); .byte HI(49115); .byte HI(44626);
	.byte HI(56045); .byte HI(52068); .byte HI(63999); .byte HI(59510);
	.byte HI( 8450); .byte HI(12427); .byte HI(  528); .byte HI( 5017);
	.byte HI(26406); .byte HI(30383); .byte HI(17460); .byte HI(21949);
	.byte HI(44362); .byte HI(48323); .byte HI(36440); .byte HI(40913);
	.byte HI(60270); .byte HI(64231); .byte HI(51324); .byte HI(55797);
	.byte HI(12675); .byte HI( 8202); .byte HI( 4753); .byte HI(  792);
	.byte HI(30631); .byte HI(26158); .byte HI(21685); .byte HI(17724);
	.byte HI(48587); .byte HI(44098); .byte HI(40665); .byte HI(36688);
	.byte HI(64495); .byte HI(60006); .byte HI(55549); .byte HI(51572);
	.byte HI(16900); .byte HI(21389); .byte HI(24854); .byte HI(28831);
	.byte HI( 1056); .byte HI( 5545); .byte HI(10034); .byte HI(14011);
	.byte HI(52812); .byte HI(57285); .byte HI(60766); .byte HI(64727);
	.byte HI(34920); .byte HI(39393); .byte HI(43898); .byte HI(47859);
	.byte HI(21125); .byte HI(17164); .byte HI(29079); .byte HI(24606);
	.byte HI( 5281); .byte HI( 1320); .byte HI(14259); .byte HI( 9786);
	.byte HI(57037); .byte HI(53060); .byte HI(64991); .byte HI(60502);
	.byte HI(39145); .byte HI(35168); .byte HI(48123); .byte HI(43634);
	.byte HI(25350); .byte HI(29327); .byte HI(16404); .byte HI(20893);
	.byte HI( 9506); .byte HI(13483); .byte HI( 1584); .byte HI( 6073);
	.byte HI(61262); .byte HI(65223); .byte HI(52316); .byte HI(56789);
	.byte HI(43370); .byte HI(47331); .byte HI(35448); .byte HI(39921);
	.byte HI(29575); .byte HI(25102); .byte HI(20629); .byte HI(16668);
	.byte HI(13731); .byte HI( 9258); .byte HI( 5809); .byte HI( 1848);
	.byte HI(65487); .byte HI(60998); .byte HI(56541); .byte HI(52564);
	.byte HI(47595); .byte HI(43106); .byte HI(39673); .byte HI(35696);
	.byte HI(33800); .byte HI(38273); .byte HI(42778); .byte HI(46739);
	.byte HI(49708); .byte HI(54181); .byte HI(57662); .byte HI(61623);
	.byte HI( 2112); .byte HI( 6601); .byte HI(11090); .byte HI(15067);
	.byte HI(20068); .byte HI(24557); .byte HI(28022); .byte HI(31999);
	.byte HI(38025); .byte HI(34048); .byte HI(47003); .byte HI(42514);
	.byte HI(53933); .byte HI(49956); .byte HI(61887); .byte HI(57398);
	.byte HI( 6337); .byte HI( 2376); .byte HI(15315); .byte HI(10842);
	.byte HI(24293); .byte HI(20332); .byte HI(32247); .byte HI(27774);
	.byte HI(42250); .byte HI(46211); .byte HI(34328); .byte HI(38801);
	.byte HI(58158); .byte HI(62119); .byte HI(49212); .byte HI(53685);
	.byte HI(10562); .byte HI(14539); .byte HI( 2640); .byte HI( 7129);
	.byte HI(28518); .byte HI(32495); .byte HI(19572); .byte HI(24061);
	.byte HI(46475); .byte HI(41986); .byte HI(38553); .byte HI(34576);
	.byte HI(62383); .byte HI(57894); .byte HI(53437); .byte HI(49460);
	.byte HI(14787); .byte HI(10314); .byte HI( 6865); .byte HI( 2904);
	.byte HI(32743); .byte HI(28270); .byte HI(23797); .byte HI(19836);
	.byte HI(50700); .byte HI(55173); .byte HI(58654); .byte HI(62615);
	.byte HI(32808); .byte HI(37281); .byte HI(41786); .byte HI(45747);
	.byte HI(19012); .byte HI(23501); .byte HI(26966); .byte HI(30943);
	.byte HI( 3168); .byte HI( 7657); .byte HI(12146); .byte HI(16123);
	.byte HI(54925); .byte HI(50948); .byte HI(62879); .byte HI(58390);
	.byte HI(37033); .byte HI(33056); .byte HI(46011); .byte HI(41522);
	.byte HI(23237); .byte HI(19276); .byte HI(31191); .byte HI(26718);
	.byte HI( 7393); .byte HI( 3432); .byte HI(16371); .byte HI(11898);
	.byte HI(59150); .byte HI(63111); .byte HI(50204); .byte HI(54677);
	.byte HI(41258); .byte HI(45219); .byte HI(33336); .byte HI(37809);
	.byte HI(27462); .byte HI(31439); .byte HI(18516); .byte HI(23005);
	.byte HI(11618); .byte HI(15595); .byte HI( 3696); .byte HI( 8185);
	.byte HI(63375); .byte HI(58886); .byte HI(54429); .byte HI(50452);
	.byte HI(45483); .byte HI(40994); .byte HI(37561); .byte HI(33584);
	.byte HI(31687); .byte HI(27214); .byte HI(22741); .byte HI(18780);
	.byte HI(15843); .byte HI(11370); .byte HI( 7921); .byte HI( 3960);
crctbl_lo:
	.byte LO(    0); .byte LO( 4489); .byte LO( 8978); .byte LO(12955);
	.byte LO(17956); .byte LO(22445); .byte LO(25910); .byte LO(29887);
	.byte LO(35912); .byte LO(40385); .byte LO(44890); .byte LO(48851);
	.byte LO(51820); .byte LO(56293); .byte LO(59774); .byte LO(63735);
	.byte LO( 4225); .byte LO(  264); .byte LO(13203); .byte LO( 8730);
	.byte LO(22181); .byte LO(18220); .byte LO(30135); .byte LO(25662);
	.byte LO(40137); .byte LO(36160); .byte LO(49115); .byte LO(44626);
	.byte LO(56045); .byte LO(52068); .byte LO(63999); .byte LO(59510);
	.byte LO( 8450); .byte LO(12427); .byte LO(  528); .byte LO( 5017);
	.byte LO(26406); .byte LO(30383); .byte LO(17460); .byte LO(21949);
	.byte LO(44362); .byte LO(48323); .byte LO(36440); .byte LO(40913);
	.byte LO(60270); .byte LO(64231); .byte LO(51324); .byte LO(55797);
	.byte LO(12675); .byte LO( 8202); .byte LO( 4753); .byte LO(  792);
	.byte LO(30631); .byte LO(26158); .byte LO(21685); .byte LO(17724);
	.byte LO(48587); .byte LO(44098); .byte LO(40665); .byte LO(36688);
	.byte LO(64495); .byte LO(60006); .byte LO(55549); .byte LO(51572);
	.byte LO(16900); .byte LO(21389); .byte LO(24854); .byte LO(28831);
	.byte LO( 1056); .byte LO( 5545); .byte LO(10034); .byte LO(14011);
	.byte LO(52812); .byte LO(57285); .byte LO(60766); .byte LO(64727);
	.byte LO(34920); .byte LO(39393); .byte LO(43898); .byte LO(47859);
	.byte LO(21125); .byte LO(17164); .byte LO(29079); .byte LO(24606);
	.byte LO( 5281); .byte LO( 1320); .byte LO(14259); .byte LO( 9786);
	.byte LO(57037); .byte LO(53060); .byte LO(64991); .byte LO(60502);
	.byte LO(39145); .byte LO(35168); .byte LO(48123); .byte LO(43634);
	.byte LO(25350); .byte LO(29327); .byte LO(16404); .byte LO(20893);
	.byte LO( 9506); .byte LO(13483); .byte LO( 1584); .byte LO( 6073);
	.byte LO(61262); .byte LO(65223); .byte LO(52316); .byte LO(56789);
	.byte LO(43370); .byte LO(47331); .byte LO(35448); .byte LO(39921);
	.byte LO(29575); .byte LO(25102); .byte LO(20629); .byte LO(16668);
	.byte LO(13731); .byte LO( 9258); .byte LO( 5809); .byte LO( 1848);
	.byte LO(65487); .byte LO(60998); .byte LO(56541); .byte LO(52564);
	.byte LO(47595); .byte LO(43106); .byte LO(39673); .byte LO(35696);
	.byte LO(33800); .byte LO(38273); .byte LO(42778); .byte LO(46739);
	.byte LO(49708); .byte LO(54181); .byte LO(57662); .byte LO(61623);
	.byte LO( 2112); .byte LO( 6601); .byte LO(11090); .byte LO(15067);
	.byte LO(20068); .byte LO(24557); .byte LO(28022); .byte LO(31999);
	.byte LO(38025); .byte LO(34048); .byte LO(47003); .byte LO(42514);
	.byte LO(53933); .byte LO(49956); .byte LO(61887); .byte LO(57398);
	.byte LO( 6337); .byte LO( 2376); .byte LO(15315); .byte LO(10842);
	.byte LO(24293); .byte LO(20332); .byte LO(32247); .byte LO(27774);
	.byte LO(42250); .byte LO(46211); .byte LO(34328); .byte LO(38801);
	.byte LO(58158); .byte LO(62119); .byte LO(49212); .byte LO(53685);
	.byte LO(10562); .byte LO(14539); .byte LO( 2640); .byte LO( 7129);
	.byte LO(28518); .byte LO(32495); .byte LO(19572); .byte LO(24061);
	.byte LO(46475); .byte LO(41986); .byte LO(38553); .byte LO(34576);
	.byte LO(62383); .byte LO(57894); .byte LO(53437); .byte LO(49460);
	.byte LO(14787); .byte LO(10314); .byte LO( 6865); .byte LO( 2904);
	.byte LO(32743); .byte LO(28270); .byte LO(23797); .byte LO(19836);
	.byte LO(50700); .byte LO(55173); .byte LO(58654); .byte LO(62615);
	.byte LO(32808); .byte LO(37281); .byte LO(41786); .byte LO(45747);
	.byte LO(19012); .byte LO(23501); .byte LO(26966); .byte LO(30943);
	.byte LO( 3168); .byte LO( 7657); .byte LO(12146); .byte LO(16123);
	.byte LO(54925); .byte LO(50948); .byte LO(62879); .byte LO(58390);
	.byte LO(37033); .byte LO(33056); .byte LO(46011); .byte LO(41522);
	.byte LO(23237); .byte LO(19276); .byte LO(31191); .byte LO(26718);
	.byte LO( 7393); .byte LO( 3432); .byte LO(16371); .byte LO(11898);
	.byte LO(59150); .byte LO(63111); .byte LO(50204); .byte LO(54677);
	.byte LO(41258); .byte LO(45219); .byte LO(33336); .byte LO(37809);
	.byte LO(27462); .byte LO(31439); .byte LO(18516); .byte LO(23005);
	.byte LO(11618); .byte LO(15595); .byte LO( 3696); .byte LO(8185);
	.byte LO(63375); .byte LO(58886); .byte LO(54429); .byte LO(50452);
	.byte LO(45483); .byte LO(40994); .byte LO(37561); .byte LO(33584);
	.byte LO(31687); .byte LO(27214); .byte LO(22741); .byte LO(18780);
	.byte LO(15843); .byte LO(11370); .byte LO( 7921); .byte LO(3960);

!======================================================================

	.align 8, 0xFF
dtmf_sintab:
	.byte 33, 33, 34, 35, 36, 36, 37, 38
	.byte 39, 40, 40, 41, 42, 43, 43, 44
	.byte 45, 46, 46, 47, 48, 49, 49, 50
	.byte 51, 51, 52, 52, 53, 54, 54, 55
	.byte 55, 56, 57, 57, 58, 58, 59, 59
	.byte 60, 60, 60, 61, 61, 62, 62, 62
	.byte 63, 63, 63, 63, 64, 64, 64, 64
	.byte 64, 65, 65, 65, 65, 65, 65, 65
	.byte 65, 65, 65, 65, 65, 65, 65, 65
	.byte 64, 64, 64, 64, 64, 63, 63, 63
	.byte 63, 62, 62, 62, 61, 61, 60, 60
	.byte 60, 59, 59, 58, 58, 57, 57, 56
	.byte 55, 55, 54, 54, 53, 52, 52, 51
	.byte 51, 50, 49, 49, 48, 47, 46, 46
	.byte 45, 44, 43, 43, 42, 41, 40, 40
	.byte 39, 38, 37, 36, 36, 35, 34, 33
	.byte 33, 32, 31, 30, 29, 29, 28, 27
	.byte 26, 25, 25, 24, 23, 22, 22, 21
	.byte 20, 19, 19, 18, 17, 16, 16, 15
	.byte 14, 14, 13, 13, 12, 11, 11, 10
	.byte 10,  9,  8,  8,  7,  7,  6,  6
	.byte  5,  5,  5,  4,  4,  3,  3,  3
	.byte  2,  2,  2,  2,  1,  1,  1,  1
	.byte  1,  0,  0,  0,  0,  0,  0,  0
	.byte  0,  0,  0,  0,  0,  0,  0,  0
	.byte  1,  1,  1,  1,  1,  2,  2,  2
	.byte  2,  3,  3,  3,  4,  4,  5,  5
	.byte  5,  6,  6,  7,  7,  8,  8,  9
	.byte 10, 10, 11, 11, 12, 13, 13, 14
	.byte 14, 15, 16, 16, 17, 18, 19, 19
	.byte 20, 21, 22, 22, 23, 24, 25, 25
	.byte 26, 27, 28, 29, 29, 30, 31, 32

!======================================================================
	.align 8, 0xFF
cu53an_font:

	.byte	0x5f	! 0 	0 1 2 3   4 - 6
	.byte	0x0c	! 1 	- - 2 3   - - -
	.byte	0x7a	! 2 	- 1 - 3   4 5 6
	.byte	0x7c	! 3 	- - 2 3   4 5 6
	.byte	0x2d	! 4 	0 - 2 3   - 5 -
	.byte	0x75	! 5 	0 - 2 -   4 5 6
	.byte	0x77	! 6 	0 1 2 -   4 5 6
	.byte	0x1c	! 7 	- - 2 3   4 - -
	.byte	0x7f	! 8 	0 1 2 3   4 5 6
	.byte	0x7d	! 9 	0 - 2 3   4 5 6
	.byte	0x3f	! A 	0 1 2 3   4 5 -
	.byte	0x67	! b 	0 1 2 -   - 5 6
	.byte	0x53	! C 	0 1 - -   4 - 6
	.byte	0x6e	! d 	- 1 2 3   - 5 6
	.byte	0x73	! E 	0 1 - -   4 5 6
	.byte	0x33	! F 	0 1 - -   4 5 -

	.byte	0x57	! G 	0 1 2 -   4 - 6

	.org cu53an_font + ' '

	.byte	0x00	!   	- - - -   - - -
	.byte	0x0c	! ! 	- - 2 3   - - -
	.byte	0x09	! " 	0 - - 3   - - -
	.byte	0x66	! # 	- 1 2 -   - 5 6
	.byte	0x25	! $ 	0 - 2 -   - 5 -
	.byte	0x05	! % 	0 - 2 -   - - -
	.byte	0x6a	! & 	- 1 - 3   - 5 6
	.byte	0x08	! ' 	- - - 3   - - -
	.byte	0x0c	! ( 	- - 2 3   - - -
	.byte	0x03	! ) 	0 1 - -   - - -
	.byte	0x70	! * 	- - - -   4 5 6
	.byte	0x23	! + 	0 1 - -   - 5 -
	.byte	0x02	! , 	- 1 - -   - - -
	.byte	0x20	! - 	- - - -   - 5 -
	.byte	0x02	! . 	- 1 - -   - - -
	.byte	0x2a	! / 	- 1 - 3   - 5 -
	.byte	0x5f	! 0 	0 1 2 3   4 - 6
	.byte	0x0c	! 1 	- - 2 3   - - -
	.byte	0x7a	! 2 	- 1 - 3   4 5 6
	.byte	0x7c	! 3 	- - 2 3   4 5 6
	.byte	0x2d	! 4 	0 - 2 3   - 5 -
	.byte	0x75	! 5 	0 - 2 -   4 5 6
	.byte	0x77	! 6 	0 1 2 -   4 5 6
	.byte	0x1c	! 7 	- - 2 3   4 - -
	.byte	0x7f	! 8 	0 1 2 3   4 5 6
	.byte	0x7d	! 9 	0 - 2 3   4 5 6
	.byte	0x50	! : 	- - - -   4 - 6
	.byte	0x48	! ; 	- - - 3   - - 6
	.byte	0x2c	! < 	- - 2 3   - 5 -
	.byte	0x60	! = 	- - - -   - 5 6
	.byte	0x23	! > 	0 1 - -   - 5 -
	.byte	0x3a	! ? 	- 1 - 3   4 5 -
	.byte	0x7e	! @ 	- 1 2 3   4 5 6
	.byte	0x3f	! A 	0 1 2 3   4 5 -
	.byte	0x67	! b 	0 1 2 -   - 5 6
	.byte	0x53	! C 	0 1 - -   4 - 6
	.byte	0x6e	! d 	- 1 2 3   - 5 6
	.byte	0x73	! E 	0 1 - -   4 5 6
	.byte	0x33	! F 	0 1 - -   4 5 -
	.byte	0x57	! G 	0 1 2 -   4 - 6
	.byte	0x2f	! H		0 1 2 3   - 5 -
	.byte	0x0c	! I 	- - 2 3   - - -
	.byte	0x4e	! J 	- 1 2 3   - - 6
	.byte	0x2f	! K 	- 1 2 3   - - 6
	.byte	0x43	! L		0 1 - -   - - 6
	.byte	0x1f	! M		0 1 2 3   4 - -
	.byte	0x26	! N		- 1 2 -   - 5 -
	.byte	0x5f	! O 	0 1 2 3   4 - 6
	.byte	0x3b	! P 	0 1 - 3   4 5 -
	.byte	0x3d	! Q 	0 - 2 3   4 5 -
	.byte	0x1b	! R		0 1 - 3   4 - -
	.byte	0x75	! S 	0 - 2 -   4 5 6
	.byte	0x13	! T		0 1 - -   4 - -
	.byte	0x4f	! U 	0 1 2 3   - - 6
	.byte	0x4f	! V 	0 1 2 3   - - 6
	.byte	0x4f	! W 	0 1 2 3   - - 6
	.byte	0x70	! X		- - - -   4 5 6
	.byte	0x6d	! Y 	0 - 2 3   - 5 6
	.byte	0x7a	! Z 	- 1 - 3   4 5 6
	.byte	0x53	! [ 	0 1 - -   4 - 6
	.byte	0x25	! \ 	0 - 2 -   - 5 -
	.byte	0x5c	! ] 	- - 2 3   4 - 6
	.byte	0x10	! ^ 	- - - -   4 - -
	.byte	0x40	! _ 	- - - -   - - 6
	.byte	0x01	! ` 	0 - - -   - - -
	.byte	0x26	! a 	- 1 2 -   - 5 -
	.byte	0x67	! b 	0 1 2 -   - 5 6
	.byte	0x62	! c 	- 1 - -   - 5 6
	.byte	0x6e	! d 	- 1 2 3   - 5 6
	.byte	0x62	! e 	- 1 - -   - 5 6
	.byte	0x33	! f 	0 1 - -   4 5 -
	.byte	0x7d	! g 	0 - 2 3   4 5 6
	.byte	0x27	! h		0 1 2 -   - 5 -
	.byte	0x04	! i 	- - 2 -   - - -
	.byte	0x44	! j 	- - 2 -   - - 6
	.byte	0x27	! k 
	.byte	0x42	! l		- 1 - -   - - 6
	.byte	0x26	! m		- 1 2 -   - 5 -
	.byte	0x26	! n		- 1 2 -   - 5 -
	.byte	0x66	! o 	- 1 2 -   - 5 6
	.byte	0x3b	! p 	0 1 - 3   4 5 -
	.byte	0x3d	! q 	0 - 2 3   4 5 -
	.byte	0x22	! r		- 1 - -   - 5 -
	.byte	0x75	! s 	0 - 2 -   4 5 6
	.byte	0x63	! t		0 1 - -   - 5 6
	.byte	0x46	! u 	- 1 2 -   - - 6
	.byte	0x46	! v 	- 1 2 -   - - 6
	.byte	0x46	! w		- 1 2 -   - - 6
	.byte	0x06	! x		- 1 2 -   - - -
	.byte	0x2d	! y 	0 - 2 3   - 5 -
	.byte	0x60	! z 	- - - -   - 5 6
	.byte	0x62	! { 	- 1 - -   - 5 6
	.byte	0x02	! | 	- 1 - -   - - -
	.byte	0x64	! } 	- - 2 -   - 5 6
	.byte	0x10	! ~ 	- - - -   4 - -
	.byte	0x00	! ^? 	- 1 - 3   4 5 6

	ASSERT((. - cu53an_font) == 128)

	! must be inside page

dtmf_8870_tab:
	.byte 0xD, 1,2,3,4,5,6,7,8,9, 0x0, '*', '#', 0xA, 0xB, 0xC

	ASSERT(HI(.) == HI(dtmf_8870_tab))

!======================================================================
!
! OUT2 emits CTCSS square wave.
!
! This needs a rewire of the timer CLK2 from the same place as
! CLK0 and CLK1, 4.032 MHz. Otherwise the tones are just too wrong.
! After the rewire the result is very accurate.
!
! Please cut the CLK2 wire into "keskeytyskytkenta" too.

CTCSS_FIRST = 64

ctcss_tab:
	.word 63000 !  64Hz ( 64.0Hz)
	.word 62031 !  65Hz ( 65.0Hz)
	.word 61091 !  66Hz ( 66.0Hz)
	.word 60179 !  67Hz ( 67.0Hz)
	.word 59294 !  68Hz ( 68.0Hz)
	.word 58435 !  69Hz ( 69.0Hz)
	.word 57600 !  70Hz ( 70.0Hz)
	.word 56789 !  71Hz ( 71.0Hz)
	.word 56000 !  72Hz ( 72.0Hz)
	.word 55233 !  73Hz ( 73.0Hz)
	.word 54486 !  74Hz ( 74.0Hz)
	.word 53760 !  75Hz ( 75.0Hz)
	.word 53053 !  76Hz ( 76.0Hz)
	.word 52364 !  77Hz ( 77.0Hz)
	.word 51692 !  78Hz ( 78.0Hz)
	.word 51038 !  79Hz ( 79.0Hz)
	.word 50400 !  80Hz ( 80.0Hz)
	.word 49778 !  81Hz ( 81.0Hz)
	.word 49171 !  82Hz ( 82.0Hz)
	.word 48578 !  83Hz ( 83.0Hz)
	.word 48000 !  84Hz ( 84.0Hz)
	.word 47435 !  85Hz ( 85.0Hz)
	.word 46884 !  86Hz ( 86.0Hz)
	.word 46345 !  87Hz ( 87.0Hz)
	.word 45818 !  88Hz ( 88.0Hz)
	.word 45303 !  89Hz ( 89.0Hz)
	.word 44800 !  90Hz ( 90.0Hz)
	.word 44308 !  91Hz ( 91.0Hz)
	.word 43826 !  92Hz ( 92.0Hz)
	.word 43355 !  93Hz ( 93.0Hz)
	.word 42894 !  94Hz ( 94.0Hz)
	.word 42442 !  95Hz ( 95.0Hz)
	.word 42000 !  96Hz ( 96.0Hz)
	.word 41567 !  97Hz ( 97.0Hz)
	.word 41143 !  98Hz ( 98.0Hz)
	.word 40727 !  99Hz ( 99.0Hz)
	.word 40320 ! 100Hz (100.0Hz)
	.word 39921 ! 101Hz (101.0Hz)
	.word 39529 ! 102Hz (102.0Hz)
	.word 39146 ! 103Hz (103.0Hz)
	.word 38769 ! 104Hz (104.0Hz)
	.word 38400 ! 105Hz (105.0Hz)
	.word 38038 ! 106Hz (106.0Hz)
	.word 37682 ! 107Hz (107.0Hz)
	.word 37333 ! 108Hz (108.0Hz)
	.word 36991 ! 109Hz (109.0Hz)
	.word 36655 ! 110Hz (110.0Hz)
	.word 36324 ! 111Hz (111.0Hz)
	.word 36000 ! 112Hz (112.0Hz)
	.word 35681 ! 113Hz (113.0Hz)
	.word 35368 ! 114Hz (114.0Hz)
	.word 35061 ! 115Hz (115.0Hz)
	.word 34759 ! 116Hz (116.0Hz)
	.word 34462 ! 117Hz (117.0Hz)
	.word 34169 ! 118Hz (118.0Hz)
	.word 33882 ! 119Hz (119.0Hz)
	.word 33600 ! 120Hz (120.0Hz)
	.word 33322 ! 121Hz (121.0Hz)
	.word 33049 ! 122Hz (122.0Hz)
	.word 32780 ! 123Hz (123.0Hz)
	.word 32516 ! 124Hz (124.0Hz)
	.word 32256 ! 125Hz (125.0Hz)
	.word 32000 ! 126Hz (126.0Hz)
	.word 31748 ! 127Hz (127.0Hz)
	.word 31500 ! 128Hz (128.0Hz)
	.word 31256 ! 129Hz (129.0Hz)
	.word 31015 ! 130Hz (130.0Hz)
	.word 30779 ! 131Hz (131.0Hz)
	.word 30545 ! 132Hz (132.0Hz)
	.word 30316 ! 133Hz (133.0Hz)
	.word 30090 ! 134Hz (134.0Hz)
	.word 29867 ! 135Hz (135.0Hz)
	.word 29647 ! 136Hz (136.0Hz)
	.word 29431 ! 137Hz (137.0Hz)
	.word 29217 ! 138Hz (138.0Hz)
	.word 29007 ! 139Hz (139.0Hz)
	.word 28800 ! 140Hz (140.0Hz)
	.word 28596 ! 141Hz (141.0Hz)
	.word 28394 ! 142Hz (142.0Hz)
	.word 28196 ! 143Hz (143.0Hz)
	.word 28000 ! 144Hz (144.0Hz)
	.word 27807 ! 145Hz (145.0Hz)
	.word 27616 ! 146Hz (146.0Hz)
	.word 27429 ! 147Hz (147.0Hz)
	.word 27243 ! 148Hz (148.0Hz)
	.word 27060 ! 149Hz (149.0Hz)
	.word 26880 ! 150Hz (150.0Hz)
	.word 26702 ! 151Hz (151.0Hz)
	.word 26526 ! 152Hz (152.0Hz)
	.word 26353 ! 153Hz (153.0Hz)
	.word 26182 ! 154Hz (154.0Hz)
	.word 26013 ! 155Hz (155.0Hz)
	.word 25846 ! 156Hz (156.0Hz)
	.word 25682 ! 157Hz (157.0Hz)
	.word 25519 ! 158Hz (158.0Hz)
	.word 25358 ! 159Hz (159.0Hz)
	.word 25200 ! 160Hz (160.0Hz)
	.word 25043 ! 161Hz (161.0Hz)
	.word 24889 ! 162Hz (162.0Hz)
	.word 24736 ! 163Hz (163.0Hz)
	.word 24585 ! 164Hz (164.0Hz)
	.word 24436 ! 165Hz (165.0Hz)
	.word 24289 ! 166Hz (166.0Hz)
	.word 24144 ! 167Hz (167.0Hz)
	.word 24000 ! 168Hz (168.0Hz)
	.word 23858 ! 169Hz (169.0Hz)
	.word 23718 ! 170Hz (170.0Hz)
	.word 23579 ! 171Hz (171.0Hz)
	.word 23442 ! 172Hz (172.0Hz)
	.word 23306 ! 173Hz (173.0Hz)
	.word 23172 ! 174Hz (174.0Hz)
	.word 23040 ! 175Hz (175.0Hz)
	.word 22909 ! 176Hz (176.0Hz)
	.word 22780 ! 177Hz (177.0Hz)
	.word 22652 ! 178Hz (178.0Hz)
	.word 22525 ! 179Hz (179.0Hz)
	.word 22400 ! 180Hz (180.0Hz)
	.word 22276 ! 181Hz (181.0Hz)
	.word 22154 ! 182Hz (182.0Hz)
	.word 22033 ! 183Hz (183.0Hz)
	.word 21913 ! 184Hz (184.0Hz)
	.word 21795 ! 185Hz (185.0Hz)
	.word 21677 ! 186Hz (186.0Hz)
	.word 21561 ! 187Hz (187.0Hz)
	.word 21447 ! 188Hz (188.0Hz)
	.word 21333 ! 189Hz (189.0Hz)
	.word 21221 ! 190Hz (190.0Hz)
	.word 21110 ! 191Hz (191.0Hz)
	.word 21000 ! 192Hz (192.0Hz)
	.word 20891 ! 193Hz (193.0Hz)
	.word 20784 ! 194Hz (194.0Hz)
	.word 20677 ! 195Hz (195.0Hz)
	.word 20571 ! 196Hz (196.0Hz)
	.word 20467 ! 197Hz (197.0Hz)
	.word 20364 ! 198Hz (198.0Hz)
	.word 20261 ! 199Hz (199.0Hz)
	.word 20160 ! 200Hz (200.0Hz)
	.word 20060 ! 201Hz (201.0Hz)
	.word 19960 ! 202Hz (202.0Hz)
	.word 19862 ! 203Hz (203.0Hz)
	.word 19765 ! 204Hz (204.0Hz)
	.word 19668 ! 205Hz (205.0Hz)
	.word 19573 ! 206Hz (206.0Hz)
	.word 19478 ! 207Hz (207.0Hz)
	.word 19385 ! 208Hz (208.0Hz)
	.word 19292 ! 209Hz (209.0Hz)
	.word 19200 ! 210Hz (210.0Hz)
	.word 19109 ! 211Hz (211.0Hz)
	.word 19019 ! 212Hz (212.0Hz)
	.word 18930 ! 213Hz (213.0Hz)
	.word 18841 ! 214Hz (214.0Hz)
	.word 18753 ! 215Hz (215.0Hz)
	.word 18667 ! 216Hz (216.0Hz)
	.word 18581 ! 217Hz (217.0Hz)
	.word 18495 ! 218Hz (218.0Hz)
	.word 18411 ! 219Hz (219.0Hz)
	.word 18327 ! 220Hz (220.0Hz)
	.word 18244 ! 221Hz (221.0Hz)
	.word 18162 ! 222Hz (222.0Hz)
	.word 18081 ! 223Hz (223.0Hz)
	.word 18000 ! 224Hz (224.0Hz)
	.word 17920 ! 225Hz (225.0Hz)
	.word 17841 ! 226Hz (226.0Hz)
	.word 17762 ! 227Hz (227.0Hz)
	.word 17684 ! 228Hz (228.0Hz)
	.word 17607 ! 229Hz (229.0Hz)
	.word 17530 ! 230Hz (230.0Hz)
	.word 17455 ! 231Hz (231.0Hz)
	.word 17379 ! 232Hz (232.0Hz)
	.word 17305 ! 233Hz (233.0Hz)
	.word 17231 ! 234Hz (234.0Hz)
	.word 17157 ! 235Hz (235.0Hz)
	.word 17085 ! 236Hz (236.0Hz)
	.word 17013 ! 237Hz (237.0Hz)
	.word 16941 ! 238Hz (238.0Hz)
	.word 16870 ! 239Hz (239.0Hz)
	.word 16800 ! 240Hz (240.0Hz)
	.word 16730 ! 241Hz (241.0Hz)
	.word 16661 ! 242Hz (242.0Hz)
	.word 16593 ! 243Hz (243.0Hz)
	.word 16525 ! 244Hz (244.0Hz)
	.word 16457 ! 245Hz (245.0Hz)
	.word 16390 ! 246Hz (246.0Hz)
	.word 16324 ! 247Hz (247.0Hz)
	.word 16258 ! 248Hz (248.0Hz)
	.word 16193 ! 249Hz (249.0Hz)
	.word 16128 ! 250Hz (250.0Hz)
	.word 16064 ! 251Hz (251.0Hz)
	.word 16000 ! 252Hz (252.0Hz)
	.word 15937 ! 253Hz (253.0Hz)
	.word 15874 ! 254Hz (254.0Hz)
	.word 15812 ! 255Hz (255.0Hz)

ctcss_off:
	ld a, TMR_2 | TMR_LSB | TMR_INTTC
	out [TMR + TMRCTRL], a
	ld a, 1
	out [TMR + 2], a     ! low for one clock, then rise and stay
	ret

ctcss_maybe:
	ld a, [cfg_ctcss_hz]
	sub CTCSS_FIRST
	jp c, ctcss_off     ! too low ones are ignored

	ld e, a
	ld d, 0
	sla e
	rl d				! two bytes per record in table
	ld ix, ctcss_tab
	add ix, de

	ld a, TMR_2 | TMR_BOTH | TMR_SQWAVE
	out [TMR + TMRCTRL], a
	ld a, [ix+0]
	out [TMR + 2], a
	ld a, [ix+0]
	out [TMR + 2], a

	ret

!======================================================================

negate_ahl:
	ld b, a
	ld a, l
	cpl
	add 1
	ld l, a
	ld a, h
	cpl
	adc 0
	ld h, a
	ld a, b
	cpl
	adc 0
	ret

	!
	!  Calculate binary value from unpacked string
	!  Return in CY AHL
	!
a2i:
	push ix
	push bc
	push de

	ld ix, digbuf
	ld a, [digidx]
	ld c, a

	ld a, 0				! AHL starts from 0x000000
	ld h, a
	ld l, a
	ld [digidx], a

	dec c
	jp z, a2i1
	dec c
	jp z, a2i2
	dec c
	jp z, a2i3
	dec c
	jp z, a2i4
	dec c
	jp z, a2i5
	dec c
	jp z, a2i6
	dec c
	jp z, a2i7

	jp a2i0				! more than 7, give 0

a2iOV:
	imm_ahl(0xFFFFFF)
	jp a2i0

a2i7:
	ld de, 0x4240
	ld b, [ix]		! x 000 000
	inc ix
	inc b
	jr 1f
2:
	add hl, de
	adc 0x0F			! 1 000 000 equals 0x 0F 4240
	jp c, a2iOV
1:
	djnz 2b
a2i6:
	ld de, 0x86a0		! 100 000 equals 0x186a0, thus the adc 1...
	ld b, [ix]		! 0 x00 000
	inc ix
	inc b
	jr 1f
2:
	add hl, de
	adc 1
	jp c, a2iOV
1:
	djnz 2b
a2i5:
	ld de, 10000
	ld b, [ix]		! 0x0 000
	inc ix
	inc b
	jr 1f
2:
	add hl, de
	adc 0
	jp c, a2iOV
1:
	djnz 2b
a2i4:
	ld de, 1000
	ld b, [ix]		! 00x 000
	inc ix
	inc b
	jr 1f
2:
	add hl, de
	adc 0
	jp c, a2iOV
1:
	djnz 2b
a2i3:
	ld de, 100
	ld b, [ix]		! 000 x00
	inc ix
	inc b
	jr 1f
2:
	add hl, de
	adc 0
	jp c, a2iOV
1:
	djnz 2b
a2i2:
	ld de, 10
	ld b, [ix]		! 000 0x0
	inc ix
	inc b
	jr 1f
2:
	add hl, de
	adc 0
	jp c, a2iOV
1:
	djnz 2b
a2i1:
	ld de, 1
	ld b, [ix]		! 000 00x
	inc ix
	inc b
	jr 1f
2:
	add hl, de
	adc 0
	jp c, a2iOV
1:
	djnz 2b
a2i0:
	pop de
	pop bc
	pop ix

	ret					! AHL contains frequency in binary


!	Multiply AHL by C, 1..
!	Result to CY AHL

mul248:

	push bc
	push de

	ld e, l
	ld d, h
	ld b, a
	and a			! clear carry
1:
	dec c
	jr z, 1f
	adc hl, de
	adc b
	jr nc, 1b
	imm_ahl(0xFFFFFF)
1:
	pop de
	pop bc

	ret

!----------------------------------------------------------------------
!
! Divide AHL by C, result left in HL, remainder in A.
!
! Origin: Trash-80 Assembly Language Subroutines, William Barden 1982.
!

div248:

	push bc

	ld b, 16	! do this 16 times.
2:
	add hl, hl	! rotate AHL one bit
	adc a		! position to the left.
	sub c
	jr c, 1f
	inc hl		! set lsb of hl, a bit into quotient.
	djnz 2b
	jr 3f
1:
	add c		! oops, should not have subtracted.
	djnz 2b
3:
	pop bc

	ret

!======================================================================

lookup_rfc:
	call get_rfc_hl
	ld a, [hl]
	or a
	jr nz, 1f
	ld a, 85
1:
	ld [rfc], a
	out [DA_RFC], a
	ret

save_rfc:
	call get_rfc_hl
	ld a, [rfc]
	ld [hl], a
	out [DA_RFC], a
	call save_nvdata
	ret

!
!  Receiver frequency is first modulo 100MHz, then modulo 1MHz.
!  Each "band" overwrite others, but, for ham bands values dont overlap
!  432..438 -> 32..38
!  144..146 -> 44..46
!   50.. 52 -> 50..52
!
get_rfc_hl:
	load_ahl(rx_freq)

	ld de, 100000 % 65536
	ld c,  100000 / 65536
	and a                     ! clear CY
1:
	sbc hl, de
	sbc c
	jp nc, 1b                 ! modulo down to 0...99999
	add hl, de
	adc c

	ld c, -1                  ! index [0...99]
	ld de, 1000
	and a
1:
	inc c
	sbc hl, de
	sbc 0
	jp nc, 1b

	ld hl, rfctab
	ld b, 0
	add hl, bc
	ret

!======================================================================

save_nvmisc_and_restart:

#ifdef P8N
	ld hl, nvstart
	ld d, O2_LCD1 & ~O2_SMEM
	ld e, O2_LCD1 |  O2_SMEM
	ld c, OUT2
1:
	out [WD], a

	ld a, [hl]
	out [c], d
	ld [hl], a
	out [c], e
	inc hl
	ld a, h
	cp HI(nvend)
	jp nz, 1b
	ld a, l
	cp LO(nvend)
	jp nz, 1b
#endif

	ld sp, 1f
	retn			! restart to (IFF1 still clear)
1:
	.word start		! retn to start

save_nvdata:

#ifdef P8N
	ld hl, nvstart
	ld d, O2_LCD1 & ~O2_SMEM
	ld e, O2_LCD1 |  O2_SMEM
	ld c, OUT2
1:
	ld a, [hl]
	di
	out [c], d
	ld [hl], a
	out [c], e
	ei
	inc hl
	ld a, h
	cp HI(nvend)
	jr nz, 1b
	ld a, l
	cp LO(nvend)
	jr nz, 1b
#endif

	ret

load_nvdata:

#ifdef P8N
	ld hl, nvstart
	ld d, O2_LCD1 & ~O2_SMEM
	ld e, O2_LCD1 |  O2_SMEM
	ld c, OUT2
1:
	out [WD], a
	out [c], d
	ld a, [hl]
	out [c], e
	ld [hl], a
	inc hl
	ld a, h
	cp HI(nvend)
	jr nz, 1b
	ld a, l
	cp LO(nvend)
	jr nz, 1b
#endif

	ret

!========================================================================
!
!  Bitbang DTMF out from 8254 timer 1 (the CCIR/MARKER pin).
!
!  Z80  clock   4.032 MHz     ~248 nsec cycle
!  8254 clock 1 4.032 MHz     ~248 nsec cycle

!  A fixed time (interrupts disabled) program loop is used to create
!  a time cell of 130T times (32.2 usec).
!  There is no padding in the P8N-loop, but creating the time-bound
!  loop later will use less T-times, so it's ok
!  (looping ix=10000 will be 322 msec).
!
!  The 8254 timer is temporarily reprogrammed for mode0
!  ("interrupt on terminal count") and LSB-only r/w operations.
!  The loop has a constant execution time, no inner branches at all.
!
!  The loop calculates sin(low)+sin(high) from table, with DDS;
!  sinus table is scaled from 1...64 so sum range is 2...128 inclusive.
!
!  Using timer mode 0; the output goes low when the count is written.
!  after the count decrements to 0 the output rises.
!  The loop takes 130T times, slightly longer than any written count.
!
!  This creates about 31 kHz PWM output.
!
!  Step 1.
!    Create the tightest loop to walk the phases, sum up values,
!    trickle watchdog and load counter.
!    Count the T times and determine loop execution time.
!    This will be the PWM cell time.
!
!  Step 2:
!    Pad out a copy of the loop for P8E.
!
!  Step 3.
!    Build phase-inc-table for tones (see mkdtmfseq.c).
!    Values must be scaled so that the lowest sum (as the count)
!    keeps the timer output almost totally high,
!    and the highest sum keeps it mostly low.
!    T-time (from Z80 CLK) isn't the same as timer period
!    (from 8254 clock 1) (although they just happen to be in P8N).
!
!  See companion program mkdtmftab.c

!
! pwm 31015.38462 Hz
!
	dtmf_phase_1750 = 3698 # 17.7 steps
	dtmf_phase_1633 = 3451 # 19.0 steps
	dtmf_phase_1477 = 3121 # 21.0 steps
	dtmf_phase_1336 = 2823 # 23.2 steps
	dtmf_phase_1209 = 2555 # 25.7 steps
	dtmf_phase_941  = 1988 # 33.0 steps
	dtmf_phase_852  = 1800 # 36.4 steps
	dtmf_phase_770  = 1627 # 40.3 steps
	dtmf_phase_697  = 1473 # 44.5 steps

dtmf_rowcol_table:

	.word dtmf_phase_941, dtmf_phase_1336 ! 0
	.word dtmf_phase_697, dtmf_phase_1209 ! 1
	.word dtmf_phase_697, dtmf_phase_1336 ! 2
	.word dtmf_phase_697, dtmf_phase_1477 ! 3
	.word dtmf_phase_770, dtmf_phase_1209 ! 4
	.word dtmf_phase_770, dtmf_phase_1336 ! 5
	.word dtmf_phase_770, dtmf_phase_1477 ! 6
	.word dtmf_phase_852, dtmf_phase_1209 ! 7
	.word dtmf_phase_852, dtmf_phase_1336 ! 8
	.word dtmf_phase_852, dtmf_phase_1477 ! 9
	.word dtmf_phase_697, dtmf_phase_1633 ! A
	.word dtmf_phase_770, dtmf_phase_1633 ! B
	.word dtmf_phase_852, dtmf_phase_1633 ! C
	.word dtmf_phase_941, dtmf_phase_1633 ! D
	.word dtmf_phase_941, dtmf_phase_1209 ! * (E)
	.word dtmf_phase_941, dtmf_phase_1477 ! # (F)

	.word dtmf_phase_1750, dtmf_phase_1750 ! 0x10    for DEBUG

dtmf_bang_tone:

	! get index in rowcol table

	cp 'B'
	jr nz, 1f
	ld a, 0x10        ! small button, debug out 1750 Hz
1:

	cp 'C'
	jr nz, 1f
	ld a, 0xA        ! CL is A
1:
	cp 'S'
	jr nz, 1f
	ld a, 0xB        ! STO is B
1:
	cp 'R'
	jr nz, 1f
	ld a, 0xC        ! RCL is C
1:
	cp 'E'
	jr nz, 1f
	ld a, 0xD       ! ENT is D
1:
	cp '*'
	jr nz, 1f
	ld a, 0xE       ! *
1:
	cp '#'
	jr nz, 1f
	ld a, 0xF       ! #
1:

	! shift index into offset, pointer to ix

	sla a
	sla a            ! index into byte offset (4 byte records)
	ld e, a
	ld d, 0
	ld ix, dtmf_rowcol_table        ! table[0]
	add ix, de

	! load phase increments

	ld c, [ix+0]
	ld b, [ix+1]
	push bc           ! phase_inc_1
	ld c, [ix+2]
	ld b, [ix+3]
	push bc
	pop iy            ! phase_inc_2 here for a while

	pop bc            ! phase_inc_1
	ld hl, 0          ! phase_acc_1
	ld d, HI(dtmf_sintab)  ! sintab indexes from both DE's

	di  ! YES!

	exx
	push bc
	push de
	push hl           ! save and use another regset for another tone

	push iy
	pop bc            ! phase_inc_2
	ld hl, 0          ! phase_acc_2
	ld d, HI(dtmf_sintab)
	exx

	! reroute tx audio, save previous state to stack

	ld a, [output_0]
	push af
	or O0_CCIRC | O0_MICM               ! Pass tones, cut mic
	out [OUT0], a

	! temporary mode change in timer 1

	ld a, TMR_1 | TMR_LSB | TMR_INTTC
	out [TMR + TMRCTRL], a

	ld a, [cpu_is_P8E]
	or a
	jp nz, 2f
	!
	! P8N loop, no waitstates
	!
1:  ! %%%%%%%%%%%%%%%%%%%%%%
	add hl, bc             ! 11T
	ld e, h                !  4T
	ld a, [de]             !  7T
	ld e, a                !  4T
	exx                    !  4T     bc de hl  swapped
	add hl, bc             ! 11T
	ld e, h                !  4T
	ld a, [de]             !  7T
	exx                    !  4T     bc de hl  swapped
	add e                  !  4T

	out [TMR + 1], a       ! 11T  70T here down
	ld a, WR0_RESET_ESCINT !  7T 
	out [SIO+ACTRL], a     ! 11T
	out [WD], a            ! 11T
	in a, [SIO+ACTRL]      ! 11T
	and SA_DA              !  7T inverted... go if DA low, idle state DA low
	jr z, 1b               ! 12T (when jumping, last one wont matter)
	                       !----------
	! %%%%%%%%%%%%%%%%%%%%%% 130T total
	jp 3f
2:
	!
	! P8E loop, each opcode causes one extra T
	! Want to have the same time anyway (same tables for same timer hw),
	! so 130 * (1/4032000) / (1/8064000) = 260 T-times.
	!
1:  ! %%%%%%%%%%%%%%%%%%%%%%
	add hl, bc             ! 12T
	ld e, h                !  5T
	ld a, [de]             !  8T
	ld e, a                !  5T
	exx                    !  5T     bc de hl  swapped
	add hl, bc             ! 12T
	ld e, h                !  5T
	ld a, [de]             !  8T
	exx                    !  5T     bc de hl  swapped back right way
	add e                  !  5T  70T here up

		! burn 113T padding dummies to use same tables (don't foul a)
		out [WD], a !  1
		out [WD], a !  2
		out [WD], a !  3
		out [WD], a !  4
		out [WD], a !  5
		out [WD], a !  6
		out [WD], a !  7
		out [WD], a !  8
		out [WD], a !  9 * 12T = 108T
		ld e, a     !    +  5T = 113T

	out [TMR + 1], a       ! 12T  77T here down
	ld a, WR0_RESET_ESCINT !  8T 
	out [SIO+ACTRL], a     ! 12T
	out [WD], a            ! 12T
	in a, [SIO+ACTRL]      ! 12T
	and SA_DA              !  8T inverted... go if DA low, idle state DA low
	jr z, 1b               ! 13T (when jumping, last one wont matter)
	                       !----------
	! %%%%%%%%%%%%%%%%%%%%%% 260T total

3:

	! restore timer back to normal

	call init_timer1

	pop af
	out [OUT0], a        ! Restore output switches

	ld a, WR0_RESET_ESCINT
	out [SIO+ACTRL], a   ! Fresh value for next escint

	ld a, 0
	ld [key_timer], a
	ld [keydown], a      ! we waited off the key

	! restore another regset

	exx
	pop hl
	pop de
	pop bc
	exx

	ei
	ret

!========================================================================
!
!  For any wierd reasons, determine if this is P8N or P8E cpu-card.
!
!  8254 clock 1 4.032 MHz     ~248 nsec cycle, same on both.
!
!  P8N:
!    Z80  clock   4.032 MHz     ~248 nsec cycle
!  P8E:
!    Z80  clock   8.064 MHz     ~124 nsec cycle
!    BUT, each opcode fetch causes one extra T-time of wait.
!
!  This MUST BE CALLED EARLY, before initializing
!  anything much.

check_for_P8E_cpu:

	!
	!  Simplify things, program timer for LSB only,
	!  mode set for free counting N, N-1, N-2, N-3
	!

	out [WD], a

	ld a, TMR_1 | TMR_LSB | TMR_INTTC
	out [TMR+TMRCTRL], a

	ld a, 65         ! see below
	out [TMR+1], a   ! go!

	nop; nop; nop; nop; nop
	nop; nop; nop; nop; nop
	nop; nop; nop; nop; nop
	nop; nop; nop; nop; nop ! 20 nops, 4T each without waitstates

	in a, [TMR+1]    ! not counted (11T), some error
	out [WD], a

	!
	!  timer counts 65 steps in 16.1 usec.
	!  P8N:
	!    20 * 4T = 80T = 19.8 usec
	!    timer has rolled over, bit 7 set.
	!  P8E:
	!    20 * 5T = 100T = 12.4 usec
	!    no timer rollover yet, bit 7 clear.
	!
	rlca   ! A.7 into A.0
	and 1
	xor 1
	ld [cpu_is_P8E], a

	ret

!======================================================================

! hl points to first blank after some characters to view

draw_decoder_history:
	push hl
	call clear_lower_colon
	pop hl

	ld de, CU53AN_segs_d_digit_9
	ld b, 10                ! 10 slots to fill
	ld a, [cu_is_alfa]
	or a
	jr z, 1f
	ld de, CU58AF_segs_d_digit_8
	ld b, 9                 ! 9 slots to fill
1:
	ld a, l
	sub b                   ! wind back last+1-ptr to print 9/10 last
	ld l, a
1:
	ld a, [hl]
	inc l
	push hl
	call dpydig
	pop hl
	djnz 1b
	ret

!----------------------------------------------------------------------

sput:
1:
	pop hl
	ld a, [hl]
	inc hl
	push hl
	or a
	ret z
	call dpydig
	jr 1b

draw_string_rightjust:
	push hl
	ld b, 7        ! number of blanks needed at the left
1:
	ld a, [hl]
	inc hl
	cp EOS
	jr z, 1f
	djnz 1b
	jr 2f          ! no blanks at all
1:
	ld a, ' '
	call dpydig
	djnz 1b        ! blank padding
2:
	pop hl         ! refresh string
	ld b, 7
1:
	ld a, [hl]
	inc hl
	cp EOS
	jr z, 1f
	push hl
	call dpydig
	pop hl
	djnz 1b
1:
	ret

!----------------------------------------------------------------------

dpydigzb:
	cp 0
	jp z, 1f
	ld c, 0   ! seen nonzero
1:
	cp 0
	jp nz, 1f
	ld a, c     ! replace initial 0's with ' '
1:
	jp dpydig

dpyhexzb:
	push af
	srl4
	call dpydigzb
	pop af
	and 0xF
	jp dpydigzb

dpyhex:
	push af
	srl4
	call dpydig
	pop af
	and 0xF
	jp dpydig

dpyval255:
	ld b, -1
1:
	inc b		! hundreds
	sub 100
	jr nc, 1b
	add 100

	ld c, -1
1:
	inc c		! tens
	sub 10
	jr nc, 1b
	add 10

	push af		! ones

	ld a, b
	or a
	jr nz, 1f
	ld b, ' '
	or c
	jr nz, 1f
	ld c, ' '
1:
	ld a, b
	call dpydig
	ld a, c
	call dpydig
	pop af
	jp dpydig

dpyval99:

	ld c, -1
1:
	inc c
	sub 10
	jr nc, 1b
	add 10
	push af

	ld a, c
	or a
	jr nz, 1f
	ld a, ' '
1:
	call dpydig
	pop af
	jp dpydig

!----------------------------------------------------------------------

dpydiv99:
	ld h, HI(div99tbl)	; ASSERT(LO(div99tbl) == 0)
	ld l, a
	ld a, [hl]
	jp dpyhex

dpydiv9:
	ld h, HI(div99tbl)	; ASSERT(LO(div99tbl) == 0)
	ld l, a
	ld a, [hl]
	srl4
	jp dpydig

!	digit or character in a
!	location table in de
!	de incremented to next position,
!	hl & a destroyed

dpydig:
	push af
	ld a, [cu_is_alfa]
	or a
	jr z, 1f
	pop af

	push bc
	ld hl, cu58af_font
	ld b, 0
	ld c, a
	add hl, bc
	adc hl, bc
	ld a, [hl]
	ld [de], a
	inc de
	inc hl
	ld a, [hl]
	ld [de], a
	inc de
	pop bc
	ret
1:
	pop af
	push bc
	ld h, HI(cu53an_font)	; ASSERT(LO(cu53an_font) == 0)
	ld l, a
	ld c, [hl]		! what segments (0..6) are lit, what are dim

	ld a, [de]; inc de; rr c; call segment_onoff
	ld a, [de]; inc de; rr c; call segment_onoff
	ld a, [de]; inc de; rr c; call segment_onoff
	ld a, [de]; inc de; rr c; call segment_onoff

	ld a, [de]; inc de; rr c; call segment_onoff
	ld a, [de]; inc de; rr c; call segment_onoff
	ld a, [de]; inc de; rr c; call segment_onoff

	pop bc
	ret

!----------------------------------------------------------------------

! 7 zeroblanked digits to [de] display bitbuf from AHL

draw_long_signed:

	bit 7, a
	jp z, draw_long ! positive

	! save cursor

	push de
	pop iy

	call negate_ahl
	call bin_bcd_AHL_DDEEHHLL

	! BCD result ok in DDEEHHLL

	ld a, d         ! 1st to go
	push hl         ! last 4 ones
	push de         ! middle two in e

	push iy
	pop de          ! cursor back

	cp 0
	ld a, '-'       ! negative value
	jr z, 1f
	ld a, 'E'       ! sorry, must be 0NNNNNN
1:
	call dpydig     ! 1st cannot be set

	ld c, ' '       ! blank leading zeroes

	pop hl          ! middle two from e
	ld a, l
	call dpyhexzb   ! 2nd, 3rd

	pop hl          ! last 4 ones
	push hl
	ld a, h
	call dpyhexzb   ! 4th, 5th

	pop hl          ! last 4 ones
	ld a, l
	call dpyhexzb   ! 6th, 7th

	ret

draw_long:

	! save cursor

	push de
	pop iy

	call bin_bcd_AHL_DDEEHHLL

	! BCD result ok in DDEEHHLL

	ld a, d         ! 1st to go
	push hl         ! last 4 ones
	push de         ! middle two in e

	push iy
	pop de          ! cursor back

	ld c, ' '       ! zeroblanker

	call dpydigzb   ! 1st

	pop hl          ! middle two from e
	ld a, l
	call dpyhexzb   ! 2nd, 3rd

	pop hl          ! last 4 ones
	push hl
	ld a, h
	call dpyhexzb   ! 4th, 5th

	pop hl          ! last 4 ones
	ld a, l
	call dpyhexzb   ! 6th, 7th

	ret

!----------------------------------------------------------------------

draw_word:

	push de
	pop iy                     ! save cursor

	ld a, 0                    ! HL has word, AHL now long
	call bin_bcd_AHL_DDEEHHLL

	ld a, e                    ! BCD result ok in EHHLL
	push hl

	push iy
	pop de                     ! cursor back

	ld c, ' '
	call dpydigzb

	pop hl
	push hl
	ld a, h
	call dpyhexzb

	pop hl
	ld a, l
	call dpyhexzb

	ret

!----------------------------------------------------------------------

bin_bcd_AHL_DDEEHHLL:

	! 3 bytes of binary input in AHL, to c ix

	push hl
	pop ix
	ld c, a

	! 3 and half bytes of packed BCD, result, MSNibble d, in ddeehhll

	xor a
	ld l, a
	ld h, a
	ld e, a
	ld d, a

	ld b, 24         ! 24 bits binary value
	jp 2f            ! 24 shifts
1:
	! BCD adjustment after all but last shift
	! if nibble >= 5, 3 added to nibble

#define __ADD3 \
	add 0x33; jp m, 3f; sub 0x30; 3: bit 3, a; jp nz, 3f; sub 0x03; 3:

	ld a, l; __ADD3; ld l, a
	ld a, h; __ADD3; ld h, a
	ld a, e; __ADD3; ld e, a
	ld a, d; __ADD3; ld d, a

#undef __ADD3
2:
	add ix, ix      ! ix <<= 1
	rl c
	rl l            ! shift the bits 1 bit up, binary MSbit into BCD LSbit
	rl h
	rl e
	rl d
	djnz 1b

	! BCD result ok in DEEHHLL

	ret

!======================================================================

a2i_byte:
	call a2i   ! long in AHL
	or h       ! AH zero ?
	ld a, l
	ret z
	ld a, 0xFF
	ret           ! byte in A

a2i_word:
	call a2i   ! long in AHL
	or a       ! A zero ?
	ret z
	ld hl, 0xFF
	ret           ! word in HL

!======================================================================

init_menu:
	ld ix, menu
	ld [menu_ptr], ix
	ret

! 6 digits, title string

draw_menu_title:
	call clear_upper_colons

	ld ix, [menu_ptr]

	ld a, [ix+offset_title+0]
	call dpydig
	ld a, [ix+offset_title+1]
	call dpydig
	ld a, [ix+offset_title+2]
	call dpydig
	ld a, [ix+offset_title+3]
	call dpydig
	ld a, [ix+offset_title+4]
	call dpydig
	ld a, [ix+offset_title+5]
	call dpydig
	ret

! TT:b1234567, where :b is nonexistent in CU58AF

draw_menu_lower_row:

	ld ix, [menu_ptr]
	ld a, [ix+offset_tag+0]
	call dpydig
	ld a, [ix+offset_tag+1]
	call dpydig

	ld a, [cu_is_alfa]
	or a
	jp nz, 1f
	call draw_lower_colon
	ld a, ' '
	call dpydig
1:
	ld ix, [menu_ptr]
	ld a, [ix+offset_type]
	cp CFG_BYTE
	jp z, draw_menu_byte
	cp CFG_WORD
	jp z, draw_menu_word
	cp CFG_FREQ
	jp z, draw_menu_freq
	cp CFG_TAB
	jp z, draw_menu_tab
	cp CFG_DYN
	jp z, draw_menu_dyn
	cp CFG_RST
	jp z, draw_menu_rst
	cp CFG_STR
	jp z, draw_menu_str
	cp CFG_DPX
	jp z, draw_menu_dpx
	cp CFG_cSEC
	jp z, draw_menu_csec

	call sput; .asciz "???????"
	ret

! return value-pointer of record ix in hl

load_menu_ptr:
	ld l, [ix+offset_ptr+0]
	ld h, [ix+offset_ptr+1]
	ret

load_menu_arg:
	ld l, [ix+offset_arg+0]
	ld h, [ix+offset_arg+1]
	ret

draw_menu_byte:
	call sput; .asciz "    "  ! 4 blanks, 3 zeroblanked digits
	call load_menu_ptr
	ld a, [hl]
	jp dpyval255

draw_menu_csec:
	call sput; .asciz "   "  ! 3 blanks, 3 zeroblanked digits, fixed 0
	call load_menu_ptr
	ld a, [hl]
	call dpyval255
	ld a, '0'
	jp dpydig

draw_menu_word:
	call sput; .asciz "  "    ! 2 blanks, 5 zeroblanked digits
	call load_menu_ptr
	push hl
	pop ix
	ld l, [ix+0]
	ld h, [ix+1]
	jp draw_word

draw_menu_freq:              ! 7 zeroblanked digits
	call load_menu_ptr
	push hl
	pop ix
	load_ahl_ix_0
	jp draw_long

draw_menu_dpx:               ! 7 zeroblanked digits
	call load_menu_ptr
	push hl
	pop ix
	load_ahl_ix_0
	or h
	or l
	jp z, 1f
	load_ahl_ix_0
	jp draw_long_signed
1:
	call sput; .asciz "    oFF"
	ret

draw_menu_tab:
	call load_menu_ptr
	ld a, [hl]
	call load_menu_arg
	cp [hl]
	jr c, 1f
	ld a, 0              ! out of range value, overwrite [0] (always default)
1:
	inc hl               ! point to string array
	ld c, a
	ld b, 0
	sla c; rl b    ! 2
	sla c; rl b    ! 4
	sla c; rl b    ! 8
	add hl, bc
	jp draw_string_rightjust

draw_menu_dyn:
	call load_menu_arg
	push hl
	ret
	ret

draw_menu_rst:
	call sput; .asciz "  666 ?"
	ret

draw_menu_str:
	call load_menu_ptr
	jp draw_string_rightjust

!======================================================================

draw_rfc_dpy:
	ld a, [rfc]
	call dpyval255
	ld a, ' '
	call dpydig
	ld a, [ad_rssi]
	call dpyval255
	ret

menu_rfc_change:
	cp -1
	jp z, 1f
	cp +1
	jp z, 1f
	call a2i_byte
	ld [rfc], a
	ld a, 0
1:
	ld hl, rfc
	add [hl]
	ld [hl], a
	out [DA_RFC], a
	call save_rfc
	ret

!----------------------------------------------------------------------

draw_batt_dpy:
	call sput; .asciz "    "
	ld a, [ad_batt]
	call dpyval255
	ret

draw_sql_dpy:
	ld a, [cfg_squelch_level]
	call dpyval255
	ld a, ' '
	call dpydig
	call read_squelcher_value
	call dpyval255
	ret

menu_sql_change:
	cp 0
	jp nz, 1f
	call a2i_byte
	ld [cfg_squelch_level], a
	ret
1:
	ld hl, cfg_squelch_level
	add [hl]
	ld [hl], a
	ret

!----------------------------------------------------------------------

decoder_hist_rewind:
	ld a, [ccir_hist_idx]      ! points usually past last blank
	dec a
	ld [ccir_hist_finger], a

	ld a, [dtmf_hist_idx]
	dec a
	ld [dtmf_hist_finger], a

	ld a, [fsk_hist_idx]
	dec a
	ld [fsk_hist_finger], a
	ret

ccir_hist_walk:
	ld hl, ccir_hist_finger
	jp decoder_history_walk

dtmf_hist_walk:
	ld hl, dtmf_hist_finger
	jp decoder_history_walk

fsk_hist_walk:
	ld hl, fsk_hist_finger
	jp decoder_history_walk

decoder_history_walk:
	add [hl]
	ld [hl], a
	ret

!----------------------------------------------------------------------

draw_ccir_hist:
	ld hl, [ccir_hist_finger] ! current peeking offset (ld l, [infact])
	ld h, HI(ccir_history)   ! history page
	jp draw_decoder_history

draw_dtmf_hist:
	ld hl, [dtmf_hist_finger] ! current peeking offset
	ld h, HI(dtmf_history)   ! history page
	jp draw_decoder_history

draw_fsk_hist:
	ld hl, [fsk_hist_finger]  ! current peeking offset
	ld h, HI(fsk_history)    ! history page
	jp draw_decoder_history

!----------------------------------------------------------------------

toggle_or_position_menu:
	ld a, [digidx]
	or a
	jp nz, 1f              ! shortcut to record with digits
	ld a, [menu_active]
	xor 1
	ld [menu_active], a
	or a
	call z, save_nvdata    ! leaving menu
	ret
1:
	call a2i
	ld de, num_menu
	and a
	sbc hl, de
	jp c, 1f
	ld hl, -1
1:
	add hl, de
	ld a, 0
	ld c, size_menurec
	call mul248
	ld bc, menu
	add hl, bc
	ld [menu_ptr], hl
	ld a, 1
	ld [menu_active], a
	ret

menu_enter_or_walk:
	ld a, [digidx]
	or a
	jp z, menu_next

	call menu_new_value
	ld a, 0
	ld [digidx], a
	ret

menu_defval_or_exec:
	ld ix, [menu_ptr]
	call load_menu_ptr            ! into hl
	ld a, [ix + offset_type]
	cp CFG_DPX
	jp z, menu_set_duplex_def      ! CFG_DPX, copy cfg_other_duplex
	cp CFG_FREQ
	jp z, menu_set_from_vfo        ! CFG_FREQ, copy rx_freq
	cp CFG_EXE
	jp nz, reset_menurec
	jp [hl]                        ! CFG_EXE, jump to ptr

menu_set_duplex_def:
	push hl
	pop ix
	load_ahl(cfg_other_duplex)
	save_ahl_ix_0
	ret

menu_set_from_vfo:
	push hl
	pop ix
	load_ahl(rx_freq)
	save_ahl_ix_0
	ret

menu_next_group:
	ld ix, [menu_ptr]
	ld b, [ix+offset_tag+0]
	ld c, [ix+offset_tag+1]
1:
	push bc
	call menu_next
	pop bc
	ld ix, [menu_ptr]
	ld a, [ix+offset_tag+0]
	cp b
	ret nz
	ld a, [ix+offset_tag+1]
	cp c
	ret nz
	jp 1b

menu_next:
	ld bc, size_menurec
	jp menu_next_prev
menu_prev:
	ld bc, -size_menurec
	jp menu_next_prev

menu_next_prev:
	ld hl, [menu_ptr]
	add hl, bc
	ld a, HI(end_menu)
	cp h
	jr nz, 1f
	ld a, LO(end_menu)
	cp l
	jr nz, 1f
	ld hl, menu
1:
	ld a, HI(menu - size_menurec)
	cp h
	jr nz, 1f
	ld a, LO(menu - size_menurec)
	cp l
	jr nz, 1f
	ld hl, end_menu - size_menurec
1:
	ld [menu_ptr], hl
	ret

menu_new_value:
	ld ix, [menu_ptr]
	call load_menu_ptr          ! hl -> var
	ld a, [ix+offset_type]
	cp CFG_BYTE
	jp z, menu_new_value_byte
	cp CFG_WORD
	jp z, menu_new_value_word
	cp CFG_FREQ
	jp z, menu_new_value_freq
	cp CFG_TAB
	jp z, menu_new_value_tab
	cp CFG_DYN
	jp z, menu_new_value_dyn
	cp CFG_RST
	jp z, menu_new_value_rst
	cp CFG_STR
	jp z, menu_new_value_str
	cp CFG_DPX
	jp z, menu_new_value_dpx
	cp CFG_cSEC
	jp z, menu_new_value_csec

	ret


menu_new_value_byte:
	push hl
	call a2i_byte
	pop ix
	ld [ix+0], a
	ret

menu_new_value_csec:
	push hl
	ld a, [digidx]
	dec a
	ld [digidx], a      ! 10# for millisecs, we need 1# for cSECs
	call a2i_byte
	pop ix
	ld [ix+0], a
	ret

menu_new_value_word:
	push hl
	call a2i_word
	pop ix
	ld [ix+0], l
	ld [ix+1], h
	ret

menu_new_value_tab:
	push hl               ! variable
	call load_menu_arg
	ld c, [hl]
	push bc               ! count of selections
	call a2i_byte
	pop bc
	cp c
	jp c, 1f
	ld a, c
	dec a
1:
	pop hl
	ld [hl], a
	ret

menu_new_value_rst:
	push hl
	ret
	ret

empty_string: .byte EOS,EOS,EOS,EOS,EOS,EOS,EOS,EOS,EOS,EOS,EOS,EOS

menu_new_value_str:
	push hl
	push hl
	pop de
	ld hl, empty_string
	ld bc, SIZE_STR
	ldir
	pop de
	ld hl, digbuf
	ld a, [digidx]
	or a
	ret z
	cp SIZE_STR
	jr c, 1f
	ld a, SIZE_STR
1:
	ld c, a
	ld b, 0
	ld a, 0
	ldir
	ret

menu_new_value_freq:
	push hl
	call a2i
	pop ix
	save_ahl_ix_0
	ret

menu_new_value_dpx:
	push hl
	call a2i
	pop ix
	ld c, [ix+2]        ! previous MSByte
	bit 7, c
	call nz, negate_ahl ! previous was negative, so...
	save_ahl_ix_0
	ret

menu_up_value:
	ld a, +1
	jp 1f

menu_dn_value:
	ld a, -1
1:
	push af                     ! direction in stack

	ld ix, [menu_ptr]
	call load_menu_ptr          ! hl -> var
	ld a, [ix+offset_type]
	cp CFG_DYN
	jp z, menu_step_value_dyn
	cp CFG_BYTE
	jp z, menu_step_value_byte
	cp CFG_cSEC
	jp z, menu_step_value_byte
	cp CFG_TAB
	jp z, menu_step_value_tab
	cp CFG_WORD
	jp z, menu_step_value_word
	cp CFG_FREQ
	jp z, menu_step_value_freq
	cp CFG_DPX
	jp z, menu_step_value_dpx

	pop af
	ret         ! doh, +/- no effect

menu_step_value_dpx:
	pop af               ! duplex value stepped, just flip between neg/pos
	push hl
	pop ix
	load_ahl_ix_0
	call negate_ahl
	save_ahl_ix_0
	ret

menu_step_value_freq:
	call get_probable_chstep_de
	pop af
	push hl
	pop ix
	cp +1
	load_ahl_ix_0
	jp z, 1f
	and a
	sbc hl, de
	sbc 0
	jp 2f
1:
	add hl, de
	adc 0
2:
	save_ahl_ix_0
	ret

menu_step_value_word:
	pop af
	ld bc, 1
	cp +1
	jp z, 1f
	ld bc, -1
1:
	push hl
	pop ix
	ld l, [ix+0]
	ld h, [ix+1]
	add hl, bc
	ld [ix+0], l
	ld [ix+1], h
	ret

menu_step_value_byte:
	pop af
	add [hl]
	ld [hl], a                   ! +=   +1 or -1
	ret

menu_step_value_tab:
	pop af
	add [hl]
	ld b, a                   ! +=   +1 or -1
	push hl                ! save ptr
	call load_menu_arg     ! for max-1
	ld a, [hl]
	ld c, a
	pop hl
	ld a, b
	cp -1
	jp nz, 1f
	ld a, c
	dec a             ! count - 1 if down from 0
1:
	cp c
	jp c, 1f
	ld a, 0           ! 0 if up from max
1:
	ld [hl], a
	ret

menu_step_value_dyn:
	pop af
	jp 1f
menu_new_value_dyn:
	ld a, 0
1:
	push af
	ld a, h
	or l
	ret z             ! null ptr, non-editable field
	pop af
	jp [hl]

!----------------------------------------------------------------------

reset_menurec:
	ld a, [ix + offset_type]

	cp CFG_BYTE
	jp z, reset_menurec_byte
	cp CFG_TAB
	jp z, reset_menurec_byte
	cp CFG_cSEC
	jp z, reset_menurec_byte

	cp CFG_WORD
	jp z, reset_menurec_word

	cp CFG_STR
	jp z, reset_menurec_str

	ret

reset_menurec_str:
	call load_menu_ptr
	ld a, EOS
	ld [hl], a
	ret

reset_menurec_byte:
	call load_menu_ptr
	ld a, [ix + offset_def]
	ld [hl], a
	ret

reset_menurec_word:
	call load_menu_ptr
	ld a, [ix + offset_def + 0]
	ld [hl], a
	inc hl
	ld a, [ix + offset_def + 1]
	ld [hl], a
	ret

!----------------------------------------------------------------------
!
!  SETUP GUNK MACROS

	! 1 byte          number of selections in table
	! n * 8 bytes     zero terminated strings, 8 bytes separated

#define TAB(name) 1: name: .byte (1f - . - 1) / 8
#define   STR(s)           2: .ascii s; .fill 8 - (. - 2b), 0xFF
#define ENDTABS          1:


#define REC(grp, name, type, ptr, arg, def) \
	1: .ascii grp;  ASSERT((.-1b)==2);      \
	1: .ascii name; ASSERT((.-1b)==6);      \
	.word ptr;                              \
	.word arg;                              \
	.word def;                              \
	.byte type;                             \
	.byte 'Z';                              \
	.align 4

offset_tag   = 0
offset_title = 2
offset_ptr   = 8
offset_arg   = 10
offset_def   = 12
offset_type  = 14

size_menurec = 16

	.align 4

!== SETUP TABLES ======================================================

menu:
	REC("GE", "tPc   ",CFG_BYTE, cfg_txpwr,          0,               0)
	REC("GE", "CtCSS ",CFG_BYTE, cfg_ctcss_hz,       0,               0)
	REC("GE", "GPio 1",CFG_TAB,  0,                  tab_onoff,       0)
	REC("GE", "Loud  ",CFG_BYTE, cfg_click_vol,      0,               1)

	REC("to", "LiGHtS",CFG_BYTE, cfg_light_seconds,  0,             255)
	REC("to", "IGnAPO",CFG_BYTE, cfg_ign_apo_hours,  0,             255)
	REC("to", "tr tot",CFG_BYTE, cfg_tx_tot_minutes, 0,               0)

	REC("Sq", "SqL   ",CFG_DYN,  menu_sql_change,    draw_sql_dpy,    0)
	REC("Sq", "SqL db",CFG_BYTE, cfg_squelch_60db,   0,             255)
	REC("Sq", "HySt  ",CFG_BYTE, cfg_squelch_hyst,   0,               4)
	REC("Sq", "oPEn  ",CFG_cSEC, cfg_squelch_head,   0,              10)
	REC("Sq", "tAIL  ",CFG_cSEC, cfg_squelch_tail,   0,              10)
	REC("Sq", "SourcE",CFG_TAB,  cfg_squelch_source, tab_sqsrc,       0)

	REC("LP", "7 SqL ",CFG_BYTE, cfg_def_squelch,    0,               0)
	REC("LP", "8 CHAn",CFG_BYTE, cfg_def_memory,     0,               0)
	REC("LP", "9 FrEq",CFG_FREQ, cfg_def_frequency,  0,               0)
	REC("LP", "0 Loud",CFG_BYTE, cfg_def_volume,     0,               1)


/* bands */
	REC("b1", "StArt ",CFG_FREQ, cfg_band1_start,    0,               0)
	REC("b1", "End   ",CFG_FREQ, cfg_band1_end,      0,               0)
	REC("b1", "duPL  ",CFG_DPX,  cfg_band1_duplex,   0,               0)
	REC("b1", "StEP  ",CFG_TAB,  cfg_band1_step,     tab_chstep,      0)
	REC("b1", "SCtAIL",CFG_BYTE, cfg_band1_sctail,   0,               1)
	REC("b1", "LIStEn",CFG_BYTE, cfg_band1_sclisten, 0,              15)

	REC("b2", "StArt ",CFG_FREQ, cfg_band2_start,    0,               0)
	REC("b2", "End   ",CFG_FREQ, cfg_band2_end,      0,               0)
	REC("b2", "duPL  ",CFG_DPX,  cfg_band2_duplex,   0,               0)
	REC("b2", "StEP  ",CFG_TAB,  cfg_band2_step,     tab_chstep,      0)
	REC("b2", "SCtAIL",CFG_BYTE, cfg_band2_sctail,   0,               1)
	REC("b2", "LIStEn",CFG_BYTE, cfg_band2_sclisten, 0,              15)

	REC("b3", "StArt ",CFG_FREQ, cfg_band3_start,    0,               0)
	REC("b3", "End   ",CFG_FREQ, cfg_band3_end,      0,               0)
	REC("b3", "duPL  ",CFG_DPX,  cfg_band3_duplex,   0,               0)
	REC("b3", "StEP  ",CFG_TAB,  cfg_band3_step,     tab_chstep,      0)
	REC("b3", "SCtAIL",CFG_BYTE, cfg_band3_sctail,   0,               1)
	REC("b3", "LIStEn",CFG_BYTE, cfg_band3_sclisten, 0,              15)

	REC("b4", "StArt ",CFG_FREQ, cfg_band4_start,    0,               0)
	REC("b4", "End   ",CFG_FREQ, cfg_band4_end,      0,               0)
	REC("b4", "duPL  ",CFG_DPX,  cfg_band4_duplex,   0,               0)
	REC("b4", "StEP  ",CFG_TAB,  cfg_band4_step,     tab_chstep,      0)
	REC("b4", "SCtAIL",CFG_BYTE, cfg_band4_sctail,   0,               1)
	REC("b4", "LIStEn",CFG_BYTE, cfg_band4_sclisten, 0,              15)

	REC("b5", "StArt ",CFG_FREQ, cfg_band5_start,    0,               0)
	REC("b5", "End   ",CFG_FREQ, cfg_band5_end,      0,               0)
	REC("b5", "duPL  ",CFG_DPX,  cfg_band5_duplex,   0,               0)
	REC("b5", "StEP  ",CFG_TAB,  cfg_band5_step,     tab_chstep,      0)
	REC("b5", "SCtAIL",CFG_BYTE, cfg_band5_sctail,   0,               1)
	REC("b5", "LIStEn",CFG_BYTE, cfg_band5_sclisten, 0,              15)

	REC("b6", "StArt ",CFG_FREQ, cfg_band6_start,    0,               0)
	REC("b6", "End   ",CFG_FREQ, cfg_band6_end,      0,               0)
	REC("b6", "duPL  ",CFG_DPX,  cfg_band6_duplex,   0,               0)
	REC("b6", "StEP  ",CFG_TAB,  cfg_band6_step,     tab_chstep,      0)
	REC("b6", "SCtAIL",CFG_BYTE, cfg_band6_sctail,   0,               1)
	REC("b6", "LIStEn",CFG_BYTE, cfg_band6_sclisten, 0,              15)
/* and else */
	REC("bo", "duPL  ",CFG_DPX,  cfg_other_duplex,   0,               0)
	REC("bo", "StEP  ",CFG_TAB,  cfg_other_step,     tab_chstep,      0)
	REC("bo", "SCtAIL",CFG_BYTE, cfg_other_sctail,   0,               1)
	REC("bo", "LIStEn",CFG_BYTE, cfg_other_sclisten, 0,              15)

	REC("SC", "rAtE  ",CFG_cSEC, cfg_scan_rate,      0,               5)

	REC("rJ", "rEJ  0",CFG_FREQ, cfg_reject_0,       0,               0)
	REC("rJ", "rEJ  1",CFG_FREQ, cfg_reject_1,       0,               0)
	REC("rJ", "rEJ  2",CFG_FREQ, cfg_reject_2,       0,               0)
	REC("rJ", "rEJ  3",CFG_FREQ, cfg_reject_3,       0,               0)
	REC("rJ", "rEJ  4",CFG_FREQ, cfg_reject_4,       0,               0)
	REC("rJ", "rEJ  5",CFG_FREQ, cfg_reject_5,       0,               0)
	REC("rJ", "rEJ  6",CFG_FREQ, cfg_reject_6,       0,               0)
	REC("rJ", "rEJ  7",CFG_FREQ, cfg_reject_7,       0,               0)
	REC("rJ", "rEJ  8",CFG_FREQ, cfg_reject_8,       0,               0)
	REC("rJ", "rEJ  9",CFG_FREQ, cfg_reject_9,       0,               0)

	REC("Sh", "ShCut0",CFG_STR,  cfg_shortcut_0,     0,               0)
	REC("Sh", "ShCut1",CFG_STR,  cfg_shortcut_1,     0,               0)
	REC("Sh", "ShCut2",CFG_STR,  cfg_shortcut_2,     0,               0)
	REC("Sh", "ShCut3",CFG_STR,  cfg_shortcut_3,     0,               0)
	REC("Sh", "ShCut4",CFG_STR,  cfg_shortcut_4,     0,               0)
	REC("Sh", "ShCut5",CFG_STR,  cfg_shortcut_5,     0,               0)
	REC("Sh", "ShCut6",CFG_STR,  cfg_shortcut_6,     0,               0)
	REC("Sh", "ShCut7",CFG_STR,  cfg_shortcut_7,     0,               0)
	REC("Sh", "ShCut8",CFG_STR,  cfg_shortcut_8,     0,               0)
	REC("Sh", "ShCut9",CFG_STR,  cfg_shortcut_9,     0,               0)

	REC("AL", "id   1",CFG_STR,  cfg_mycall_1,       0,               0)
	REC("AL", "id   2",CFG_STR,  cfg_mycall_2,       0,               0)
	REC("AL", "id   3",CFG_STR,  cfg_mycall_3,       0,               0)
	REC("AL", "ccir 1",CFG_STR,  cfg_ccir_1,         0,               0)
	REC("AL", "ccir 2",CFG_STR,  cfg_ccir_2,         0,               0)
	REC("AL", "ccir 3",CFG_STR,  cfg_ccir_3,         0,               0)
	REC("AL", "dtnf 1",CFG_STR,  cfg_dtmf_3,         0,               0)
	REC("AL", "dtnf 2",CFG_STR,  cfg_dtmf_3,         0,               0)
	REC("AL", "dtnf 3",CFG_STR,  cfg_dtmf_3,         0,               0)
	REC("AL", "PEPA  ",CFG_STR,  cfg_pepa_on,        0,               0)
	REC("AL", "PEPAoF",CFG_STR,  cfg_pepa_off,       0,               0)
	REC("AL", "Loud  ",CFG_BYTE, cfg_alert_vol,      0,               7)
	REC("AL", "cirdur",CFG_cSEC, cfg_ccir_minlen,    0,              20)
	REC("AL", "dtfdur",CFG_BYTE, cfg_dtmf_holdtime,  0,               5)

	REC("tr", "tr Lo ",CFG_FREQ, cfg_tx_band_start,  0,               0)
	REC("tr", "tr Hi ",CFG_FREQ, cfg_tx_band_end,    0,               0)
	REC("tr", "trSPot",CFG_FREQ, cfg_tx_oob,         0,               0)

	REC("dH", "ccir H",CFG_DYN,  ccir_hist_walk,     draw_ccir_hist,  0)
	REC("dH", "dtnf H",CFG_DYN,  dtmf_hist_walk,     draw_dtmf_hist,  0)
	REC("dH", "FSK  H",CFG_DYN,  fsk_hist_walk,      draw_fsk_hist,   0)

	REC("Fn", "Func  ",CFG_TAB,  cfg_function,       tab_func,        0)

	REC("PH", "SynCrd",CFG_TAB,  cfg_synth_card,     tab_synth_card,  0)
	REC("PH", "3diGit",CFG_STR,  cfg_implied,        0,               0)
	REC("PH", "IFFrEq",CFG_FREQ, cfg_if_freq,        0,               0)
	REC("PH", "r CEnt",CFG_FREQ, cfg_rx_vco_center,  0,               0)
	REC("PH", "t CEnt",CFG_FREQ, cfg_tx_vco_center,  0,               0)
	REC("PH", "LPFILt",CFG_WORD, cfg_lpf_hz,         0,            3600)

	REC("dF", "ALLrSt",CFG_RST,  disaster,           0,               0)
	REC("dF", "CH rSt",CFG_RST,  wipe_memories,      0,               0)
	REC("dF", "SAnE  ",CFG_RST,  sane_defaults,      0,               0)

	REC("St", "bAtt  ",CFG_DYN,  0,                  draw_batt_dpy,   0)
	REC("St", "SoFt  ",CFG_STR,  version,            0,               0)

	REC("rF", "rFc   ",CFG_DYN,  menu_rfc_change,    draw_rfc_dpy,    0)
end_menu:

num_menu = (end_menu - menu) / size_menurec

	TAB(tab_func)
		STR("Std")
		STR("rPtr")
		STR("SLAvE")
	TAB(tab_onoff)
		STR("oFF")
		STR("on")
	TAB(tab_off_on_flip)
		STR("oFF")
		STR("on")
		STR("FLIP")
	TAB(tab_sqsrc)
		STR("SqL")
		STR("SqLnot")
		STR("rSSI")
	TAB(tab_chstep)
		STR("25")
		STR("20")
		STR("15")
		STR("12_5")
		STR("10")
	TAB(tab_synth_card)
		STR("S8d")
		STR("S8c")
		STR("S8b")
	ENDTABS


!== SETUP DEFAULTS wrt BAND ===========================================

#define X(_f) .byte LO(_f), LO((_f) >> 8), LO((_f) >> 16);

	! IMPLIED
	! 1st I/F
	! VCO A/B rx
	! VCO A/B tx
	! TX LIMITS
	! BAND1:   start end duplex step
	! BAND2:   start end duplex step
	! OTHER:             duplex step

defaults_70cm:
	.byte 4,3,3, EOS, EOS, EOS
	X( 86512)
	X(450000)
	X(450000)
	X(432000) X(438000)
	X(433400) X(433600) X(    0) .byte STEP_25
	X(434600) X(435000) X(-1600) .byte STEP_25
	                    X(-1600) .byte STEP_25

defaults_2m:
	.byte 1,4,5, EOS, EOS, EOS
	X( 21400)
	X(150000)
	X(150000)
	X(144000) X(146000)
	X(145200) X(145600) X(   0) .byte STEP_25
	X(145600) X(145800) X(-600) .byte STEP_25
	                    X(-600) .byte STEP_25

defaults_6m:
	.byte 0,5,1, EOS, EOS, EOS
	X( 45000)
	X( 60000)
	X( 60000)
	X( 50000) X( 52000)
	X( 51490) X( 51610) X(   0) .byte STEP_20
	X( 51810) X( 51970) X(-600) .byte STEP_20
	                    X(-600) .byte STEP_20

#undef X

set_defaults_band:
	ld a, [cfg_synth_card]
	push af
	call reset_menurecords   ! remember radio type during reset
	pop af
	ld [cfg_synth_card], a
	cp S8B
	ld hl, defaults_6m
	jp z, 1f
	cp S8C
	ld hl, defaults_2m
	jp z, 1f
	ld hl, defaults_70cm
1:
	ldi_6(cfg_implied)
	ldi_3(cfg_if_freq)
	ldi_3(cfg_rx_vco_center)
	ldi_3(cfg_tx_vco_center)

	ldi_6(cfg_tx_band_start)    ! and end

	ldi_10(cfg_band1_start)    ! and end, duplex, step
	ldi_10(cfg_band2_start)    ! and end, duplex, step

	ldi_3(cfg_other_duplex)
	ldi_1(cfg_other_step)

	call save_nvdata
	jp powerdown


get_probable_chstep_de:
	ld a, [cfg_synth_card]
	ld de, 20
	cp S8B
	ret z
	ld de, 25
	ret


reset_menurecords:
	ld ix, menu
1:
	call reset_menurec
	ld de, size_menurec
	add ix, de
	push ix
	pop de
	ld a, d
	cp HI(end_menu)
	jp nz, 1b
	ld a, e
	cp LO(end_menu)
	jp nz, 1b

	ret

check_for_666:
	call a2i
	sub_ahl_immde(666)
	or h
	or l
	ret

!----------------------------------------------------------------------
sane_defaults:
	call check_for_666
	ret nz
	jp set_defaults_band

disaster:
	call check_for_666
	ret nz

	ld a, [cfg_synth_card]
	ld b, a
	ld hl, nvstart
1:
	ld a, 0
	ld [hl], a
	inc hl
	ld a, h
	cp HI(nvend)
	jr nz, 1b
	ld a, l
	cp LO(nvend)
	jr nz, 1b

	ld a, b
	ld [cfg_synth_card], a

	jp set_defaults_band

wipe_memories:
	ld hl, memories
1:
	ld a, 0
	ld [hl], a
	inc hl
	ld a, h
	cp HI(end_memories)
	jr nz, 1b
	ld a, l
	cp LO(end_memories)
	jr nz, 1b

	ret

!======================================================================

	.ascii "TheEnd"
	.byte .cksum(0, .)

1:
	.data

	.org 0xC000		! start of RAM

!======================================================================
!
!	Variables
!

!----------------------------------------------------------------------
nvstart:					!------------------------------------------

volume          BYTE
audio_dst       BYTE
squelch_forced  BYTE
scan_mode       BYTE

mem_flags   BYTE
mem_idx     BYTE

rx_freq     FREQ
tx_freq     FREQ

duplex_state  BYTE
duplex_shift  FREQ
band          BYTE
band_step     BYTE
band_step_hz  WORD
band_sctail   BYTE
band_sclisten BYTE

!-----------
VIP_COUNT = 10
vip_list	BUF(SIZE_FREQ * VIP_COUNT)

!-----------
!  RFC values fold over every 100 MHz, each 1 MHz has separate value
!
rfctab:     .rs 100

!-----------
!  12 bytes per memory:
!
!    @0     3 bytes rx-frequency
!    @3     3 bytes tx-frequency
!    @6     1 byte  misc bits
!    @7     1 byte  ctcss hz
!    @8     4 bytes reserved
!

mem_FLAGS  = 6         ! offsets
mem_CTCSS  = 7
mem_SIZE   = 12

MEM_VALID     = 0x01   ! flag bits
MEM_HIDDEN    = 0x02
MEM_SCANNABLE = 0x04


memories:    .rs 130 * mem_SIZE
end_memories:

!== SETUP BLOCK =======================================================

	cfg_function          BYTE

	cfg_implied           STRING   ! STRING

	cfg_txpwr             BYTE     ! Transmitter power level
	cfg_alert_vol         BYTE     ! Alert volume
	cfg_click_vol         BYTE     ! Keyclick
	cfg_light_seconds     BYTE     ! seconds
	cfg_ign_apo_hours     BYTE     ! powerdown without manipulation nor IGN
	cfg_tx_tot_minutes    BYTE     ! powerdown if tx longer

	cfg_scan_rate         BYTE     ! cSEC 0...2550

	cfg_squelch_source    BYTE	   ! SQL, /SQL or RSSI
	cfg_squelch_level     BYTE     ! between +/- half hysteresis
	cfg_squelch_60db      BYTE     ! REALLY STRONG SIGNAL
	cfg_squelch_hyst      BYTE     ! difference of open and close levels
	cfg_squelch_head      BYTE     ! opening "tail"
	cfg_squelch_tail      BYTE     ! closing tail

	cfg_def_squelch       BYTE 
	cfg_def_memory        BYTE 
	cfg_def_frequency     FREQ 
	cfg_def_volume        BYTE 

	cfg_synth_card        BYTE     ! TAB    S8x enumeration
	cfg_if_freq           FREQ     ! 1st I/F
	cfg_rx_vco_center     FREQ     ! 
	cfg_tx_vco_center     FREQ     ! 

	cfg_ctcss_hz          BYTE     ! 0..255 Hz

	cfg_lpf_hz            WORD     ! low-pass cutoff freq

	cfg_tx_oob            FREQ     ! Single spot allowed tx out-of-band

	cfg_tx_band_start     FREQ     ! start/end pairs must be successive
	cfg_tx_band_end       FREQ 

size_bandrec = (3 * SIZE_FREQ + 3 + 2)      ! bands 1...6
	cfg_band1_start       FREQ
	cfg_band1_end         FREQ 
	cfg_band1_duplex      FREQ     ! CFG_DPX (includes sign)
	cfg_band1_step        BYTE     ! TAB (STEP_xx)
	cfg_band1_sctail      BYTE     ! seconds of lingering after LOS
	cfg_band1_sclisten    BYTE     ! seconds of stay at one location
	                      .rs 2
	cfg_band2_start       FREQ 
	cfg_band2_end         FREQ 
	cfg_band2_duplex      FREQ 
	cfg_band2_step        BYTE     ! TAB (STEP_xx)
	cfg_band2_sctail      BYTE     ! seconds of lingering after LOS
	cfg_band2_sclisten    BYTE     ! seconds of stay at one location
	                      .rs 2
	cfg_band3_start       FREQ 
	cfg_band3_end         FREQ 
	cfg_band3_duplex      FREQ 
	cfg_band3_step        BYTE     ! TAB (STEP_xx)
	cfg_band3_sctail      BYTE     ! seconds of lingering after LOS
	cfg_band3_sclisten    BYTE     ! seconds of stay at one location
	                      .rs 2
	cfg_band4_start       FREQ 
	cfg_band4_end         FREQ 
	cfg_band4_duplex      FREQ 
	cfg_band4_step        BYTE     ! TAB (STEP_xx)
	cfg_band4_sctail      BYTE     ! seconds of lingering after LOS
	cfg_band4_sclisten    BYTE     ! seconds of stay at one location
	                      .rs 2
	cfg_band5_start       FREQ 
	cfg_band5_end         FREQ 
	cfg_band5_duplex      FREQ 
	cfg_band5_step        BYTE     ! TAB (STEP_xx)
	cfg_band5_sctail      BYTE     ! seconds of lingering after LOS
	cfg_band5_sclisten    BYTE     ! seconds of stay at one location
	                      .rs 2
	cfg_band6_start       FREQ 
	cfg_band6_end         FREQ 
	cfg_band6_duplex      FREQ 
	cfg_band6_step        BYTE     ! TAB (STEP_xx)
	cfg_band6_sctail      BYTE     ! seconds of lingering after LOS
	cfg_band6_sclisten    BYTE     ! seconds of stay at one location
	                      .rs 2
num_bandrecs = 6
	cfg_other_start       FREQ     ! unused, now "other" looks ...
	cfg_other_end         FREQ     ! ... like previous bandrecords
	cfg_other_duplex      FREQ     ! CFG_DPX (includes sign)
	cfg_other_step        BYTE     ! TAB (STEP_xx)
	cfg_other_sctail      BYTE     ! seconds of lingering after LOS
	cfg_other_sclisten    BYTE     ! seconds of stay at one location
	                      .rs 2

	cfg_reject_0          FREQ
	cfg_reject_1          FREQ
	cfg_reject_2          FREQ
	cfg_reject_3          FREQ
	cfg_reject_4          FREQ
	cfg_reject_5          FREQ
	cfg_reject_6          FREQ
	cfg_reject_7          FREQ
	cfg_reject_8          FREQ
	cfg_reject_9          FREQ

	cfg_act_onhook        STRING ! command strings
	cfg_act_offhook       STRING

	cfg_shortcut_0        STRING
	cfg_shortcut_1        STRING
	cfg_shortcut_2        STRING
	cfg_shortcut_3        STRING
	cfg_shortcut_4        STRING
	cfg_shortcut_5        STRING
	cfg_shortcut_6        STRING
	cfg_shortcut_7        STRING
	cfg_shortcut_8        STRING
	cfg_shortcut_9        STRING

	cfg_mycall_1          STRING
	cfg_mycall_2          STRING
	cfg_mycall_3          STRING
	cfg_ccir_1            STRING
	cfg_ccir_2            STRING
	cfg_ccir_3            STRING
	cfg_dtmf_1            STRING
	cfg_dtmf_2            STRING
	cfg_dtmf_3            STRING

	cfg_pepa_on           STRING
	cfg_pepa_off          STRING

	cfg_ccir_minlen       BYTE    ! cSEC, minimum accepted length of ccir series
	cfg_dtmf_holdtime     BYTE    ! SEC, idle before dtmf sequence complete

!== END SETUP BLOCK ===================================================

chk_size_nvdata = . - nvstart
	ASSERT(chk_size_nvdata < (4 * 1024))

	.org nvstart + 4 * 1024
nvend:						!------------------------------------------

!----------------------------------------------------------------------

output_0	BYTE
output_1	BYTE

mbusrx_rp	WORD
mbusrx_wp	WORD

mbustx_rp	WORD
mbustx_wp	WORD

synth_ctrl  BYTE    ! synth control register
rx_refdiv   WORD
tx_refdiv   WORD
rx_divisor	BUF(3)
tx_divisor	BUF(3)	! 17 bits NA

cpu_is_P8E  BYTE

!======================================================================

_bss:                    ! zeroed variables

rx_bstep_cfg	BUF(2)	! 2 and 25 for frequency/divisor math
tx_bstep_cfg	BUF(2)	! 2 and 25 for frequency/divisor math

mbustx_cnt	BYTE
mbusrx_cnt	BYTE

mbus_timer	BYTE		! timer for MBUS transmit

rssi_timer		BYTE
mt_timer		BYTE
key_timer		BYTE
key_speed		BYTE
key_blips		BYTE

alert_timer		BYTE	! Seconds between alerts
lights_timer	BYTE	! Seconds since last CU manipulation
txtail_timer	BYTE	! to delay squelch pop after tx and
						! battery check wrt voltage drop on tx
tx_tot_timer	BYTE	! Catch stuck PTT, 0...255 minutes
ign_apo_timer   BYTE    ! powerdown after IGN clear this long
ccir_tx_timer	BYTE	! for 100ms tone (10 ticks)
scan_timer		BYTE
scan_patience	BYTE	! slower timer for "patience"

scan_mute		BYTE	! NZ if scanner unstable
scanner_state	WORD
scan_oops		BYTE

last_scan       BYTE
rejects			BUF(SIZE_FREQ * 10)
reject_idx		BYTE
adj_feedback	WORD
call_dpyed      BYTE
dpx_ind_flags   BYTE

sir			BYTE
KEYSIR  = 0
DPYSIR  = 1
DTMFSIR = 2
INSIR   = 7
nosir		BYTE	! Mainline needs full attention

lastdigit	BYTE
lastkey		BYTE
key			BYTE
dark		BYTE
key_time	BYTE

pttdn		BYTE
keydown		BYTE

digidx		BYTE
digbuf		BUF(16)

ad_select	BYTE

squelch_delay   BYTE   ! dragging "timer" for squelch head/tail
squelch_open	BYTE   ! 1/0 state

mton		BYTE

tx_is_legal BYTE   ! NZ if ok to tx
txon		BYTE
rfc			BYTE
srssi		BYTE

ad_rssi		BYTE
ad_sql		BYTE
ad_batt		BYTE

sec100		BYTE		! "uptime"
seconds		BYTE
minutes		BYTE
hours		BYTE

redraw_req	BYTE

vip_idx		BYTE

outpacket	BUF(8)

piob_mode       BYTE  ! PIO B mode, ones inputs
pioa_data		BYTE
last_columns	BYTE
dtmf_code		BYTE
spkrbtn			BYTE

cu_is_known BYTE
cu_is_alfa	BYTE	! NZ if CU58AF detected
portable	BYTE	! NZ if /POR in CU-connector (EXIN1)
local_mode	BYTE	! NZ if /LOCAL grounded

ccir_prevdata    BYTE  ! unshifted raw bits from PIO PA
ccir_hist_finger BYTE  ! peeking offset
ccir_hist_idx    BYTE  ! insert point
ccir_tonetime    BYTE  ! length in centiseconds
ccir_toneptr     BYTE  ! start of current serie

dtmf_prevdata    BYTE  ! unshifted raw bits from [DTMF]
dtmf_hist_finger BYTE  ! peeking offset
dtmf_hist_idx    BYTE  ! insert point
dtmf_idletime    BYTE  ! note when no dtmf tones for some time
dtmf_toneptr     BYTE  ! pending codes

packet           BUF(8) ! buffer to collect input frame
pkt_ptr          WORD   ! in above buffer
fsk_hist_finger  BYTE   ! peeking offset
fsk_hist_idx     BYTE   ! insert point
packet_good      BYTE   ! index in history, to check "ours"
packet_rdy       BYTE

menu_active BYTE
menu_ptr    WORD

lpf_hz_now  WORD   ! catch change in setup

	.align 8 ! ------------------------

ccir_history BUF(256)    ! page aligned
dtmf_history BUF(256)    ! page aligned
fsk_history  BUF(256)    ! page aligned

mbusrx_buf	BUF(256)     ! page aligned
mbustx_buf	BUF(256)     ! page aligned

segments	BUF(64)      ! page aligned, space for either AN or AF cu.
indicators	BYTE         ! LEDs.

junk		BYTE

_end:

chk_size_stack = 0x10000 - _end
	ASSERT(chk_size_stack > (4 * 1024))

